(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('styled-components'), require('styled-system'), require('@roadmunk/ds-tokens')) :
    typeof define === 'function' && define.amd ? define(['exports', 'react', 'styled-components', 'styled-system', '@roadmunk/ds-tokens'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ds-component-library'] = {}, global.React, global.styled, global.styledSystem, global.dsTokens));
}(this, (function (exports, React, styled, styledSystem, dsTokens) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
    var styled__default = /*#__PURE__*/_interopDefaultLegacy(styled);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    }

    function _extends() {
      _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = arguments[i];

          for (var key in source) {
            if (Object.prototype.hasOwnProperty.call(source, key)) {
              target[key] = source[key];
            }
          }
        }

        return target;
      };

      return _extends.apply(this, arguments);
    }

    function _assertThisInitialized(self) {
      if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }

      return self;
    }

    function _inheritsLoose(subClass, superClass) {
      subClass.prototype = Object.create(superClass.prototype);
      subClass.prototype.constructor = subClass;
      subClass.__proto__ = superClass;
    }

    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
      };
      return _getPrototypeOf(o);
    }

    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
        o.__proto__ = p;
        return o;
      };

      return _setPrototypeOf(o, p);
    }

    function _isNativeFunction(fn) {
      return Function.toString.call(fn).indexOf("[native code]") !== -1;
    }

    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct) return false;
      if (Reflect.construct.sham) return false;
      if (typeof Proxy === "function") return true;

      try {
        Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
        return true;
      } catch (e) {
        return false;
      }
    }

    function _construct(Parent, args, Class) {
      if (_isNativeReflectConstruct()) {
        _construct = Reflect.construct;
      } else {
        _construct = function _construct(Parent, args, Class) {
          var a = [null];
          a.push.apply(a, args);
          var Constructor = Function.bind.apply(Parent, a);
          var instance = new Constructor();
          if (Class) _setPrototypeOf(instance, Class.prototype);
          return instance;
        };
      }

      return _construct.apply(null, arguments);
    }

    function _wrapNativeSuper(Class) {
      var _cache = typeof Map === "function" ? new Map() : undefined;

      _wrapNativeSuper = function _wrapNativeSuper(Class) {
        if (Class === null || !_isNativeFunction(Class)) return Class;

        if (typeof Class !== "function") {
          throw new TypeError("Super expression must either be null or a function");
        }

        if (typeof _cache !== "undefined") {
          if (_cache.has(Class)) return _cache.get(Class);

          _cache.set(Class, Wrapper);
        }

        function Wrapper() {
          return _construct(Class, arguments, _getPrototypeOf(this).constructor);
        }

        Wrapper.prototype = Object.create(Class.prototype, {
          constructor: {
            value: Wrapper,
            enumerable: false,
            writable: true,
            configurable: true
          }
        });
        return _setPrototypeOf(Wrapper, Class);
      };

      return _wrapNativeSuper(Class);
    }

    // based on https://github.com/styled-components/styled-components/blob/fcf6f3804c57a14dd7984dfab7bc06ee2edca044/src/utils/error.js

    /**
     * Parse errors.md and turn it into a simple hash of code: message
     * @private
     */
    var ERRORS = {
      "1": "Passed invalid arguments to hsl, please pass multiple numbers e.g. hsl(360, 0.75, 0.4) or an object e.g. rgb({ hue: 255, saturation: 0.4, lightness: 0.75 }).\n\n",
      "2": "Passed invalid arguments to hsla, please pass multiple numbers e.g. hsla(360, 0.75, 0.4, 0.7) or an object e.g. rgb({ hue: 255, saturation: 0.4, lightness: 0.75, alpha: 0.7 }).\n\n",
      "3": "Passed an incorrect argument to a color function, please pass a string representation of a color.\n\n",
      "4": "Couldn't generate valid rgb string from %s, it returned %s.\n\n",
      "5": "Couldn't parse the color string. Please provide the color as a string in hex, rgb, rgba, hsl or hsla notation.\n\n",
      "6": "Passed invalid arguments to rgb, please pass multiple numbers e.g. rgb(255, 205, 100) or an object e.g. rgb({ red: 255, green: 205, blue: 100 }).\n\n",
      "7": "Passed invalid arguments to rgba, please pass multiple numbers e.g. rgb(255, 205, 100, 0.75) or an object e.g. rgb({ red: 255, green: 205, blue: 100, alpha: 0.75 }).\n\n",
      "8": "Passed invalid argument to toColorString, please pass a RgbColor, RgbaColor, HslColor or HslaColor object.\n\n",
      "9": "Please provide a number of steps to the modularScale helper.\n\n",
      "10": "Please pass a number or one of the predefined scales to the modularScale helper as the ratio.\n\n",
      "11": "Invalid value passed as base to modularScale, expected number or em string but got \"%s\"\n\n",
      "12": "Expected a string ending in \"px\" or a number passed as the first argument to %s(), got \"%s\" instead.\n\n",
      "13": "Expected a string ending in \"px\" or a number passed as the second argument to %s(), got \"%s\" instead.\n\n",
      "14": "Passed invalid pixel value (\"%s\") to %s(), please pass a value like \"12px\" or 12.\n\n",
      "15": "Passed invalid base value (\"%s\") to %s(), please pass a value like \"12px\" or 12.\n\n",
      "16": "You must provide a template to this method.\n\n",
      "17": "You passed an unsupported selector state to this method.\n\n",
      "18": "minScreen and maxScreen must be provided as stringified numbers with the same units.\n\n",
      "19": "fromSize and toSize must be provided as stringified numbers with the same units.\n\n",
      "20": "expects either an array of objects or a single object with the properties prop, fromSize, and toSize.\n\n",
      "21": "expects the objects in the first argument array to have the properties `prop`, `fromSize`, and `toSize`.\n\n",
      "22": "expects the first argument object to have the properties `prop`, `fromSize`, and `toSize`.\n\n",
      "23": "fontFace expects a name of a font-family.\n\n",
      "24": "fontFace expects either the path to the font file(s) or a name of a local copy.\n\n",
      "25": "fontFace expects localFonts to be an array.\n\n",
      "26": "fontFace expects fileFormats to be an array.\n\n",
      "27": "radialGradient requries at least 2 color-stops to properly render.\n\n",
      "28": "Please supply a filename to retinaImage() as the first argument.\n\n",
      "29": "Passed invalid argument to triangle, please pass correct pointingDirection e.g. 'right'.\n\n",
      "30": "Passed an invalid value to `height` or `width`. Please provide a pixel based unit.\n\n",
      "31": "The animation shorthand only takes 8 arguments. See the specification for more information: http://mdn.io/animation\n\n",
      "32": "To pass multiple animations please supply them in arrays, e.g. animation(['rotate', '2s'], ['move', '1s'])\nTo pass a single animation please supply them in simple values, e.g. animation('rotate', '2s')\n\n",
      "33": "The animation shorthand arrays can only have 8 elements. See the specification for more information: http://mdn.io/animation\n\n",
      "34": "borderRadius expects a radius value as a string or number as the second argument.\n\n",
      "35": "borderRadius expects one of \"top\", \"bottom\", \"left\" or \"right\" as the first argument.\n\n",
      "36": "Property must be a string value.\n\n",
      "37": "Syntax Error at %s.\n\n",
      "38": "Formula contains a function that needs parentheses at %s.\n\n",
      "39": "Formula is missing closing parenthesis at %s.\n\n",
      "40": "Formula has too many closing parentheses at %s.\n\n",
      "41": "All values in a formula must have the same unit or be unitless.\n\n",
      "42": "Please provide a number of steps to the modularScale helper.\n\n",
      "43": "Please pass a number or one of the predefined scales to the modularScale helper as the ratio.\n\n",
      "44": "Invalid value passed as base to modularScale, expected number or em/rem string but got %s.\n\n",
      "45": "Passed invalid argument to hslToColorString, please pass a HslColor or HslaColor object.\n\n",
      "46": "Passed invalid argument to rgbToColorString, please pass a RgbColor or RgbaColor object.\n\n",
      "47": "minScreen and maxScreen must be provided as stringified numbers with the same units.\n\n",
      "48": "fromSize and toSize must be provided as stringified numbers with the same units.\n\n",
      "49": "Expects either an array of objects or a single object with the properties prop, fromSize, and toSize.\n\n",
      "50": "Expects the objects in the first argument array to have the properties prop, fromSize, and toSize.\n\n",
      "51": "Expects the first argument object to have the properties prop, fromSize, and toSize.\n\n",
      "52": "fontFace expects either the path to the font file(s) or a name of a local copy.\n\n",
      "53": "fontFace expects localFonts to be an array.\n\n",
      "54": "fontFace expects fileFormats to be an array.\n\n",
      "55": "fontFace expects a name of a font-family.\n\n",
      "56": "linearGradient requries at least 2 color-stops to properly render.\n\n",
      "57": "radialGradient requries at least 2 color-stops to properly render.\n\n",
      "58": "Please supply a filename to retinaImage() as the first argument.\n\n",
      "59": "Passed invalid argument to triangle, please pass correct pointingDirection e.g. 'right'.\n\n",
      "60": "Passed an invalid value to `height` or `width`. Please provide a pixel based unit.\n\n",
      "61": "Property must be a string value.\n\n",
      "62": "borderRadius expects a radius value as a string or number as the second argument.\n\n",
      "63": "borderRadius expects one of \"top\", \"bottom\", \"left\" or \"right\" as the first argument.\n\n",
      "64": "The animation shorthand only takes 8 arguments. See the specification for more information: http://mdn.io/animation.\n\n",
      "65": "To pass multiple animations please supply them in arrays, e.g. animation(['rotate', '2s'], ['move', '1s'])\\nTo pass a single animation please supply them in simple values, e.g. animation('rotate', '2s').\n\n",
      "66": "The animation shorthand arrays can only have 8 elements. See the specification for more information: http://mdn.io/animation.\n\n",
      "67": "You must provide a template to this method.\n\n",
      "68": "You passed an unsupported selector state to this method.\n\n",
      "69": "Expected a string ending in \"px\" or a number passed as the first argument to %s(), got %s instead.\n\n",
      "70": "Expected a string ending in \"px\" or a number passed as the second argument to %s(), got %s instead.\n\n",
      "71": "Passed invalid pixel value %s to %s(), please pass a value like \"12px\" or 12.\n\n",
      "72": "Passed invalid base value %s to %s(), please pass a value like \"12px\" or 12.\n\n",
      "73": "Please provide a valid CSS variable.\n\n",
      "74": "CSS variable not found.\n"
    };
    /**
     * super basic version of sprintf
     * @private
     */

    function format() {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      var a = args[0];
      var b = [];
      var c;

      for (c = 1; c < args.length; c += 1) {
        b.push(args[c]);
      }

      b.forEach(function (d) {
        a = a.replace(/%[a-z]/, d);
      });
      return a;
    }
    /**
     * Create an error file out of errors.md for development and a simple web link to the full errors
     * in production mode.
     * @private
     */


    var PolishedError = /*#__PURE__*/function (_Error) {
      _inheritsLoose(PolishedError, _Error);

      function PolishedError(code) {
        var _this;

        if (process.env.NODE_ENV === 'production') {
          _this = _Error.call(this, "An error occurred. See https://github.com/styled-components/polished/blob/main/src/internalHelpers/errors.md#" + code + " for more information.") || this;
        } else {
          for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
            args[_key2 - 1] = arguments[_key2];
          }

          _this = _Error.call(this, format.apply(void 0, [ERRORS[code]].concat(args))) || this;
        }

        return _assertThisInitialized(_this);
      }

      return PolishedError;
    }( /*#__PURE__*/_wrapNativeSuper(Error));

    var cssRegex = /^([+-]?(?:\d+|\d*\.\d+))([a-z]*|%)$/;
    /**
     * Returns a given CSS value minus its unit of measure.
     *
     * @deprecated - stripUnit's unitReturn functionality has been marked for deprecation in polished 4.0. It's functionality has been been moved to getValueAndUnit.
     *
     * @example
     * // Styles as object usage
     * const styles = {
     *   '--dimension': stripUnit('100px')
     * }
     *
     * // styled-components usage
     * const div = styled.div`
     *   --dimension: ${stripUnit('100px')};
     * `
     *
     * // CSS in JS Output
     *
     * element {
     *   '--dimension': 100
     * }
     */

    function stripUnit(value, unitReturn) {
      if (typeof value !== 'string') return unitReturn ? [value, undefined] : value;
      var matchedValue = value.match(cssRegex);

      if (unitReturn) {
        // eslint-disable-next-line no-console
        console.warn("stripUnit's unitReturn functionality has been marked for deprecation in polished 4.0. It's functionality has been been moved to getValueAndUnit.");
        if (matchedValue) return [parseFloat(value), matchedValue[2]];
        return [value, undefined];
      }

      if (matchedValue) return parseFloat(value);
      return value;
    }

    var cssRegex$1 = /^([+-]?(?:\d+|\d*\.\d+))([a-z]*|%)$/;
    /**
     * Returns a given CSS value and its unit as elements of an array.
     *
     * @example
     * // Styles as object usage
     * const styles = {
     *   '--dimension': getValueAndUnit('100px')[0],
     *   '--unit': getValueAndUnit('100px')[1],
     * }
     *
     * // styled-components usage
     * const div = styled.div`
     *   --dimension: ${getValueAndUnit('100px')[0]};
     *   --unit: ${getValueAndUnit('100px')[1]};
     * `
     *
     * // CSS in JS Output
     *
     * element {
     *   '--dimension': 100,
     *   '--unit': 'px',
     * }
     */

    function getValueAndUnit(value) {
      if (typeof value !== 'string') return [value, ''];
      var matchedValue = value.match(cssRegex$1);
      if (matchedValue) return [parseFloat(value), matchedValue[2]];
      return [value, undefined];
    }

    /**
     * CSS to normalize abnormalities across browsers (normalize.css v8.0.1 | MIT License | github.com/necolas/normalize.css)
     *
     * @example
     * // Styles as object usage
     * const styles = {
     *    ...normalize(),
     * }
     *
     * // styled-components usage
     * const GlobalStyle = createGlobalStyle`${normalize()}`
     *
     * // CSS as JS Output
     *
     * html {
     *   lineHeight: 1.15,
     *   textSizeAdjust: 100%,
     * } ...
     */
    function normalize() {
      var _ref;

      return [(_ref = {
        html: {
          lineHeight: '1.15',
          textSizeAdjust: '100%'
        },
        body: {
          margin: '0'
        },
        main: {
          display: 'block'
        },
        h1: {
          fontSize: '2em',
          margin: '0.67em 0'
        },
        hr: {
          boxSizing: 'content-box',
          height: '0',
          overflow: 'visible'
        },
        pre: {
          fontFamily: 'monospace, monospace',
          fontSize: '1em'
        },
        a: {
          backgroundColor: 'transparent'
        },
        'abbr[title]': {
          borderBottom: 'none',
          textDecoration: 'underline'
        }
      }, _ref["b,\n    strong"] = {
        fontWeight: 'bolder'
      }, _ref["code,\n    kbd,\n    samp"] = {
        fontFamily: 'monospace, monospace',
        fontSize: '1em'
      }, _ref.small = {
        fontSize: '80%'
      }, _ref["sub,\n    sup"] = {
        fontSize: '75%',
        lineHeight: '0',
        position: 'relative',
        verticalAlign: 'baseline'
      }, _ref.sub = {
        bottom: '-0.25em'
      }, _ref.sup = {
        top: '-0.5em'
      }, _ref.img = {
        borderStyle: 'none'
      }, _ref["button,\n    input,\n    optgroup,\n    select,\n    textarea"] = {
        fontFamily: 'inherit',
        fontSize: '100%',
        lineHeight: '1.15',
        margin: '0'
      }, _ref["button,\n    input"] = {
        overflow: 'visible'
      }, _ref["button,\n    select"] = {
        textTransform: 'none'
      }, _ref["button,\n    html [type=\"button\"],\n    [type=\"reset\"],\n    [type=\"submit\"]"] = {
        WebkitAppearance: 'button'
      }, _ref["button::-moz-focus-inner,\n    [type=\"button\"]::-moz-focus-inner,\n    [type=\"reset\"]::-moz-focus-inner,\n    [type=\"submit\"]::-moz-focus-inner"] = {
        borderStyle: 'none',
        padding: '0'
      }, _ref["button:-moz-focusring,\n    [type=\"button\"]:-moz-focusring,\n    [type=\"reset\"]:-moz-focusring,\n    [type=\"submit\"]:-moz-focusring"] = {
        outline: '1px dotted ButtonText'
      }, _ref.fieldset = {
        padding: '0.35em 0.625em 0.75em'
      }, _ref.legend = {
        boxSizing: 'border-box',
        color: 'inherit',
        display: 'table',
        maxWidth: '100%',
        padding: '0',
        whiteSpace: 'normal'
      }, _ref.progress = {
        verticalAlign: 'baseline'
      }, _ref.textarea = {
        overflow: 'auto'
      }, _ref["[type=\"checkbox\"],\n    [type=\"radio\"]"] = {
        boxSizing: 'border-box',
        padding: '0'
      }, _ref["[type=\"number\"]::-webkit-inner-spin-button,\n    [type=\"number\"]::-webkit-outer-spin-button"] = {
        height: 'auto'
      }, _ref['[type="search"]'] = {
        WebkitAppearance: 'textfield',
        outlineOffset: '-2px'
      }, _ref['[type="search"]::-webkit-search-decoration'] = {
        WebkitAppearance: 'none'
      }, _ref['::-webkit-file-upload-button'] = {
        WebkitAppearance: 'button',
        font: 'inherit'
      }, _ref.details = {
        display: 'block'
      }, _ref.summary = {
        display: 'list-item'
      }, _ref.template = {
        display: 'none'
      }, _ref['[hidden]'] = {
        display: 'none'
      }, _ref), {
        'abbr[title]': {
          textDecoration: 'underline dotted'
        }
      }];
    }

    function colorToInt(color) {
      return Math.round(color * 255);
    }

    function convertToInt(red, green, blue) {
      return colorToInt(red) + "," + colorToInt(green) + "," + colorToInt(blue);
    }

    function hslToRgb(hue, saturation, lightness, convert) {
      if (convert === void 0) {
        convert = convertToInt;
      }

      if (saturation === 0) {
        // achromatic
        return convert(lightness, lightness, lightness);
      } // formulae from https://en.wikipedia.org/wiki/HSL_and_HSV


      var huePrime = (hue % 360 + 360) % 360 / 60;
      var chroma = (1 - Math.abs(2 * lightness - 1)) * saturation;
      var secondComponent = chroma * (1 - Math.abs(huePrime % 2 - 1));
      var red = 0;
      var green = 0;
      var blue = 0;

      if (huePrime >= 0 && huePrime < 1) {
        red = chroma;
        green = secondComponent;
      } else if (huePrime >= 1 && huePrime < 2) {
        red = secondComponent;
        green = chroma;
      } else if (huePrime >= 2 && huePrime < 3) {
        green = chroma;
        blue = secondComponent;
      } else if (huePrime >= 3 && huePrime < 4) {
        green = secondComponent;
        blue = chroma;
      } else if (huePrime >= 4 && huePrime < 5) {
        red = secondComponent;
        blue = chroma;
      } else if (huePrime >= 5 && huePrime < 6) {
        red = chroma;
        blue = secondComponent;
      }

      var lightnessModification = lightness - chroma / 2;
      var finalRed = red + lightnessModification;
      var finalGreen = green + lightnessModification;
      var finalBlue = blue + lightnessModification;
      return convert(finalRed, finalGreen, finalBlue);
    }

    var namedColorMap = {
      aliceblue: 'f0f8ff',
      antiquewhite: 'faebd7',
      aqua: '00ffff',
      aquamarine: '7fffd4',
      azure: 'f0ffff',
      beige: 'f5f5dc',
      bisque: 'ffe4c4',
      black: '000',
      blanchedalmond: 'ffebcd',
      blue: '0000ff',
      blueviolet: '8a2be2',
      brown: 'a52a2a',
      burlywood: 'deb887',
      cadetblue: '5f9ea0',
      chartreuse: '7fff00',
      chocolate: 'd2691e',
      coral: 'ff7f50',
      cornflowerblue: '6495ed',
      cornsilk: 'fff8dc',
      crimson: 'dc143c',
      cyan: '00ffff',
      darkblue: '00008b',
      darkcyan: '008b8b',
      darkgoldenrod: 'b8860b',
      darkgray: 'a9a9a9',
      darkgreen: '006400',
      darkgrey: 'a9a9a9',
      darkkhaki: 'bdb76b',
      darkmagenta: '8b008b',
      darkolivegreen: '556b2f',
      darkorange: 'ff8c00',
      darkorchid: '9932cc',
      darkred: '8b0000',
      darksalmon: 'e9967a',
      darkseagreen: '8fbc8f',
      darkslateblue: '483d8b',
      darkslategray: '2f4f4f',
      darkslategrey: '2f4f4f',
      darkturquoise: '00ced1',
      darkviolet: '9400d3',
      deeppink: 'ff1493',
      deepskyblue: '00bfff',
      dimgray: '696969',
      dimgrey: '696969',
      dodgerblue: '1e90ff',
      firebrick: 'b22222',
      floralwhite: 'fffaf0',
      forestgreen: '228b22',
      fuchsia: 'ff00ff',
      gainsboro: 'dcdcdc',
      ghostwhite: 'f8f8ff',
      gold: 'ffd700',
      goldenrod: 'daa520',
      gray: '808080',
      green: '008000',
      greenyellow: 'adff2f',
      grey: '808080',
      honeydew: 'f0fff0',
      hotpink: 'ff69b4',
      indianred: 'cd5c5c',
      indigo: '4b0082',
      ivory: 'fffff0',
      khaki: 'f0e68c',
      lavender: 'e6e6fa',
      lavenderblush: 'fff0f5',
      lawngreen: '7cfc00',
      lemonchiffon: 'fffacd',
      lightblue: 'add8e6',
      lightcoral: 'f08080',
      lightcyan: 'e0ffff',
      lightgoldenrodyellow: 'fafad2',
      lightgray: 'd3d3d3',
      lightgreen: '90ee90',
      lightgrey: 'd3d3d3',
      lightpink: 'ffb6c1',
      lightsalmon: 'ffa07a',
      lightseagreen: '20b2aa',
      lightskyblue: '87cefa',
      lightslategray: '789',
      lightslategrey: '789',
      lightsteelblue: 'b0c4de',
      lightyellow: 'ffffe0',
      lime: '0f0',
      limegreen: '32cd32',
      linen: 'faf0e6',
      magenta: 'f0f',
      maroon: '800000',
      mediumaquamarine: '66cdaa',
      mediumblue: '0000cd',
      mediumorchid: 'ba55d3',
      mediumpurple: '9370db',
      mediumseagreen: '3cb371',
      mediumslateblue: '7b68ee',
      mediumspringgreen: '00fa9a',
      mediumturquoise: '48d1cc',
      mediumvioletred: 'c71585',
      midnightblue: '191970',
      mintcream: 'f5fffa',
      mistyrose: 'ffe4e1',
      moccasin: 'ffe4b5',
      navajowhite: 'ffdead',
      navy: '000080',
      oldlace: 'fdf5e6',
      olive: '808000',
      olivedrab: '6b8e23',
      orange: 'ffa500',
      orangered: 'ff4500',
      orchid: 'da70d6',
      palegoldenrod: 'eee8aa',
      palegreen: '98fb98',
      paleturquoise: 'afeeee',
      palevioletred: 'db7093',
      papayawhip: 'ffefd5',
      peachpuff: 'ffdab9',
      peru: 'cd853f',
      pink: 'ffc0cb',
      plum: 'dda0dd',
      powderblue: 'b0e0e6',
      purple: '800080',
      rebeccapurple: '639',
      red: 'f00',
      rosybrown: 'bc8f8f',
      royalblue: '4169e1',
      saddlebrown: '8b4513',
      salmon: 'fa8072',
      sandybrown: 'f4a460',
      seagreen: '2e8b57',
      seashell: 'fff5ee',
      sienna: 'a0522d',
      silver: 'c0c0c0',
      skyblue: '87ceeb',
      slateblue: '6a5acd',
      slategray: '708090',
      slategrey: '708090',
      snow: 'fffafa',
      springgreen: '00ff7f',
      steelblue: '4682b4',
      tan: 'd2b48c',
      teal: '008080',
      thistle: 'd8bfd8',
      tomato: 'ff6347',
      turquoise: '40e0d0',
      violet: 'ee82ee',
      wheat: 'f5deb3',
      white: 'fff',
      whitesmoke: 'f5f5f5',
      yellow: 'ff0',
      yellowgreen: '9acd32'
    };
    /**
     * Checks if a string is a CSS named color and returns its equivalent hex value, otherwise returns the original color.
     * @private
     */

    function nameToHex(color) {
      if (typeof color !== 'string') return color;
      var normalizedColorName = color.toLowerCase();
      return namedColorMap[normalizedColorName] ? "#" + namedColorMap[normalizedColorName] : color;
    }

    var hexRegex = /^#[a-fA-F0-9]{6}$/;
    var hexRgbaRegex = /^#[a-fA-F0-9]{8}$/;
    var reducedHexRegex = /^#[a-fA-F0-9]{3}$/;
    var reducedRgbaHexRegex = /^#[a-fA-F0-9]{4}$/;
    var rgbRegex = /^rgb\(\s*(\d{1,3})\s*,\s*(\d{1,3})\s*,\s*(\d{1,3})\s*\)$/i;
    var rgbaRegex = /^rgba\(\s*(\d{1,3})\s*,\s*(\d{1,3})\s*,\s*(\d{1,3})\s*,\s*([-+]?[0-9]*[.]?[0-9]+)\s*\)$/i;
    var hslRegex = /^hsl\(\s*(\d{0,3}[.]?[0-9]+)\s*,\s*(\d{1,3}[.]?[0-9]?)%\s*,\s*(\d{1,3}[.]?[0-9]?)%\s*\)$/i;
    var hslaRegex = /^hsla\(\s*(\d{0,3}[.]?[0-9]+)\s*,\s*(\d{1,3}[.]?[0-9]?)%\s*,\s*(\d{1,3}[.]?[0-9]?)%\s*,\s*([-+]?[0-9]*[.]?[0-9]+)\s*\)$/i;
    /**
     * Returns an RgbColor or RgbaColor object. This utility function is only useful
     * if want to extract a color component. With the color util `toColorString` you
     * can convert a RgbColor or RgbaColor object back to a string.
     *
     * @example
     * // Assigns `{ red: 255, green: 0, blue: 0 }` to color1
     * const color1 = parseToRgb('rgb(255, 0, 0)');
     * // Assigns `{ red: 92, green: 102, blue: 112, alpha: 0.75 }` to color2
     * const color2 = parseToRgb('hsla(210, 10%, 40%, 0.75)');
     */

    function parseToRgb(color) {
      if (typeof color !== 'string') {
        throw new PolishedError(3);
      }

      var normalizedColor = nameToHex(color);

      if (normalizedColor.match(hexRegex)) {
        return {
          red: parseInt("" + normalizedColor[1] + normalizedColor[2], 16),
          green: parseInt("" + normalizedColor[3] + normalizedColor[4], 16),
          blue: parseInt("" + normalizedColor[5] + normalizedColor[6], 16)
        };
      }

      if (normalizedColor.match(hexRgbaRegex)) {
        var alpha = parseFloat((parseInt("" + normalizedColor[7] + normalizedColor[8], 16) / 255).toFixed(2));
        return {
          red: parseInt("" + normalizedColor[1] + normalizedColor[2], 16),
          green: parseInt("" + normalizedColor[3] + normalizedColor[4], 16),
          blue: parseInt("" + normalizedColor[5] + normalizedColor[6], 16),
          alpha: alpha
        };
      }

      if (normalizedColor.match(reducedHexRegex)) {
        return {
          red: parseInt("" + normalizedColor[1] + normalizedColor[1], 16),
          green: parseInt("" + normalizedColor[2] + normalizedColor[2], 16),
          blue: parseInt("" + normalizedColor[3] + normalizedColor[3], 16)
        };
      }

      if (normalizedColor.match(reducedRgbaHexRegex)) {
        var _alpha = parseFloat((parseInt("" + normalizedColor[4] + normalizedColor[4], 16) / 255).toFixed(2));

        return {
          red: parseInt("" + normalizedColor[1] + normalizedColor[1], 16),
          green: parseInt("" + normalizedColor[2] + normalizedColor[2], 16),
          blue: parseInt("" + normalizedColor[3] + normalizedColor[3], 16),
          alpha: _alpha
        };
      }

      var rgbMatched = rgbRegex.exec(normalizedColor);

      if (rgbMatched) {
        return {
          red: parseInt("" + rgbMatched[1], 10),
          green: parseInt("" + rgbMatched[2], 10),
          blue: parseInt("" + rgbMatched[3], 10)
        };
      }

      var rgbaMatched = rgbaRegex.exec(normalizedColor);

      if (rgbaMatched) {
        return {
          red: parseInt("" + rgbaMatched[1], 10),
          green: parseInt("" + rgbaMatched[2], 10),
          blue: parseInt("" + rgbaMatched[3], 10),
          alpha: parseFloat("" + rgbaMatched[4])
        };
      }

      var hslMatched = hslRegex.exec(normalizedColor);

      if (hslMatched) {
        var hue = parseInt("" + hslMatched[1], 10);
        var saturation = parseInt("" + hslMatched[2], 10) / 100;
        var lightness = parseInt("" + hslMatched[3], 10) / 100;
        var rgbColorString = "rgb(" + hslToRgb(hue, saturation, lightness) + ")";
        var hslRgbMatched = rgbRegex.exec(rgbColorString);

        if (!hslRgbMatched) {
          throw new PolishedError(4, normalizedColor, rgbColorString);
        }

        return {
          red: parseInt("" + hslRgbMatched[1], 10),
          green: parseInt("" + hslRgbMatched[2], 10),
          blue: parseInt("" + hslRgbMatched[3], 10)
        };
      }

      var hslaMatched = hslaRegex.exec(normalizedColor);

      if (hslaMatched) {
        var _hue = parseInt("" + hslaMatched[1], 10);

        var _saturation = parseInt("" + hslaMatched[2], 10) / 100;

        var _lightness = parseInt("" + hslaMatched[3], 10) / 100;

        var _rgbColorString = "rgb(" + hslToRgb(_hue, _saturation, _lightness) + ")";

        var _hslRgbMatched = rgbRegex.exec(_rgbColorString);

        if (!_hslRgbMatched) {
          throw new PolishedError(4, normalizedColor, _rgbColorString);
        }

        return {
          red: parseInt("" + _hslRgbMatched[1], 10),
          green: parseInt("" + _hslRgbMatched[2], 10),
          blue: parseInt("" + _hslRgbMatched[3], 10),
          alpha: parseFloat("" + hslaMatched[4])
        };
      }

      throw new PolishedError(5);
    }

    /**
     * Reduces hex values if possible e.g. #ff8866 to #f86
     * @private
     */
    var reduceHexValue = function reduceHexValue(value) {
      if (value.length === 7 && value[1] === value[2] && value[3] === value[4] && value[5] === value[6]) {
        return "#" + value[1] + value[3] + value[5];
      }

      return value;
    };

    function numberToHex(value) {
      var hex = value.toString(16);
      return hex.length === 1 ? "0" + hex : hex;
    }

    /**
     * Returns a string value for the color. The returned result is the smallest possible hex notation.
     *
     * @example
     * // Styles as object usage
     * const styles = {
     *   background: rgb(255, 205, 100),
     *   background: rgb({ red: 255, green: 205, blue: 100 }),
     * }
     *
     * // styled-components usage
     * const div = styled.div`
     *   background: ${rgb(255, 205, 100)};
     *   background: ${rgb({ red: 255, green: 205, blue: 100 })};
     * `
     *
     * // CSS in JS Output
     *
     * element {
     *   background: "#ffcd64";
     *   background: "#ffcd64";
     * }
     */
    function rgb(value, green, blue) {
      if (typeof value === 'number' && typeof green === 'number' && typeof blue === 'number') {
        return reduceHexValue("#" + numberToHex(value) + numberToHex(green) + numberToHex(blue));
      } else if (typeof value === 'object' && green === undefined && blue === undefined) {
        return reduceHexValue("#" + numberToHex(value.red) + numberToHex(value.green) + numberToHex(value.blue));
      }

      throw new PolishedError(6);
    }

    /**
     * Returns a string value for the color. The returned result is the smallest possible rgba or hex notation.
     *
     * Can also be used to fade a color by passing a hex value or named CSS color along with an alpha value.
     *
     * @example
     * // Styles as object usage
     * const styles = {
     *   background: rgba(255, 205, 100, 0.7),
     *   background: rgba({ red: 255, green: 205, blue: 100, alpha: 0.7 }),
     *   background: rgba(255, 205, 100, 1),
     *   background: rgba('#ffffff', 0.4),
     *   background: rgba('black', 0.7),
     * }
     *
     * // styled-components usage
     * const div = styled.div`
     *   background: ${rgba(255, 205, 100, 0.7)};
     *   background: ${rgba({ red: 255, green: 205, blue: 100, alpha: 0.7 })};
     *   background: ${rgba(255, 205, 100, 1)};
     *   background: ${rgba('#ffffff', 0.4)};
     *   background: ${rgba('black', 0.7)};
     * `
     *
     * // CSS in JS Output
     *
     * element {
     *   background: "rgba(255,205,100,0.7)";
     *   background: "rgba(255,205,100,0.7)";
     *   background: "#ffcd64";
     *   background: "rgba(255,255,255,0.4)";
     *   background: "rgba(0,0,0,0.7)";
     * }
     */
    function rgba(firstValue, secondValue, thirdValue, fourthValue) {
      if (typeof firstValue === 'string' && typeof secondValue === 'number') {
        var rgbValue = parseToRgb(firstValue);
        return "rgba(" + rgbValue.red + "," + rgbValue.green + "," + rgbValue.blue + "," + secondValue + ")";
      } else if (typeof firstValue === 'number' && typeof secondValue === 'number' && typeof thirdValue === 'number' && typeof fourthValue === 'number') {
        return fourthValue >= 1 ? rgb(firstValue, secondValue, thirdValue) : "rgba(" + firstValue + "," + secondValue + "," + thirdValue + "," + fourthValue + ")";
      } else if (typeof firstValue === 'object' && secondValue === undefined && thirdValue === undefined && fourthValue === undefined) {
        return firstValue.alpha >= 1 ? rgb(firstValue.red, firstValue.green, firstValue.blue) : "rgba(" + firstValue.red + "," + firstValue.green + "," + firstValue.blue + "," + firstValue.alpha + ")";
      }

      throw new PolishedError(7);
    }

    // Type definitions taken from https://github.com/gcanti/flow-static-land/blob/master/src/Fun.js
    // eslint-disable-next-line no-unused-vars
    // eslint-disable-next-line no-unused-vars
    // eslint-disable-next-line no-redeclare
    function curried(f, length, acc) {
      return function fn() {
        // eslint-disable-next-line prefer-rest-params
        var combined = acc.concat(Array.prototype.slice.call(arguments));
        return combined.length >= length ? f.apply(this, combined) : curried(f, length, combined);
      };
    } // eslint-disable-next-line no-redeclare


    function curry(f) {
      // eslint-disable-line no-redeclare
      return curried(f, f.length, []);
    }

    function guard(lowerBoundary, upperBoundary, value) {
      return Math.max(lowerBoundary, Math.min(upperBoundary, value));
    }

    /**
     * Decreases the opacity of a color. Its range for the amount is between 0 to 1.
     *
     *
     * @example
     * // Styles as object usage
     * const styles = {
     *   background: transparentize(0.1, '#fff');
     *   background: transparentize(0.2, 'hsl(0, 0%, 100%)'),
     *   background: transparentize('0.5', 'rgba(255, 0, 0, 0.8)'),
     * }
     *
     * // styled-components usage
     * const div = styled.div`
     *   background: ${transparentize(0.1, '#fff')};
     *   background: ${transparentize(0.2, 'hsl(0, 0%, 100%)')},
     *   background: ${transparentize('0.5', 'rgba(255, 0, 0, 0.8)')},
     * `
     *
     * // CSS in JS Output
     *
     * element {
     *   background: "rgba(255,255,255,0.9)";
     *   background: "rgba(255,255,255,0.8)";
     *   background: "rgba(255,0,0,0.3)";
     * }
     */

    function transparentize(amount, color) {
      if (color === 'transparent') return color;
      var parsedColor = parseToRgb(color);
      var alpha = typeof parsedColor.alpha === 'number' ? parsedColor.alpha : 1;

      var colorWithAlpha = _extends({}, parsedColor, {
        alpha: guard(0, 1, (alpha * 100 - parseFloat(amount) * 100) / 100)
      });

      return rgba(colorWithAlpha);
    } // prettier-ignore


    var curriedTransparentize = /*#__PURE__*/curry
    /* ::<number | string, string, string> */
    (transparentize);

    var additionalGlobalStyles = styled.css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  *,\n  :after,\n  :before {\n    box-sizing: border-box;\n    -webkit-font-smoothing: antialiased;\n    -moz-osx-font-smoothing: grayscale;\n  }\n"], ["\n  *,\n  :after,\n  :before {\n    box-sizing: border-box;\n    -webkit-font-smoothing: antialiased;\n    -moz-osx-font-smoothing: grayscale;\n  }\n"])));
    var GlobalStyle = styled.createGlobalStyle(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  ", "\n  ", "\n"], ["\n  ", "\n  ", "\n"])), normalize(), additionalGlobalStyles);

    var GlobalFontImport = function GlobalFontImport() {
      return "\n  @import\n  url(https://fonts.googleapis.com/css?family=Source+Sans+Pro:400,600|Work+Sans:400,500,600,700);\n";
    };
    var templateObject_1, templateObject_2;

    var AppProvider = function AppProvider(_a) {
      var _b = _a.theme,
          theme = _b === void 0 ? {} : _b,
          children = _a.children;
      return /*#__PURE__*/React__default['default'].createElement(styled.ThemeProvider, {
        theme: theme
      }, /*#__PURE__*/React__default['default'].createElement(GlobalStyle, null), /*#__PURE__*/React__default['default'].createElement("style", null, /*#__PURE__*/React__default['default'].createElement(GlobalFontImport, null)), children);
    };

    /**
     * A function that always returns `true`. Any passed in parameters are ignored.
     *
     * @func
     * @memberOf R
     * @since v0.9.0
     * @category Function
     * @sig * -> Boolean
     * @param {*}
     * @return {Boolean}
     * @see R.F
     * @example
     *
     *      R.T(); //=> true
     */
    var T = function () {
      return true;
    };

    function _isPlaceholder(a) {
      return a != null && typeof a === 'object' && a['@@functional/placeholder'] === true;
    }

    /**
     * Optimized internal one-arity curry function.
     *
     * @private
     * @category Function
     * @param {Function} fn The function to curry.
     * @return {Function} The curried function.
     */

    function _curry1(fn) {
      return function f1(a) {
        if (arguments.length === 0 || _isPlaceholder(a)) {
          return f1;
        } else {
          return fn.apply(this, arguments);
        }
      };
    }

    /**
     * Optimized internal two-arity curry function.
     *
     * @private
     * @category Function
     * @param {Function} fn The function to curry.
     * @return {Function} The curried function.
     */

    function _curry2(fn) {
      return function f2(a, b) {
        switch (arguments.length) {
          case 0:
            return f2;

          case 1:
            return _isPlaceholder(a) ? f2 : _curry1(function (_b) {
              return fn(a, _b);
            });

          default:
            return _isPlaceholder(a) && _isPlaceholder(b) ? f2 : _isPlaceholder(a) ? _curry1(function (_a) {
              return fn(_a, b);
            }) : _isPlaceholder(b) ? _curry1(function (_b) {
              return fn(a, _b);
            }) : fn(a, b);
        }
      };
    }

    /**
     * Adds two values.
     *
     * @func
     * @memberOf R
     * @since v0.1.0
     * @category Math
     * @sig Number -> Number -> Number
     * @param {Number} a
     * @param {Number} b
     * @return {Number}
     * @see R.subtract
     * @example
     *
     *      R.add(2, 3);       //=>  5
     *      R.add(7)(10);      //=> 17
     */

    var add =
    /*#__PURE__*/
    _curry2(function add(a, b) {
      return Number(a) + Number(b);
    });

    /**
     * Private `concat` function to merge two array-like objects.
     *
     * @private
     * @param {Array|Arguments} [set1=[]] An array-like object.
     * @param {Array|Arguments} [set2=[]] An array-like object.
     * @return {Array} A new, merged array.
     * @example
     *
     *      _concat([4, 5, 6], [1, 2, 3]); //=> [4, 5, 6, 1, 2, 3]
     */
    function _concat(set1, set2) {
      set1 = set1 || [];
      set2 = set2 || [];
      var idx;
      var len1 = set1.length;
      var len2 = set2.length;
      var result = [];
      idx = 0;

      while (idx < len1) {
        result[result.length] = set1[idx];
        idx += 1;
      }

      idx = 0;

      while (idx < len2) {
        result[result.length] = set2[idx];
        idx += 1;
      }

      return result;
    }

    function _arity(n, fn) {
      /* eslint-disable no-unused-vars */
      switch (n) {
        case 0:
          return function () {
            return fn.apply(this, arguments);
          };

        case 1:
          return function (a0) {
            return fn.apply(this, arguments);
          };

        case 2:
          return function (a0, a1) {
            return fn.apply(this, arguments);
          };

        case 3:
          return function (a0, a1, a2) {
            return fn.apply(this, arguments);
          };

        case 4:
          return function (a0, a1, a2, a3) {
            return fn.apply(this, arguments);
          };

        case 5:
          return function (a0, a1, a2, a3, a4) {
            return fn.apply(this, arguments);
          };

        case 6:
          return function (a0, a1, a2, a3, a4, a5) {
            return fn.apply(this, arguments);
          };

        case 7:
          return function (a0, a1, a2, a3, a4, a5, a6) {
            return fn.apply(this, arguments);
          };

        case 8:
          return function (a0, a1, a2, a3, a4, a5, a6, a7) {
            return fn.apply(this, arguments);
          };

        case 9:
          return function (a0, a1, a2, a3, a4, a5, a6, a7, a8) {
            return fn.apply(this, arguments);
          };

        case 10:
          return function (a0, a1, a2, a3, a4, a5, a6, a7, a8, a9) {
            return fn.apply(this, arguments);
          };

        default:
          throw new Error('First argument to _arity must be a non-negative integer no greater than ten');
      }
    }

    /**
     * Internal curryN function.
     *
     * @private
     * @category Function
     * @param {Number} length The arity of the curried function.
     * @param {Array} received An array of arguments received thus far.
     * @param {Function} fn The function to curry.
     * @return {Function} The curried function.
     */

    function _curryN(length, received, fn) {
      return function () {
        var combined = [];
        var argsIdx = 0;
        var left = length;
        var combinedIdx = 0;

        while (combinedIdx < received.length || argsIdx < arguments.length) {
          var result;

          if (combinedIdx < received.length && (!_isPlaceholder(received[combinedIdx]) || argsIdx >= arguments.length)) {
            result = received[combinedIdx];
          } else {
            result = arguments[argsIdx];
            argsIdx += 1;
          }

          combined[combinedIdx] = result;

          if (!_isPlaceholder(result)) {
            left -= 1;
          }

          combinedIdx += 1;
        }

        return left <= 0 ? fn.apply(this, combined) : _arity(left, _curryN(length, combined, fn));
      };
    }

    /**
     * Returns a curried equivalent of the provided function, with the specified
     * arity. The curried function has two unusual capabilities. First, its
     * arguments needn't be provided one at a time. If `g` is `R.curryN(3, f)`, the
     * following are equivalent:
     *
     *   - `g(1)(2)(3)`
     *   - `g(1)(2, 3)`
     *   - `g(1, 2)(3)`
     *   - `g(1, 2, 3)`
     *
     * Secondly, the special placeholder value [`R.__`](#__) may be used to specify
     * "gaps", allowing partial application of any combination of arguments,
     * regardless of their positions. If `g` is as above and `_` is [`R.__`](#__),
     * the following are equivalent:
     *
     *   - `g(1, 2, 3)`
     *   - `g(_, 2, 3)(1)`
     *   - `g(_, _, 3)(1)(2)`
     *   - `g(_, _, 3)(1, 2)`
     *   - `g(_, 2)(1)(3)`
     *   - `g(_, 2)(1, 3)`
     *   - `g(_, 2)(_, 3)(1)`
     *
     * @func
     * @memberOf R
     * @since v0.5.0
     * @category Function
     * @sig Number -> (* -> a) -> (* -> a)
     * @param {Number} length The arity for the returned function.
     * @param {Function} fn The function to curry.
     * @return {Function} A new, curried function.
     * @see R.curry
     * @example
     *
     *      const sumArgs = (...args) => R.sum(args);
     *
     *      const curriedAddFourNumbers = R.curryN(4, sumArgs);
     *      const f = curriedAddFourNumbers(1, 2);
     *      const g = f(3);
     *      g(4); //=> 10
     */

    var curryN =
    /*#__PURE__*/
    _curry2(function curryN(length, fn) {
      if (length === 1) {
        return _curry1(fn);
      }

      return _arity(length, _curryN(length, [], fn));
    });

    /**
     * Optimized internal three-arity curry function.
     *
     * @private
     * @category Function
     * @param {Function} fn The function to curry.
     * @return {Function} The curried function.
     */

    function _curry3(fn) {
      return function f3(a, b, c) {
        switch (arguments.length) {
          case 0:
            return f3;

          case 1:
            return _isPlaceholder(a) ? f3 : _curry2(function (_b, _c) {
              return fn(a, _b, _c);
            });

          case 2:
            return _isPlaceholder(a) && _isPlaceholder(b) ? f3 : _isPlaceholder(a) ? _curry2(function (_a, _c) {
              return fn(_a, b, _c);
            }) : _isPlaceholder(b) ? _curry2(function (_b, _c) {
              return fn(a, _b, _c);
            }) : _curry1(function (_c) {
              return fn(a, b, _c);
            });

          default:
            return _isPlaceholder(a) && _isPlaceholder(b) && _isPlaceholder(c) ? f3 : _isPlaceholder(a) && _isPlaceholder(b) ? _curry2(function (_a, _b) {
              return fn(_a, _b, c);
            }) : _isPlaceholder(a) && _isPlaceholder(c) ? _curry2(function (_a, _c) {
              return fn(_a, b, _c);
            }) : _isPlaceholder(b) && _isPlaceholder(c) ? _curry2(function (_b, _c) {
              return fn(a, _b, _c);
            }) : _isPlaceholder(a) ? _curry1(function (_a) {
              return fn(_a, b, c);
            }) : _isPlaceholder(b) ? _curry1(function (_b) {
              return fn(a, _b, c);
            }) : _isPlaceholder(c) ? _curry1(function (_c) {
              return fn(a, b, _c);
            }) : fn(a, b, c);
        }
      };
    }

    /**
     * Tests whether or not an object is an array.
     *
     * @private
     * @param {*} val The object to test.
     * @return {Boolean} `true` if `val` is an array, `false` otherwise.
     * @example
     *
     *      _isArray([]); //=> true
     *      _isArray(null); //=> false
     *      _isArray({}); //=> false
     */
    var _isArray = Array.isArray || function _isArray(val) {
      return val != null && val.length >= 0 && Object.prototype.toString.call(val) === '[object Array]';
    };

    function _isTransformer(obj) {
      return obj != null && typeof obj['@@transducer/step'] === 'function';
    }

    /**
     * Returns a function that dispatches with different strategies based on the
     * object in list position (last argument). If it is an array, executes [fn].
     * Otherwise, if it has a function with one of the given method names, it will
     * execute that function (functor case). Otherwise, if it is a transformer,
     * uses transducer [xf] to return a new transformer (transducer case).
     * Otherwise, it will default to executing [fn].
     *
     * @private
     * @param {Array} methodNames properties to check for a custom implementation
     * @param {Function} xf transducer to initialize if object is transformer
     * @param {Function} fn default ramda implementation
     * @return {Function} A function that dispatches on object in list position
     */

    function _dispatchable(methodNames, xf, fn) {
      return function () {
        if (arguments.length === 0) {
          return fn();
        }

        var args = Array.prototype.slice.call(arguments, 0);
        var obj = args.pop();

        if (!_isArray(obj)) {
          var idx = 0;

          while (idx < methodNames.length) {
            if (typeof obj[methodNames[idx]] === 'function') {
              return obj[methodNames[idx]].apply(obj, args);
            }

            idx += 1;
          }

          if (_isTransformer(obj)) {
            var transducer = xf.apply(null, args);
            return transducer(obj);
          }
        }

        return fn.apply(this, arguments);
      };
    }

    var _xfBase = {
      init: function () {
        return this.xf['@@transducer/init']();
      },
      result: function (result) {
        return this.xf['@@transducer/result'](result);
      }
    };

    /**
     * Returns the larger of its two arguments.
     *
     * @func
     * @memberOf R
     * @since v0.1.0
     * @category Relation
     * @sig Ord a => a -> a -> a
     * @param {*} a
     * @param {*} b
     * @return {*}
     * @see R.maxBy, R.min
     * @example
     *
     *      R.max(789, 123); //=> 789
     *      R.max('a', 'b'); //=> 'b'
     */

    var max =
    /*#__PURE__*/
    _curry2(function max(a, b) {
      return b > a ? b : a;
    });

    function _map(fn, functor) {
      var idx = 0;
      var len = functor.length;
      var result = Array(len);

      while (idx < len) {
        result[idx] = fn(functor[idx]);
        idx += 1;
      }

      return result;
    }

    function _isString(x) {
      return Object.prototype.toString.call(x) === '[object String]';
    }

    /**
     * Tests whether or not an object is similar to an array.
     *
     * @private
     * @category Type
     * @category List
     * @sig * -> Boolean
     * @param {*} x The object to test.
     * @return {Boolean} `true` if `x` has a numeric length property and extreme indices defined; `false` otherwise.
     * @example
     *
     *      _isArrayLike([]); //=> true
     *      _isArrayLike(true); //=> false
     *      _isArrayLike({}); //=> false
     *      _isArrayLike({length: 10}); //=> false
     *      _isArrayLike({0: 'zero', 9: 'nine', length: 10}); //=> true
     */

    var _isArrayLike =
    /*#__PURE__*/
    _curry1(function isArrayLike(x) {
      if (_isArray(x)) {
        return true;
      }

      if (!x) {
        return false;
      }

      if (typeof x !== 'object') {
        return false;
      }

      if (_isString(x)) {
        return false;
      }

      if (x.nodeType === 1) {
        return !!x.length;
      }

      if (x.length === 0) {
        return true;
      }

      if (x.length > 0) {
        return x.hasOwnProperty(0) && x.hasOwnProperty(x.length - 1);
      }

      return false;
    });

    var XWrap =
    /*#__PURE__*/
    function () {
      function XWrap(fn) {
        this.f = fn;
      }

      XWrap.prototype['@@transducer/init'] = function () {
        throw new Error('init not implemented on XWrap');
      };

      XWrap.prototype['@@transducer/result'] = function (acc) {
        return acc;
      };

      XWrap.prototype['@@transducer/step'] = function (acc, x) {
        return this.f(acc, x);
      };

      return XWrap;
    }();

    function _xwrap(fn) {
      return new XWrap(fn);
    }

    /**
     * Creates a function that is bound to a context.
     * Note: `R.bind` does not provide the additional argument-binding capabilities of
     * [Function.prototype.bind](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function/bind).
     *
     * @func
     * @memberOf R
     * @since v0.6.0
     * @category Function
     * @category Object
     * @sig (* -> *) -> {*} -> (* -> *)
     * @param {Function} fn The function to bind to context
     * @param {Object} thisObj The context to bind `fn` to
     * @return {Function} A function that will execute in the context of `thisObj`.
     * @see R.partial
     * @example
     *
     *      const log = R.bind(console.log, console);
     *      R.pipe(R.assoc('a', 2), R.tap(log), R.assoc('a', 3))({a: 1}); //=> {a: 3}
     *      // logs {a: 2}
     * @symb R.bind(f, o)(a, b) = f.call(o, a, b)
     */

    var bind =
    /*#__PURE__*/
    _curry2(function bind(fn, thisObj) {
      return _arity(fn.length, function () {
        return fn.apply(thisObj, arguments);
      });
    });

    function _arrayReduce(xf, acc, list) {
      var idx = 0;
      var len = list.length;

      while (idx < len) {
        acc = xf['@@transducer/step'](acc, list[idx]);

        if (acc && acc['@@transducer/reduced']) {
          acc = acc['@@transducer/value'];
          break;
        }

        idx += 1;
      }

      return xf['@@transducer/result'](acc);
    }

    function _iterableReduce(xf, acc, iter) {
      var step = iter.next();

      while (!step.done) {
        acc = xf['@@transducer/step'](acc, step.value);

        if (acc && acc['@@transducer/reduced']) {
          acc = acc['@@transducer/value'];
          break;
        }

        step = iter.next();
      }

      return xf['@@transducer/result'](acc);
    }

    function _methodReduce(xf, acc, obj, methodName) {
      return xf['@@transducer/result'](obj[methodName](bind(xf['@@transducer/step'], xf), acc));
    }

    var symIterator = typeof Symbol !== 'undefined' ? Symbol.iterator : '@@iterator';
    function _reduce(fn, acc, list) {
      if (typeof fn === 'function') {
        fn = _xwrap(fn);
      }

      if (_isArrayLike(list)) {
        return _arrayReduce(fn, acc, list);
      }

      if (typeof list['fantasy-land/reduce'] === 'function') {
        return _methodReduce(fn, acc, list, 'fantasy-land/reduce');
      }

      if (list[symIterator] != null) {
        return _iterableReduce(fn, acc, list[symIterator]());
      }

      if (typeof list.next === 'function') {
        return _iterableReduce(fn, acc, list);
      }

      if (typeof list.reduce === 'function') {
        return _methodReduce(fn, acc, list, 'reduce');
      }

      throw new TypeError('reduce: list must be array or iterable');
    }

    var XMap =
    /*#__PURE__*/
    function () {
      function XMap(f, xf) {
        this.xf = xf;
        this.f = f;
      }

      XMap.prototype['@@transducer/init'] = _xfBase.init;
      XMap.prototype['@@transducer/result'] = _xfBase.result;

      XMap.prototype['@@transducer/step'] = function (result, input) {
        return this.xf['@@transducer/step'](result, this.f(input));
      };

      return XMap;
    }();

    var _xmap =
    /*#__PURE__*/
    _curry2(function _xmap(f, xf) {
      return new XMap(f, xf);
    });

    function _has(prop, obj) {
      return Object.prototype.hasOwnProperty.call(obj, prop);
    }

    var toString = Object.prototype.toString;

    var _isArguments =
    /*#__PURE__*/
    function () {
      return toString.call(arguments) === '[object Arguments]' ? function _isArguments(x) {
        return toString.call(x) === '[object Arguments]';
      } : function _isArguments(x) {
        return _has('callee', x);
      };
    }();

    var hasEnumBug = !
    /*#__PURE__*/
    {
      toString: null
    }.propertyIsEnumerable('toString');
    var nonEnumerableProps = ['constructor', 'valueOf', 'isPrototypeOf', 'toString', 'propertyIsEnumerable', 'hasOwnProperty', 'toLocaleString']; // Safari bug

    var hasArgsEnumBug =
    /*#__PURE__*/
    function () {

      return arguments.propertyIsEnumerable('length');
    }();

    var contains = function contains(list, item) {
      var idx = 0;

      while (idx < list.length) {
        if (list[idx] === item) {
          return true;
        }

        idx += 1;
      }

      return false;
    };
    /**
     * Returns a list containing the names of all the enumerable own properties of
     * the supplied object.
     * Note that the order of the output array is not guaranteed to be consistent
     * across different JS platforms.
     *
     * @func
     * @memberOf R
     * @since v0.1.0
     * @category Object
     * @sig {k: v} -> [k]
     * @param {Object} obj The object to extract properties from
     * @return {Array} An array of the object's own properties.
     * @see R.keysIn, R.values
     * @example
     *
     *      R.keys({a: 1, b: 2, c: 3}); //=> ['a', 'b', 'c']
     */


    var keys = typeof Object.keys === 'function' && !hasArgsEnumBug ?
    /*#__PURE__*/
    _curry1(function keys(obj) {
      return Object(obj) !== obj ? [] : Object.keys(obj);
    }) :
    /*#__PURE__*/
    _curry1(function keys(obj) {
      if (Object(obj) !== obj) {
        return [];
      }

      var prop, nIdx;
      var ks = [];

      var checkArgsLength = hasArgsEnumBug && _isArguments(obj);

      for (prop in obj) {
        if (_has(prop, obj) && (!checkArgsLength || prop !== 'length')) {
          ks[ks.length] = prop;
        }
      }

      if (hasEnumBug) {
        nIdx = nonEnumerableProps.length - 1;

        while (nIdx >= 0) {
          prop = nonEnumerableProps[nIdx];

          if (_has(prop, obj) && !contains(ks, prop)) {
            ks[ks.length] = prop;
          }

          nIdx -= 1;
        }
      }

      return ks;
    });

    /**
     * Takes a function and
     * a [functor](https://github.com/fantasyland/fantasy-land#functor),
     * applies the function to each of the functor's values, and returns
     * a functor of the same shape.
     *
     * Ramda provides suitable `map` implementations for `Array` and `Object`,
     * so this function may be applied to `[1, 2, 3]` or `{x: 1, y: 2, z: 3}`.
     *
     * Dispatches to the `map` method of the second argument, if present.
     *
     * Acts as a transducer if a transformer is given in list position.
     *
     * Also treats functions as functors and will compose them together.
     *
     * @func
     * @memberOf R
     * @since v0.1.0
     * @category List
     * @sig Functor f => (a -> b) -> f a -> f b
     * @param {Function} fn The function to be called on every element of the input `list`.
     * @param {Array} list The list to be iterated over.
     * @return {Array} The new list.
     * @see R.transduce, R.addIndex
     * @example
     *
     *      const double = x => x * 2;
     *
     *      R.map(double, [1, 2, 3]); //=> [2, 4, 6]
     *
     *      R.map(double, {x: 1, y: 2, z: 3}); //=> {x: 2, y: 4, z: 6}
     * @symb R.map(f, [a, b]) = [f(a), f(b)]
     * @symb R.map(f, { x: a, y: b }) = { x: f(a), y: f(b) }
     * @symb R.map(f, functor_o) = functor_o.map(f)
     */

    var map =
    /*#__PURE__*/
    _curry2(
    /*#__PURE__*/
    _dispatchable(['fantasy-land/map', 'map'], _xmap, function map(fn, functor) {
      switch (Object.prototype.toString.call(functor)) {
        case '[object Function]':
          return curryN(functor.length, function () {
            return fn.call(this, functor.apply(this, arguments));
          });

        case '[object Object]':
          return _reduce(function (acc, key) {
            acc[key] = fn(functor[key]);
            return acc;
          }, {}, keys(functor));

        default:
          return _map(fn, functor);
      }
    }));

    /**
     * Determine if the passed argument is an integer.
     *
     * @private
     * @param {*} n
     * @category Type
     * @return {Boolean}
     */
    var _isInteger = Number.isInteger || function _isInteger(n) {
      return n << 0 === n;
    };

    /**
     * Returns the nth element of the given list or string. If n is negative the
     * element at index length + n is returned.
     *
     * @func
     * @memberOf R
     * @since v0.1.0
     * @category List
     * @sig Number -> [a] -> a | Undefined
     * @sig Number -> String -> String
     * @param {Number} offset
     * @param {*} list
     * @return {*}
     * @example
     *
     *      const list = ['foo', 'bar', 'baz', 'quux'];
     *      R.nth(1, list); //=> 'bar'
     *      R.nth(-1, list); //=> 'quux'
     *      R.nth(-99, list); //=> undefined
     *
     *      R.nth(2, 'abc'); //=> 'c'
     *      R.nth(3, 'abc'); //=> ''
     * @symb R.nth(-1, [a, b, c]) = c
     * @symb R.nth(0, [a, b, c]) = a
     * @symb R.nth(1, [a, b, c]) = b
     */

    var nth =
    /*#__PURE__*/
    _curry2(function nth(offset, list) {
      var idx = offset < 0 ? list.length + offset : offset;
      return _isString(list) ? list.charAt(idx) : list[idx];
    });

    /**
     * Retrieves the values at given paths of an object.
     *
     * @func
     * @memberOf R
     * @since v0.27.1
     * @category Object
     * @typedefn Idx = [String | Int]
     * @sig [Idx] -> {a} -> [a | Undefined]
     * @param {Array} pathsArray The array of paths to be fetched.
     * @param {Object} obj The object to retrieve the nested properties from.
     * @return {Array} A list consisting of values at paths specified by "pathsArray".
     * @see R.path
     * @example
     *
     *      R.paths([['a', 'b'], ['p', 0, 'q']], {a: {b: 2}, p: [{q: 3}]}); //=> [2, 3]
     *      R.paths([['a', 'b'], ['p', 'r']], {a: {b: 2}, p: [{q: 3}]}); //=> [2, undefined]
     */

    var paths =
    /*#__PURE__*/
    _curry2(function paths(pathsArray, obj) {
      return pathsArray.map(function (paths) {
        var val = obj;
        var idx = 0;
        var p;

        while (idx < paths.length) {
          if (val == null) {
            return;
          }

          p = paths[idx];
          val = _isInteger(p) ? nth(p, val) : val[p];
          idx += 1;
        }

        return val;
      });
    });

    /**
     * Retrieve the value at a given path.
     *
     * @func
     * @memberOf R
     * @since v0.2.0
     * @category Object
     * @typedefn Idx = String | Int
     * @sig [Idx] -> {a} -> a | Undefined
     * @param {Array} path The path to use.
     * @param {Object} obj The object to retrieve the nested property from.
     * @return {*} The data at `path`.
     * @see R.prop, R.nth
     * @example
     *
     *      R.path(['a', 'b'], {a: {b: 2}}); //=> 2
     *      R.path(['a', 'b'], {c: {b: 2}}); //=> undefined
     *      R.path(['a', 'b', 0], {a: {b: [1, 2, 3]}}); //=> 1
     *      R.path(['a', 'b', -2], {a: {b: [1, 2, 3]}}); //=> 2
     */

    var path =
    /*#__PURE__*/
    _curry2(function path(pathAr, obj) {
      return paths([pathAr], obj)[0];
    });

    /**
     * Returns a function that when supplied an object returns the indicated
     * property of that object, if it exists.
     *
     * @func
     * @memberOf R
     * @since v0.1.0
     * @category Object
     * @typedefn Idx = String | Int
     * @sig Idx -> {s: a} -> a | Undefined
     * @param {String|Number} p The property name or array index
     * @param {Object} obj The object to query
     * @return {*} The value at `obj.p`.
     * @see R.path, R.nth
     * @example
     *
     *      R.prop('x', {x: 100}); //=> 100
     *      R.prop('x', {}); //=> undefined
     *      R.prop(0, [100]); //=> 100
     *      R.compose(R.inc, R.prop('x'))({ x: 3 }) //=> 4
     */

    var prop =
    /*#__PURE__*/
    _curry2(function prop(p, obj) {
      return path([p], obj);
    });

    /**
     * Returns a new list by plucking the same named property off all objects in
     * the list supplied.
     *
     * `pluck` will work on
     * any [functor](https://github.com/fantasyland/fantasy-land#functor) in
     * addition to arrays, as it is equivalent to `R.map(R.prop(k), f)`.
     *
     * @func
     * @memberOf R
     * @since v0.1.0
     * @category List
     * @sig Functor f => k -> f {k: v} -> f v
     * @param {Number|String} key The key name to pluck off of each object.
     * @param {Array} f The array or functor to consider.
     * @return {Array} The list of values for the given key.
     * @see R.props
     * @example
     *
     *      var getAges = R.pluck('age');
     *      getAges([{name: 'fred', age: 29}, {name: 'wilma', age: 27}]); //=> [29, 27]
     *
     *      R.pluck(0, [[1, 2], [3, 4]]);               //=> [1, 3]
     *      R.pluck('val', {a: {val: 3}, b: {val: 5}}); //=> {a: 3, b: 5}
     * @symb R.pluck('x', [{x: 1, y: 2}, {x: 3, y: 4}, {x: 5, y: 6}]) = [1, 3, 5]
     * @symb R.pluck(0, [[1, 2], [3, 4], [5, 6]]) = [1, 3, 5]
     */

    var pluck =
    /*#__PURE__*/
    _curry2(function pluck(p, list) {
      return map(prop(p), list);
    });

    /**
     * Returns a single item by iterating through the list, successively calling
     * the iterator function and passing it an accumulator value and the current
     * value from the array, and then passing the result to the next call.
     *
     * The iterator function receives two values: *(acc, value)*. It may use
     * [`R.reduced`](#reduced) to shortcut the iteration.
     *
     * The arguments' order of [`reduceRight`](#reduceRight)'s iterator function
     * is *(value, acc)*.
     *
     * Note: `R.reduce` does not skip deleted or unassigned indices (sparse
     * arrays), unlike the native `Array.prototype.reduce` method. For more details
     * on this behavior, see:
     * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/reduce#Description
     *
     * Dispatches to the `reduce` method of the third argument, if present. When
     * doing so, it is up to the user to handle the [`R.reduced`](#reduced)
     * shortcuting, as this is not implemented by `reduce`.
     *
     * @func
     * @memberOf R
     * @since v0.1.0
     * @category List
     * @sig ((a, b) -> a) -> a -> [b] -> a
     * @param {Function} fn The iterator function. Receives two values, the accumulator and the
     *        current element from the array.
     * @param {*} acc The accumulator value.
     * @param {Array} list The list to iterate over.
     * @return {*} The final, accumulated value.
     * @see R.reduced, R.addIndex, R.reduceRight
     * @example
     *
     *      R.reduce(R.subtract, 0, [1, 2, 3, 4]) // => ((((0 - 1) - 2) - 3) - 4) = -10
     *      //          -               -10
     *      //         / \              / \
     *      //        -   4           -6   4
     *      //       / \              / \
     *      //      -   3   ==>     -3   3
     *      //     / \              / \
     *      //    -   2           -1   2
     *      //   / \              / \
     *      //  0   1            0   1
     *
     * @symb R.reduce(f, a, [b, c, d]) = f(f(f(a, b), c), d)
     */

    var reduce =
    /*#__PURE__*/
    _curry3(_reduce);

    /**
     * Takes a list of predicates and returns a predicate that returns true for a
     * given list of arguments if every one of the provided predicates is satisfied
     * by those arguments.
     *
     * The function returned is a curried function whose arity matches that of the
     * highest-arity predicate.
     *
     * @func
     * @memberOf R
     * @since v0.9.0
     * @category Logic
     * @sig [(*... -> Boolean)] -> (*... -> Boolean)
     * @param {Array} predicates An array of predicates to check
     * @return {Function} The combined predicate
     * @see R.anyPass
     * @example
     *
     *      const isQueen = R.propEq('rank', 'Q');
     *      const isSpade = R.propEq('suit', '♠︎');
     *      const isQueenOfSpades = R.allPass([isQueen, isSpade]);
     *
     *      isQueenOfSpades({rank: 'Q', suit: '♣︎'}); //=> false
     *      isQueenOfSpades({rank: 'Q', suit: '♠︎'}); //=> true
     */

    var allPass =
    /*#__PURE__*/
    _curry1(function allPass(preds) {
      return curryN(reduce(max, 0, pluck('length', preds)), function () {
        var idx = 0;
        var len = preds.length;

        while (idx < len) {
          if (!preds[idx].apply(this, arguments)) {
            return false;
          }

          idx += 1;
        }

        return true;
      });
    });

    /**
     * Takes a list of predicates and returns a predicate that returns true for a
     * given list of arguments if at least one of the provided predicates is
     * satisfied by those arguments.
     *
     * The function returned is a curried function whose arity matches that of the
     * highest-arity predicate.
     *
     * @func
     * @memberOf R
     * @since v0.9.0
     * @category Logic
     * @sig [(*... -> Boolean)] -> (*... -> Boolean)
     * @param {Array} predicates An array of predicates to check
     * @return {Function} The combined predicate
     * @see R.allPass
     * @example
     *
     *      const isClub = R.propEq('suit', '♣');
     *      const isSpade = R.propEq('suit', '♠');
     *      const isBlackCard = R.anyPass([isClub, isSpade]);
     *
     *      isBlackCard({rank: '10', suit: '♣'}); //=> true
     *      isBlackCard({rank: 'Q', suit: '♠'}); //=> true
     *      isBlackCard({rank: 'Q', suit: '♦'}); //=> false
     */

    var anyPass =
    /*#__PURE__*/
    _curry1(function anyPass(preds) {
      return curryN(reduce(max, 0, pluck('length', preds)), function () {
        var idx = 0;
        var len = preds.length;

        while (idx < len) {
          if (preds[idx].apply(this, arguments)) {
            return true;
          }

          idx += 1;
        }

        return false;
      });
    });

    /**
     * ap applies a list of functions to a list of values.
     *
     * Dispatches to the `ap` method of the second argument, if present. Also
     * treats curried functions as applicatives.
     *
     * @func
     * @memberOf R
     * @since v0.3.0
     * @category Function
     * @sig [a -> b] -> [a] -> [b]
     * @sig Apply f => f (a -> b) -> f a -> f b
     * @sig (r -> a -> b) -> (r -> a) -> (r -> b)
     * @param {*} applyF
     * @param {*} applyX
     * @return {*}
     * @example
     *
     *      R.ap([R.multiply(2), R.add(3)], [1,2,3]); //=> [2, 4, 6, 4, 5, 6]
     *      R.ap([R.concat('tasty '), R.toUpper], ['pizza', 'salad']); //=> ["tasty pizza", "tasty salad", "PIZZA", "SALAD"]
     *
     *      // R.ap can also be used as S combinator
     *      // when only two functions are passed
     *      R.ap(R.concat, R.toUpper)('Ramda') //=> 'RamdaRAMDA'
     * @symb R.ap([f, g], [a, b]) = [f(a), f(b), g(a), g(b)]
     */

    var ap =
    /*#__PURE__*/
    _curry2(function ap(applyF, applyX) {
      return typeof applyX['fantasy-land/ap'] === 'function' ? applyX['fantasy-land/ap'](applyF) : typeof applyF.ap === 'function' ? applyF.ap(applyX) : typeof applyF === 'function' ? function (x) {
        return applyF(x)(applyX(x));
      } : _reduce(function (acc, f) {
        return _concat(acc, map(f, applyX));
      }, [], applyF);
    });

    /**
     * Makes a shallow clone of an object, setting or overriding the specified
     * property with the given value. Note that this copies and flattens prototype
     * properties onto the new object as well. All non-primitive properties are
     * copied by reference.
     *
     * @func
     * @memberOf R
     * @since v0.8.0
     * @category Object
     * @sig String -> a -> {k: v} -> {k: v}
     * @param {String} prop The property name to set
     * @param {*} val The new value
     * @param {Object} obj The object to clone
     * @return {Object} A new object equivalent to the original except for the changed property.
     * @see R.dissoc, R.pick
     * @example
     *
     *      R.assoc('c', 3, {a: 1, b: 2}); //=> {a: 1, b: 2, c: 3}
     */

    var assoc =
    /*#__PURE__*/
    _curry3(function assoc(prop, val, obj) {
      var result = {};

      for (var p in obj) {
        result[p] = obj[p];
      }

      result[prop] = val;
      return result;
    });

    /**
     * Checks if the input value is `null` or `undefined`.
     *
     * @func
     * @memberOf R
     * @since v0.9.0
     * @category Type
     * @sig * -> Boolean
     * @param {*} x The value to test.
     * @return {Boolean} `true` if `x` is `undefined` or `null`, otherwise `false`.
     * @example
     *
     *      R.isNil(null); //=> true
     *      R.isNil(undefined); //=> true
     *      R.isNil(0); //=> false
     *      R.isNil([]); //=> false
     */

    var isNil =
    /*#__PURE__*/
    _curry1(function isNil(x) {
      return x == null;
    });

    function _isFunction(x) {
      var type = Object.prototype.toString.call(x);
      return type === '[object Function]' || type === '[object AsyncFunction]' || type === '[object GeneratorFunction]' || type === '[object AsyncGeneratorFunction]';
    }

    /**
     * "lifts" a function to be the specified arity, so that it may "map over" that
     * many lists, Functions or other objects that satisfy the [FantasyLand Apply spec](https://github.com/fantasyland/fantasy-land#apply).
     *
     * @func
     * @memberOf R
     * @since v0.7.0
     * @category Function
     * @sig Number -> (*... -> *) -> ([*]... -> [*])
     * @param {Function} fn The function to lift into higher context
     * @return {Function} The lifted function.
     * @see R.lift, R.ap
     * @example
     *
     *      const madd3 = R.liftN(3, (...args) => R.sum(args));
     *      madd3([1,2,3], [1,2,3], [1]); //=> [3, 4, 5, 4, 5, 6, 5, 6, 7]
     */

    var liftN =
    /*#__PURE__*/
    _curry2(function liftN(arity, fn) {
      var lifted = curryN(arity, fn);
      return curryN(arity, function () {
        return _reduce(ap, map(lifted, arguments[0]), Array.prototype.slice.call(arguments, 1));
      });
    });

    /**
     * "lifts" a function of arity > 1 so that it may "map over" a list, Function or other
     * object that satisfies the [FantasyLand Apply spec](https://github.com/fantasyland/fantasy-land#apply).
     *
     * @func
     * @memberOf R
     * @since v0.7.0
     * @category Function
     * @sig (*... -> *) -> ([*]... -> [*])
     * @param {Function} fn The function to lift into higher context
     * @return {Function} The lifted function.
     * @see R.liftN
     * @example
     *
     *      const madd3 = R.lift((a, b, c) => a + b + c);
     *
     *      madd3([1,2,3], [1,2,3], [1]); //=> [3, 4, 5, 4, 5, 6, 5, 6, 7]
     *
     *      const madd5 = R.lift((a, b, c, d, e) => a + b + c + d + e);
     *
     *      madd5([1,2], [3], [4, 5], [6], [7, 8]); //=> [21, 22, 22, 23, 22, 23, 23, 24]
     */

    var lift =
    /*#__PURE__*/
    _curry1(function lift(fn) {
      return liftN(fn.length, fn);
    });

    /**
     * Gives a single-word string description of the (native) type of a value,
     * returning such answers as 'Object', 'Number', 'Array', or 'Null'. Does not
     * attempt to distinguish user Object types any further, reporting them all as
     * 'Object'.
     *
     * @func
     * @memberOf R
     * @since v0.8.0
     * @category Type
     * @sig (* -> {*}) -> String
     * @param {*} val The value to test
     * @return {String}
     * @example
     *
     *      R.type({}); //=> "Object"
     *      R.type(1); //=> "Number"
     *      R.type(false); //=> "Boolean"
     *      R.type('s'); //=> "String"
     *      R.type(null); //=> "Null"
     *      R.type([]); //=> "Array"
     *      R.type(/[A-z]/); //=> "RegExp"
     *      R.type(() => {}); //=> "Function"
     *      R.type(undefined); //=> "Undefined"
     */

    var type =
    /*#__PURE__*/
    _curry1(function type(val) {
      return val === null ? 'Null' : val === undefined ? 'Undefined' : Object.prototype.toString.call(val).slice(8, -1);
    });

    /**
     * A function that returns the `!` of its argument. It will return `true` when
     * passed false-y value, and `false` when passed a truth-y one.
     *
     * @func
     * @memberOf R
     * @since v0.1.0
     * @category Logic
     * @sig * -> Boolean
     * @param {*} a any value
     * @return {Boolean} the logical inverse of passed argument.
     * @see R.complement
     * @example
     *
     *      R.not(true); //=> false
     *      R.not(false); //=> true
     *      R.not(0); //=> true
     *      R.not(1); //=> false
     */

    var not =
    /*#__PURE__*/
    _curry1(function not(a) {
      return !a;
    });

    function _pipe(f, g) {
      return function () {
        return g.call(this, f.apply(this, arguments));
      };
    }

    /**
     * This checks whether a function has a [methodname] function. If it isn't an
     * array it will execute that function otherwise it will default to the ramda
     * implementation.
     *
     * @private
     * @param {Function} fn ramda implemtation
     * @param {String} methodname property to check for a custom implementation
     * @return {Object} Whatever the return value of the method is.
     */

    function _checkForMethod(methodname, fn) {
      return function () {
        var length = arguments.length;

        if (length === 0) {
          return fn();
        }

        var obj = arguments[length - 1];
        return _isArray(obj) || typeof obj[methodname] !== 'function' ? fn.apply(this, arguments) : obj[methodname].apply(obj, Array.prototype.slice.call(arguments, 0, length - 1));
      };
    }

    /**
     * Returns the elements of the given list or string (or object with a `slice`
     * method) from `fromIndex` (inclusive) to `toIndex` (exclusive).
     *
     * Dispatches to the `slice` method of the third argument, if present.
     *
     * @func
     * @memberOf R
     * @since v0.1.4
     * @category List
     * @sig Number -> Number -> [a] -> [a]
     * @sig Number -> Number -> String -> String
     * @param {Number} fromIndex The start index (inclusive).
     * @param {Number} toIndex The end index (exclusive).
     * @param {*} list
     * @return {*}
     * @example
     *
     *      R.slice(1, 3, ['a', 'b', 'c', 'd']);        //=> ['b', 'c']
     *      R.slice(1, Infinity, ['a', 'b', 'c', 'd']); //=> ['b', 'c', 'd']
     *      R.slice(0, -1, ['a', 'b', 'c', 'd']);       //=> ['a', 'b', 'c']
     *      R.slice(-3, -1, ['a', 'b', 'c', 'd']);      //=> ['b', 'c']
     *      R.slice(0, 3, 'ramda');                     //=> 'ram'
     */

    var slice =
    /*#__PURE__*/
    _curry3(
    /*#__PURE__*/
    _checkForMethod('slice', function slice(fromIndex, toIndex, list) {
      return Array.prototype.slice.call(list, fromIndex, toIndex);
    }));

    /**
     * Returns all but the first element of the given list or string (or object
     * with a `tail` method).
     *
     * Dispatches to the `slice` method of the first argument, if present.
     *
     * @func
     * @memberOf R
     * @since v0.1.0
     * @category List
     * @sig [a] -> [a]
     * @sig String -> String
     * @param {*} list
     * @return {*}
     * @see R.head, R.init, R.last
     * @example
     *
     *      R.tail([1, 2, 3]);  //=> [2, 3]
     *      R.tail([1, 2]);     //=> [2]
     *      R.tail([1]);        //=> []
     *      R.tail([]);         //=> []
     *
     *      R.tail('abc');  //=> 'bc'
     *      R.tail('ab');   //=> 'b'
     *      R.tail('a');    //=> ''
     *      R.tail('');     //=> ''
     */

    var tail =
    /*#__PURE__*/
    _curry1(
    /*#__PURE__*/
    _checkForMethod('tail',
    /*#__PURE__*/
    slice(1, Infinity)));

    /**
     * Performs left-to-right function composition. The first argument may have
     * any arity; the remaining arguments must be unary.
     *
     * In some libraries this function is named `sequence`.
     *
     * **Note:** The result of pipe is not automatically curried.
     *
     * @func
     * @memberOf R
     * @since v0.1.0
     * @category Function
     * @sig (((a, b, ..., n) -> o), (o -> p), ..., (x -> y), (y -> z)) -> ((a, b, ..., n) -> z)
     * @param {...Function} functions
     * @return {Function}
     * @see R.compose
     * @example
     *
     *      const f = R.pipe(Math.pow, R.negate, R.inc);
     *
     *      f(3, 4); // -(3^4) + 1
     * @symb R.pipe(f, g, h)(a, b) = h(g(f(a, b)))
     */

    function pipe() {
      if (arguments.length === 0) {
        throw new Error('pipe requires at least one argument');
      }

      return _arity(arguments[0].length, reduce(_pipe, arguments[0], tail(arguments)));
    }

    function _arrayFromIterator(iter) {
      var list = [];
      var next;

      while (!(next = iter.next()).done) {
        list.push(next.value);
      }

      return list;
    }

    function _includesWith(pred, x, list) {
      var idx = 0;
      var len = list.length;

      while (idx < len) {
        if (pred(x, list[idx])) {
          return true;
        }

        idx += 1;
      }

      return false;
    }

    function _functionName(f) {
      // String(x => x) evaluates to "x => x", so the pattern may not match.
      var match = String(f).match(/^function (\w*)/);
      return match == null ? '' : match[1];
    }

    // Based on https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
    function _objectIs(a, b) {
      // SameValue algorithm
      if (a === b) {
        // Steps 1-5, 7-10
        // Steps 6.b-6.e: +0 != -0
        return a !== 0 || 1 / a === 1 / b;
      } else {
        // Step 6.a: NaN == NaN
        return a !== a && b !== b;
      }
    }

    var _objectIs$1 = typeof Object.is === 'function' ? Object.is : _objectIs;

    /**
     * private _uniqContentEquals function.
     * That function is checking equality of 2 iterator contents with 2 assumptions
     * - iterators lengths are the same
     * - iterators values are unique
     *
     * false-positive result will be returned for comparision of, e.g.
     * - [1,2,3] and [1,2,3,4]
     * - [1,1,1] and [1,2,3]
     * */

    function _uniqContentEquals(aIterator, bIterator, stackA, stackB) {
      var a = _arrayFromIterator(aIterator);

      var b = _arrayFromIterator(bIterator);

      function eq(_a, _b) {
        return _equals(_a, _b, stackA.slice(), stackB.slice());
      } // if *a* array contains any element that is not included in *b*


      return !_includesWith(function (b, aItem) {
        return !_includesWith(eq, aItem, b);
      }, b, a);
    }

    function _equals(a, b, stackA, stackB) {
      if (_objectIs$1(a, b)) {
        return true;
      }

      var typeA = type(a);

      if (typeA !== type(b)) {
        return false;
      }

      if (a == null || b == null) {
        return false;
      }

      if (typeof a['fantasy-land/equals'] === 'function' || typeof b['fantasy-land/equals'] === 'function') {
        return typeof a['fantasy-land/equals'] === 'function' && a['fantasy-land/equals'](b) && typeof b['fantasy-land/equals'] === 'function' && b['fantasy-land/equals'](a);
      }

      if (typeof a.equals === 'function' || typeof b.equals === 'function') {
        return typeof a.equals === 'function' && a.equals(b) && typeof b.equals === 'function' && b.equals(a);
      }

      switch (typeA) {
        case 'Arguments':
        case 'Array':
        case 'Object':
          if (typeof a.constructor === 'function' && _functionName(a.constructor) === 'Promise') {
            return a === b;
          }

          break;

        case 'Boolean':
        case 'Number':
        case 'String':
          if (!(typeof a === typeof b && _objectIs$1(a.valueOf(), b.valueOf()))) {
            return false;
          }

          break;

        case 'Date':
          if (!_objectIs$1(a.valueOf(), b.valueOf())) {
            return false;
          }

          break;

        case 'Error':
          return a.name === b.name && a.message === b.message;

        case 'RegExp':
          if (!(a.source === b.source && a.global === b.global && a.ignoreCase === b.ignoreCase && a.multiline === b.multiline && a.sticky === b.sticky && a.unicode === b.unicode)) {
            return false;
          }

          break;
      }

      var idx = stackA.length - 1;

      while (idx >= 0) {
        if (stackA[idx] === a) {
          return stackB[idx] === b;
        }

        idx -= 1;
      }

      switch (typeA) {
        case 'Map':
          if (a.size !== b.size) {
            return false;
          }

          return _uniqContentEquals(a.entries(), b.entries(), stackA.concat([a]), stackB.concat([b]));

        case 'Set':
          if (a.size !== b.size) {
            return false;
          }

          return _uniqContentEquals(a.values(), b.values(), stackA.concat([a]), stackB.concat([b]));

        case 'Arguments':
        case 'Array':
        case 'Object':
        case 'Boolean':
        case 'Number':
        case 'String':
        case 'Date':
        case 'Error':
        case 'RegExp':
        case 'Int8Array':
        case 'Uint8Array':
        case 'Uint8ClampedArray':
        case 'Int16Array':
        case 'Uint16Array':
        case 'Int32Array':
        case 'Uint32Array':
        case 'Float32Array':
        case 'Float64Array':
        case 'ArrayBuffer':
          break;

        default:
          // Values of other types are only equal if identical.
          return false;
      }

      var keysA = keys(a);

      if (keysA.length !== keys(b).length) {
        return false;
      }

      var extendedStackA = stackA.concat([a]);
      var extendedStackB = stackB.concat([b]);
      idx = keysA.length - 1;

      while (idx >= 0) {
        var key = keysA[idx];

        if (!(_has(key, b) && _equals(b[key], a[key], extendedStackA, extendedStackB))) {
          return false;
        }

        idx -= 1;
      }

      return true;
    }

    /**
     * Returns `true` if its arguments are equivalent, `false` otherwise. Handles
     * cyclical data structures.
     *
     * Dispatches symmetrically to the `equals` methods of both arguments, if
     * present.
     *
     * @func
     * @memberOf R
     * @since v0.15.0
     * @category Relation
     * @sig a -> b -> Boolean
     * @param {*} a
     * @param {*} b
     * @return {Boolean}
     * @example
     *
     *      R.equals(1, 1); //=> true
     *      R.equals(1, '1'); //=> false
     *      R.equals([1, 2, 3], [1, 2, 3]); //=> true
     *
     *      const a = {}; a.v = a;
     *      const b = {}; b.v = b;
     *      R.equals(a, b); //=> true
     */

    var equals =
    /*#__PURE__*/
    _curry2(function equals(a, b) {
      return _equals(a, b, [], []);
    });

    function _indexOf(list, a, idx) {
      var inf, item; // Array.prototype.indexOf doesn't exist below IE9

      if (typeof list.indexOf === 'function') {
        switch (typeof a) {
          case 'number':
            if (a === 0) {
              // manually crawl the list to distinguish between +0 and -0
              inf = 1 / a;

              while (idx < list.length) {
                item = list[idx];

                if (item === 0 && 1 / item === inf) {
                  return idx;
                }

                idx += 1;
              }

              return -1;
            } else if (a !== a) {
              // NaN
              while (idx < list.length) {
                item = list[idx];

                if (typeof item === 'number' && item !== item) {
                  return idx;
                }

                idx += 1;
              }

              return -1;
            } // non-zero numbers can utilise Set


            return list.indexOf(a, idx);
          // all these types can utilise Set

          case 'string':
          case 'boolean':
          case 'function':
          case 'undefined':
            return list.indexOf(a, idx);

          case 'object':
            if (a === null) {
              // null can utilise Set
              return list.indexOf(a, idx);
            }

        }
      } // anything else not covered above, defer to R.equals


      while (idx < list.length) {
        if (equals(list[idx], a)) {
          return idx;
        }

        idx += 1;
      }

      return -1;
    }

    function _includes(a, list) {
      return _indexOf(list, a, 0) >= 0;
    }

    function _quote(s) {
      var escaped = s.replace(/\\/g, '\\\\').replace(/[\b]/g, '\\b') // \b matches word boundary; [\b] matches backspace
      .replace(/\f/g, '\\f').replace(/\n/g, '\\n').replace(/\r/g, '\\r').replace(/\t/g, '\\t').replace(/\v/g, '\\v').replace(/\0/g, '\\0');
      return '"' + escaped.replace(/"/g, '\\"') + '"';
    }

    /**
     * Polyfill from <https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date/toISOString>.
     */
    var pad = function pad(n) {
      return (n < 10 ? '0' : '') + n;
    };

    var _toISOString = typeof Date.prototype.toISOString === 'function' ? function _toISOString(d) {
      return d.toISOString();
    } : function _toISOString(d) {
      return d.getUTCFullYear() + '-' + pad(d.getUTCMonth() + 1) + '-' + pad(d.getUTCDate()) + 'T' + pad(d.getUTCHours()) + ':' + pad(d.getUTCMinutes()) + ':' + pad(d.getUTCSeconds()) + '.' + (d.getUTCMilliseconds() / 1000).toFixed(3).slice(2, 5) + 'Z';
    };

    function _complement(f) {
      return function () {
        return !f.apply(this, arguments);
      };
    }

    function _filter(fn, list) {
      var idx = 0;
      var len = list.length;
      var result = [];

      while (idx < len) {
        if (fn(list[idx])) {
          result[result.length] = list[idx];
        }

        idx += 1;
      }

      return result;
    }

    function _isObject(x) {
      return Object.prototype.toString.call(x) === '[object Object]';
    }

    var XFilter =
    /*#__PURE__*/
    function () {
      function XFilter(f, xf) {
        this.xf = xf;
        this.f = f;
      }

      XFilter.prototype['@@transducer/init'] = _xfBase.init;
      XFilter.prototype['@@transducer/result'] = _xfBase.result;

      XFilter.prototype['@@transducer/step'] = function (result, input) {
        return this.f(input) ? this.xf['@@transducer/step'](result, input) : result;
      };

      return XFilter;
    }();

    var _xfilter =
    /*#__PURE__*/
    _curry2(function _xfilter(f, xf) {
      return new XFilter(f, xf);
    });

    /**
     * Takes a predicate and a `Filterable`, and returns a new filterable of the
     * same type containing the members of the given filterable which satisfy the
     * given predicate. Filterable objects include plain objects or any object
     * that has a filter method such as `Array`.
     *
     * Dispatches to the `filter` method of the second argument, if present.
     *
     * Acts as a transducer if a transformer is given in list position.
     *
     * @func
     * @memberOf R
     * @since v0.1.0
     * @category List
     * @sig Filterable f => (a -> Boolean) -> f a -> f a
     * @param {Function} pred
     * @param {Array} filterable
     * @return {Array} Filterable
     * @see R.reject, R.transduce, R.addIndex
     * @example
     *
     *      const isEven = n => n % 2 === 0;
     *
     *      R.filter(isEven, [1, 2, 3, 4]); //=> [2, 4]
     *
     *      R.filter(isEven, {a: 1, b: 2, c: 3, d: 4}); //=> {b: 2, d: 4}
     */

    var filter =
    /*#__PURE__*/
    _curry2(
    /*#__PURE__*/
    _dispatchable(['filter'], _xfilter, function (pred, filterable) {
      return _isObject(filterable) ? _reduce(function (acc, key) {
        if (pred(filterable[key])) {
          acc[key] = filterable[key];
        }

        return acc;
      }, {}, keys(filterable)) : // else
      _filter(pred, filterable);
    }));

    /**
     * The complement of [`filter`](#filter).
     *
     * Acts as a transducer if a transformer is given in list position. Filterable
     * objects include plain objects or any object that has a filter method such
     * as `Array`.
     *
     * @func
     * @memberOf R
     * @since v0.1.0
     * @category List
     * @sig Filterable f => (a -> Boolean) -> f a -> f a
     * @param {Function} pred
     * @param {Array} filterable
     * @return {Array}
     * @see R.filter, R.transduce, R.addIndex
     * @example
     *
     *      const isOdd = (n) => n % 2 === 1;
     *
     *      R.reject(isOdd, [1, 2, 3, 4]); //=> [2, 4]
     *
     *      R.reject(isOdd, {a: 1, b: 2, c: 3, d: 4}); //=> {b: 2, d: 4}
     */

    var reject =
    /*#__PURE__*/
    _curry2(function reject(pred, filterable) {
      return filter(_complement(pred), filterable);
    });

    function _toString(x, seen) {
      var recur = function recur(y) {
        var xs = seen.concat([x]);
        return _includes(y, xs) ? '<Circular>' : _toString(y, xs);
      }; //  mapPairs :: (Object, [String]) -> [String]


      var mapPairs = function (obj, keys) {
        return _map(function (k) {
          return _quote(k) + ': ' + recur(obj[k]);
        }, keys.slice().sort());
      };

      switch (Object.prototype.toString.call(x)) {
        case '[object Arguments]':
          return '(function() { return arguments; }(' + _map(recur, x).join(', ') + '))';

        case '[object Array]':
          return '[' + _map(recur, x).concat(mapPairs(x, reject(function (k) {
            return /^\d+$/.test(k);
          }, keys(x)))).join(', ') + ']';

        case '[object Boolean]':
          return typeof x === 'object' ? 'new Boolean(' + recur(x.valueOf()) + ')' : x.toString();

        case '[object Date]':
          return 'new Date(' + (isNaN(x.valueOf()) ? recur(NaN) : _quote(_toISOString(x))) + ')';

        case '[object Null]':
          return 'null';

        case '[object Number]':
          return typeof x === 'object' ? 'new Number(' + recur(x.valueOf()) + ')' : 1 / x === -Infinity ? '-0' : x.toString(10);

        case '[object String]':
          return typeof x === 'object' ? 'new String(' + recur(x.valueOf()) + ')' : _quote(x);

        case '[object Undefined]':
          return 'undefined';

        default:
          if (typeof x.toString === 'function') {
            var repr = x.toString();

            if (repr !== '[object Object]') {
              return repr;
            }
          }

          return '{' + mapPairs(x, keys(x)).join(', ') + '}';
      }
    }

    /**
     * Returns the string representation of the given value. `eval`'ing the output
     * should result in a value equivalent to the input value. Many of the built-in
     * `toString` methods do not satisfy this requirement.
     *
     * If the given value is an `[object Object]` with a `toString` method other
     * than `Object.prototype.toString`, this method is invoked with no arguments
     * to produce the return value. This means user-defined constructor functions
     * can provide a suitable `toString` method. For example:
     *
     *     function Point(x, y) {
     *       this.x = x;
     *       this.y = y;
     *     }
     *
     *     Point.prototype.toString = function() {
     *       return 'new Point(' + this.x + ', ' + this.y + ')';
     *     };
     *
     *     R.toString(new Point(1, 2)); //=> 'new Point(1, 2)'
     *
     * @func
     * @memberOf R
     * @since v0.14.0
     * @category String
     * @sig * -> String
     * @param {*} val
     * @return {String}
     * @example
     *
     *      R.toString(42); //=> '42'
     *      R.toString('abc'); //=> '"abc"'
     *      R.toString([1, 2, 3]); //=> '[1, 2, 3]'
     *      R.toString({foo: 1, bar: 2, baz: 3}); //=> '{"bar": 2, "baz": 3, "foo": 1}'
     *      R.toString(new Date('2001-02-03T04:05:06Z')); //=> 'new Date("2001-02-03T04:05:06.000Z")'
     */

    var toString$1 =
    /*#__PURE__*/
    _curry1(function toString(val) {
      return _toString(val, []);
    });

    /**
     * Returns a function, `fn`, which encapsulates `if/else, if/else, ...` logic.
     * `R.cond` takes a list of [predicate, transformer] pairs. All of the arguments
     * to `fn` are applied to each of the predicates in turn until one returns a
     * "truthy" value, at which point `fn` returns the result of applying its
     * arguments to the corresponding transformer. If none of the predicates
     * matches, `fn` returns undefined.
     *
     * @func
     * @memberOf R
     * @since v0.6.0
     * @category Logic
     * @sig [[(*... -> Boolean),(*... -> *)]] -> (*... -> *)
     * @param {Array} pairs A list of [predicate, transformer]
     * @return {Function}
     * @see R.ifElse, R.unless, R.when
     * @example
     *
     *      const fn = R.cond([
     *        [R.equals(0),   R.always('water freezes at 0°C')],
     *        [R.equals(100), R.always('water boils at 100°C')],
     *        [R.T,           temp => 'nothing special happens at ' + temp + '°C']
     *      ]);
     *      fn(0); //=> 'water freezes at 0°C'
     *      fn(50); //=> 'nothing special happens at 50°C'
     *      fn(100); //=> 'water boils at 100°C'
     */

    var cond =
    /*#__PURE__*/
    _curry1(function cond(pairs) {
      var arity = reduce(max, 0, map(function (pair) {
        return pair[0].length;
      }, pairs));
      return _arity(arity, function () {
        var idx = 0;

        while (idx < pairs.length) {
          if (pairs[idx][0].apply(this, arguments)) {
            return pairs[idx][1].apply(this, arguments);
          }

          idx += 1;
        }
      });
    });

    /**
     * Returns the second argument if it is not `null`, `undefined` or `NaN`;
     * otherwise the first argument is returned.
     *
     * @func
     * @memberOf R
     * @since v0.10.0
     * @category Logic
     * @sig a -> b -> a | b
     * @param {a} default The default value.
     * @param {b} val `val` will be returned instead of `default` unless `val` is `null`, `undefined` or `NaN`.
     * @return {*} The second value if it is not `null`, `undefined` or `NaN`, otherwise the default value
     * @example
     *
     *      const defaultTo42 = R.defaultTo(42);
     *
     *      defaultTo42(null);  //=> 42
     *      defaultTo42(undefined);  //=> 42
     *      defaultTo42(false);  //=> false
     *      defaultTo42('Ramda');  //=> 'Ramda'
     *      // parseInt('string') results in NaN
     *      defaultTo42(parseInt('string')); //=> 42
     */

    var defaultTo =
    /*#__PURE__*/
    _curry2(function defaultTo(d, v) {
      return v == null || v !== v ? d : v;
    });

    /**
     * Divides two numbers. Equivalent to `a / b`.
     *
     * @func
     * @memberOf R
     * @since v0.1.0
     * @category Math
     * @sig Number -> Number -> Number
     * @param {Number} a The first value.
     * @param {Number} b The second value.
     * @return {Number} The result of `a / b`.
     * @see R.multiply
     * @example
     *
     *      R.divide(71, 100); //=> 0.71
     *
     *      const half = R.divide(R.__, 2);
     *      half(42); //=> 21
     *
     *      const reciprocal = R.divide(1);
     *      reciprocal(4);   //=> 0.25
     */

    var divide =
    /*#__PURE__*/
    _curry2(function divide(a, b) {
      return a / b;
    });

    /**
     * Returns the last element of the given list or string.
     *
     * @func
     * @memberOf R
     * @since v0.1.4
     * @category List
     * @sig [a] -> a | Undefined
     * @sig String -> String
     * @param {*} list
     * @return {*}
     * @see R.init, R.head, R.tail
     * @example
     *
     *      R.last(['fi', 'fo', 'fum']); //=> 'fum'
     *      R.last([]); //=> undefined
     *
     *      R.last('abc'); //=> 'c'
     *      R.last(''); //=> ''
     */

    var last =
    /*#__PURE__*/
    nth(-1);

    /**
     * Returns `true` if one or both of its arguments are `true`. Returns `false`
     * if both arguments are `false`.
     *
     * @func
     * @memberOf R
     * @since v0.1.0
     * @category Logic
     * @sig a -> b -> a | b
     * @param {Any} a
     * @param {Any} b
     * @return {Any} the first argument if truthy, otherwise the second argument.
     * @see R.either, R.xor
     * @example
     *
     *      R.or(true, true); //=> true
     *      R.or(true, false); //=> true
     *      R.or(false, true); //=> true
     *      R.or(false, false); //=> false
     */

    var or =
    /*#__PURE__*/
    _curry2(function or(a, b) {
      return a || b;
    });

    /**
     * A function wrapping calls to the two functions in an `||` operation,
     * returning the result of the first function if it is truth-y and the result
     * of the second function otherwise. Note that this is short-circuited,
     * meaning that the second function will not be invoked if the first returns a
     * truth-y value.
     *
     * In addition to functions, `R.either` also accepts any fantasy-land compatible
     * applicative functor.
     *
     * @func
     * @memberOf R
     * @since v0.12.0
     * @category Logic
     * @sig (*... -> Boolean) -> (*... -> Boolean) -> (*... -> Boolean)
     * @param {Function} f a predicate
     * @param {Function} g another predicate
     * @return {Function} a function that applies its arguments to `f` and `g` and `||`s their outputs together.
     * @see R.or
     * @example
     *
     *      const gt10 = x => x > 10;
     *      const even = x => x % 2 === 0;
     *      const f = R.either(gt10, even);
     *      f(101); //=> true
     *      f(8); //=> true
     *
     *      R.either(Maybe.Just(false), Maybe.Just(55)); // => Maybe.Just(55)
     *      R.either([false, false, 'a'], [11]) // => [11, 11, "a"]
     */

    var either =
    /*#__PURE__*/
    _curry2(function either(f, g) {
      return _isFunction(f) ? function _either() {
        return f.apply(this, arguments) || g.apply(this, arguments);
      } : lift(or)(f, g);
    });

    /**
     * Returns the empty value of its argument's type. Ramda defines the empty
     * value of Array (`[]`), Object (`{}`), String (`''`), and Arguments. Other
     * types are supported if they define `<Type>.empty`,
     * `<Type>.prototype.empty` or implement the
     * [FantasyLand Monoid spec](https://github.com/fantasyland/fantasy-land#monoid).
     *
     * Dispatches to the `empty` method of the first argument, if present.
     *
     * @func
     * @memberOf R
     * @since v0.3.0
     * @category Function
     * @sig a -> a
     * @param {*} x
     * @return {*}
     * @example
     *
     *      R.empty(Just(42));      //=> Nothing()
     *      R.empty([1, 2, 3]);     //=> []
     *      R.empty('unicorns');    //=> ''
     *      R.empty({x: 1, y: 2});  //=> {}
     */

    var empty =
    /*#__PURE__*/
    _curry1(function empty(x) {
      return x != null && typeof x['fantasy-land/empty'] === 'function' ? x['fantasy-land/empty']() : x != null && x.constructor != null && typeof x.constructor['fantasy-land/empty'] === 'function' ? x.constructor['fantasy-land/empty']() : x != null && typeof x.empty === 'function' ? x.empty() : x != null && x.constructor != null && typeof x.constructor.empty === 'function' ? x.constructor.empty() : _isArray(x) ? [] : _isString(x) ? '' : _isObject(x) ? {} : _isArguments(x) ? function () {
        return arguments;
      }() : void 0 // else
      ;
    });

    /**
     * Returns a new function much like the supplied one, except that the first two
     * arguments' order is reversed.
     *
     * @func
     * @memberOf R
     * @since v0.1.0
     * @category Function
     * @sig ((a, b, c, ...) -> z) -> (b -> a -> c -> ... -> z)
     * @param {Function} fn The function to invoke with its first two parameters reversed.
     * @return {*} The result of invoking `fn` with its first two parameters' order reversed.
     * @example
     *
     *      const mergeThree = (a, b, c) => [].concat(a, b, c);
     *
     *      mergeThree(1, 2, 3); //=> [1, 2, 3]
     *
     *      R.flip(mergeThree)(1, 2, 3); //=> [2, 1, 3]
     * @symb R.flip(f)(a, b, c) = f(b, a, c)
     */

    var flip =
    /*#__PURE__*/
    _curry1(function flip(fn) {
      return curryN(fn.length, function (a, b) {
        var args = Array.prototype.slice.call(arguments, 0);
        args[0] = b;
        args[1] = a;
        return fn.apply(this, args);
      });
    });

    /**
     * Creates a new object from a list key-value pairs. If a key appears in
     * multiple pairs, the rightmost pair is included in the object.
     *
     * @func
     * @memberOf R
     * @since v0.3.0
     * @category List
     * @sig [[k,v]] -> {k: v}
     * @param {Array} pairs An array of two-element arrays that will be the keys and values of the output object.
     * @return {Object} The object made by pairing up `keys` and `values`.
     * @see R.toPairs, R.pair
     * @example
     *
     *      R.fromPairs([['a', 1], ['b', 2], ['c', 3]]); //=> {a: 1, b: 2, c: 3}
     */

    var fromPairs =
    /*#__PURE__*/
    _curry1(function fromPairs(pairs) {
      var result = {};
      var idx = 0;

      while (idx < pairs.length) {
        result[pairs[idx][0]] = pairs[idx][1];
        idx += 1;
      }

      return result;
    });

    function _objectAssign(target) {
      if (target == null) {
        throw new TypeError('Cannot convert undefined or null to object');
      }

      var output = Object(target);
      var idx = 1;
      var length = arguments.length;

      while (idx < length) {
        var source = arguments[idx];

        if (source != null) {
          for (var nextKey in source) {
            if (_has(nextKey, source)) {
              output[nextKey] = source[nextKey];
            }
          }
        }

        idx += 1;
      }

      return output;
    }

    var _objectAssign$1 = typeof Object.assign === 'function' ? Object.assign : _objectAssign;

    /**
     * Returns `true` if the given value is its type's empty value; `false`
     * otherwise.
     *
     * @func
     * @memberOf R
     * @since v0.1.0
     * @category Logic
     * @sig a -> Boolean
     * @param {*} x
     * @return {Boolean}
     * @see R.empty
     * @example
     *
     *      R.isEmpty([1, 2, 3]);   //=> false
     *      R.isEmpty([]);          //=> true
     *      R.isEmpty('');          //=> true
     *      R.isEmpty(null);        //=> false
     *      R.isEmpty({});          //=> true
     *      R.isEmpty({length: 0}); //=> false
     */

    var isEmpty =
    /*#__PURE__*/
    _curry1(function isEmpty(x) {
      return x != null && equals(x, empty(x));
    });

    /**
     * An Object-specific version of [`map`](#map). The function is applied to three
     * arguments: *(value, key, obj)*. If only the value is significant, use
     * [`map`](#map) instead.
     *
     * @func
     * @memberOf R
     * @since v0.9.0
     * @category Object
     * @sig ((*, String, Object) -> *) -> Object -> Object
     * @param {Function} fn
     * @param {Object} obj
     * @return {Object}
     * @see R.map
     * @example
     *
     *      const xyz = { x: 1, y: 2, z: 3 };
     *      const prependKeyAndDouble = (num, key, obj) => key + (num * 2);
     *
     *      R.mapObjIndexed(prependKeyAndDouble, xyz); //=> { x: 'x2', y: 'y4', z: 'z6' }
     */

    var mapObjIndexed =
    /*#__PURE__*/
    _curry2(function mapObjIndexed(fn, obj) {
      return _reduce(function (acc, key) {
        acc[key] = fn(obj[key], key, obj);
        return acc;
      }, {}, keys(obj));
    });

    /**
     * Create a new object with the own properties of the first object merged with
     * the own properties of the second object. If a key exists in both objects,
     * the value from the first object will be used.
     *
     * @func
     * @memberOf R
     * @since v0.26.0
     * @category Object
     * @sig {k: v} -> {k: v} -> {k: v}
     * @param {Object} l
     * @param {Object} r
     * @return {Object}
     * @see R.mergeRight, R.mergeDeepLeft, R.mergeWith, R.mergeWithKey
     * @example
     *
     *      R.mergeLeft({ 'age': 40 }, { 'name': 'fred', 'age': 10 });
     *      //=> { 'name': 'fred', 'age': 40 }
     *
     *      const resetToDefault = R.mergeLeft({x: 0});
     *      resetToDefault({x: 5, y: 2}); //=> {x: 0, y: 2}
     * @symb R.mergeLeft(a, b) = {...b, ...a}
     */

    var mergeLeft =
    /*#__PURE__*/
    _curry2(function mergeLeft(l, r) {
      return _objectAssign$1({}, r, l);
    });

    /**
     * Multiplies two numbers. Equivalent to `a * b` but curried.
     *
     * @func
     * @memberOf R
     * @since v0.1.0
     * @category Math
     * @sig Number -> Number -> Number
     * @param {Number} a The first value.
     * @param {Number} b The second value.
     * @return {Number} The result of `a * b`.
     * @see R.divide
     * @example
     *
     *      const double = R.multiply(2);
     *      const triple = R.multiply(3);
     *      double(3);       //=>  6
     *      triple(4);       //=> 12
     *      R.multiply(2, 5);  //=> 10
     */

    var multiply =
    /*#__PURE__*/
    _curry2(function multiply(a, b) {
      return a * b;
    });

    /**
     * Negates its argument.
     *
     * @func
     * @memberOf R
     * @since v0.9.0
     * @category Math
     * @sig Number -> Number
     * @param {Number} n
     * @return {Number}
     * @example
     *
     *      R.negate(42); //=> -42
     */

    var negate =
    /*#__PURE__*/
    _curry1(function negate(n) {
      return -n;
    });

    /**
     * Returns a partial copy of an object omitting the keys specified.
     *
     * @func
     * @memberOf R
     * @since v0.1.0
     * @category Object
     * @sig [String] -> {String: *} -> {String: *}
     * @param {Array} names an array of String property names to omit from the new object
     * @param {Object} obj The object to copy from
     * @return {Object} A new object with properties from `names` not on it.
     * @see R.pick
     * @example
     *
     *      R.omit(['a', 'd'], {a: 1, b: 2, c: 3, d: 4}); //=> {b: 2, c: 3}
     */

    var omit =
    /*#__PURE__*/
    _curry2(function omit(names, obj) {
      var result = {};
      var index = {};
      var idx = 0;
      var len = names.length;

      while (idx < len) {
        index[names[idx]] = 1;
        idx += 1;
      }

      for (var prop in obj) {
        if (!index.hasOwnProperty(prop)) {
          result[prop] = obj[prop];
        }
      }

      return result;
    });

    /**
     * Returns `true` if the specified object property is equal, in
     * [`R.equals`](#equals) terms, to the given value; `false` otherwise.
     * You can test multiple properties with [`R.whereEq`](#whereEq).
     *
     * @func
     * @memberOf R
     * @since v0.1.0
     * @category Relation
     * @sig String -> a -> Object -> Boolean
     * @param {String} name
     * @param {*} val
     * @param {*} obj
     * @return {Boolean}
     * @see R.whereEq, R.propSatisfies, R.equals
     * @example
     *
     *      const abby = {name: 'Abby', age: 7, hair: 'blond'};
     *      const fred = {name: 'Fred', age: 12, hair: 'brown'};
     *      const rusty = {name: 'Rusty', age: 10, hair: 'brown'};
     *      const alois = {name: 'Alois', age: 15, disposition: 'surly'};
     *      const kids = [abby, fred, rusty, alois];
     *      const hasBrownHair = R.propEq('hair', 'brown');
     *      R.filter(hasBrownHair, kids); //=> [fred, rusty]
     */

    var propEq =
    /*#__PURE__*/
    _curry3(function propEq(name, val, obj) {
      return equals(val, obj[name]);
    });

    /**
     * Converts an object into an array of key, value arrays. Only the object's
     * own properties are used.
     * Note that the order of the output array is not guaranteed to be consistent
     * across different JS platforms.
     *
     * @func
     * @memberOf R
     * @since v0.4.0
     * @category Object
     * @sig {String: *} -> [[String,*]]
     * @param {Object} obj The object to extract from
     * @return {Array} An array of key, value arrays from the object's own properties.
     * @see R.fromPairs
     * @example
     *
     *      R.toPairs({a: 1, b: 2, c: 3}); //=> [['a', 1], ['b', 2], ['c', 3]]
     */

    var toPairs =
    /*#__PURE__*/
    _curry1(function toPairs(obj) {
      var pairs = [];

      for (var prop in obj) {
        if (_has(prop, obj)) {
          pairs[pairs.length] = [prop, obj[prop]];
        }
      }

      return pairs;
    });

    var pipeDivide = flip(divide);
    var hasNoValue = anyPass([isEmpty, isNil]);
    var isNotEmpty = pipe(isEmpty, not);
    var isNotNil = pipe(isNil, not);
    var hasValue = allPass([isNotEmpty, isNotNil]);

    var propIsNil = function propIsNil(property) {
      return pipe(prop(property), isNil);
    };

    var toStringWithSpaces = function toStringWithSpaces(array) {
      return array.join(' ');
    };

    var noop = function noop() {};

    // @ts-expect-error ts-migrate(7016) FIXME: Try `npm install @types/ramda` if it exists or add... Remove this comment to see the full error message

    var appendUnit = function appendUnit(unit) {
      return function (val) {
        return "" + val + unit;
      };
    };

    var calcPercentage = function calcPercentage(divisor) {
      return pipe(pipeDivide(divisor), multiply(100), toString$1, appendUnit('%'));
    };

    var appendUnitToCollection = function appendUnitToCollection(unit) {
      return map(appendUnit(unit));
    };

    var operateTwoUnitValues = function operateTwoUnitValues(method) {
      return function (valA) {
        return function (valB) {
          var _a = getValueAndUnit(valA),
              valueA = _a[0],
              unitA = _a[1];

          var _b = getValueAndUnit(valB),
              valueB = _b[0],
              unitB = _b[1];

          var unitToUse = unitA || unitB || 'px';
          return "" + method(valueA, valueB) + unitToUse;
        };
      };
    };

    var addTwoUnitValues = operateTwoUnitValues(add);

    /*
    object-assign
    (c) Sindre Sorhus
    @license MIT
    */
    /* eslint-disable no-unused-vars */
    var getOwnPropertySymbols = Object.getOwnPropertySymbols;
    var hasOwnProperty = Object.prototype.hasOwnProperty;
    var propIsEnumerable = Object.prototype.propertyIsEnumerable;

    function toObject(val) {
    	if (val === null || val === undefined) {
    		throw new TypeError('Object.assign cannot be called with null or undefined');
    	}

    	return Object(val);
    }

    function shouldUseNative() {
    	try {
    		if (!Object.assign) {
    			return false;
    		}

    		// Detect buggy property enumeration order in older V8 versions.

    		// https://bugs.chromium.org/p/v8/issues/detail?id=4118
    		var test1 = new String('abc');  // eslint-disable-line no-new-wrappers
    		test1[5] = 'de';
    		if (Object.getOwnPropertyNames(test1)[0] === '5') {
    			return false;
    		}

    		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
    		var test2 = {};
    		for (var i = 0; i < 10; i++) {
    			test2['_' + String.fromCharCode(i)] = i;
    		}
    		var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
    			return test2[n];
    		});
    		if (order2.join('') !== '0123456789') {
    			return false;
    		}

    		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
    		var test3 = {};
    		'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
    			test3[letter] = letter;
    		});
    		if (Object.keys(Object.assign({}, test3)).join('') !==
    				'abcdefghijklmnopqrst') {
    			return false;
    		}

    		return true;
    	} catch (err) {
    		// We don't expect any of the above to throw, but better to be safe.
    		return false;
    	}
    }

    var objectAssign = shouldUseNative() ? Object.assign : function (target, source) {
    	var from;
    	var to = toObject(target);
    	var symbols;

    	for (var s = 1; s < arguments.length; s++) {
    		from = Object(arguments[s]);

    		for (var key in from) {
    			if (hasOwnProperty.call(from, key)) {
    				to[key] = from[key];
    			}
    		}

    		if (getOwnPropertySymbols) {
    			symbols = getOwnPropertySymbols(from);
    			for (var i = 0; i < symbols.length; i++) {
    				if (propIsEnumerable.call(from, symbols[i])) {
    					to[symbols[i]] = from[symbols[i]];
    				}
    			}
    		}
    	}

    	return to;
    };

    var merge = function merge(a, b) {
      var result = objectAssign({}, a, b);

      for (var key in a) {
        var _assign;

        if (!a[key] || typeof b[key] !== 'object') continue;
        objectAssign(result, (_assign = {}, _assign[key] = objectAssign(a[key], b[key]), _assign));
      }

      return result;
    }; // sort object-value responsive styles

    var sort = function sort(obj) {
      var next = {};
      Object.keys(obj).sort(function (a, b) {
        return a.localeCompare(b, undefined, {
          numeric: true,
          sensitivity: 'base'
        });
      }).forEach(function (key) {
        next[key] = obj[key];
      });
      return next;
    };

    var defaults = {
      breakpoints: [40, 52, 64].map(function (n) {
        return n + 'em';
      })
    };

    var createMediaQuery = function createMediaQuery(n) {
      return "@media screen and (min-width: " + n + ")";
    };

    var get = function get(obj, key, def, p, undef) {
      key = key && key.split ? key.split('.') : [key];

      for (p = 0; p < key.length; p++) {
        obj = obj ? obj[key[p]] : undef;
      }

      return obj === undef ? def : obj;
    };
    var createParser = function createParser(config) {
      var cache = {};

      var parse = function parse(props) {
        var styles = {};
        var shouldSort = false;
        var isCacheDisabled = props.theme && props.theme.disableStyledSystemCache;

        for (var key in props) {
          if (!config[key]) continue;
          var sx = config[key];
          var raw = props[key];
          var scale = get(props.theme, sx.scale, sx.defaults);

          if (typeof raw === 'object') {
            cache.breakpoints = !isCacheDisabled && cache.breakpoints || get(props.theme, 'breakpoints', defaults.breakpoints);

            if (Array.isArray(raw)) {
              cache.media = !isCacheDisabled && cache.media || [null].concat(cache.breakpoints.map(createMediaQuery));
              styles = merge(styles, parseResponsiveStyle(cache.media, sx, scale, raw, props));
              continue;
            }

            if (raw !== null) {
              styles = merge(styles, parseResponsiveObject(cache.breakpoints, sx, scale, raw, props));
              shouldSort = true;
            }

            continue;
          }

          objectAssign(styles, sx(raw, scale, props));
        } // sort object-based responsive styles


        if (shouldSort) {
          styles = sort(styles);
        }

        return styles;
      };

      parse.config = config;
      parse.propNames = Object.keys(config);
      parse.cache = cache;
      var keys = Object.keys(config).filter(function (k) {
        return k !== 'config';
      });

      if (keys.length > 1) {
        keys.forEach(function (key) {
          var _createParser;

          parse[key] = createParser((_createParser = {}, _createParser[key] = config[key], _createParser));
        });
      }

      return parse;
    };

    var parseResponsiveStyle = function parseResponsiveStyle(mediaQueries, sx, scale, raw, _props) {
      var styles = {};
      raw.slice(0, mediaQueries.length).forEach(function (value, i) {
        var media = mediaQueries[i];
        var style = sx(value, scale, _props);

        if (!media) {
          objectAssign(styles, style);
        } else {
          var _assign2;

          objectAssign(styles, (_assign2 = {}, _assign2[media] = objectAssign({}, styles[media], style), _assign2));
        }
      });
      return styles;
    };

    var parseResponsiveObject = function parseResponsiveObject(breakpoints, sx, scale, raw, _props) {
      var styles = {};

      for (var key in raw) {
        var breakpoint = breakpoints[key];
        var value = raw[key];
        var style = sx(value, scale, _props);

        if (!breakpoint) {
          objectAssign(styles, style);
        } else {
          var _assign3;

          var media = createMediaQuery(breakpoint);
          objectAssign(styles, (_assign3 = {}, _assign3[media] = objectAssign({}, styles[media], style), _assign3));
        }
      }

      return styles;
    };

    function _extends$1() { _extends$1 = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends$1.apply(this, arguments); }

    // based on https://github.com/developit/dlv
    var get$1 = function get(obj, key, def, p, undef) {
      key = key && key.split ? key.split('.') : [key];

      for (p = 0; p < key.length; p++) {
        obj = obj ? obj[key[p]] : undef;
      }

      return obj === undef ? def : obj;
    };
    var defaultBreakpoints = [40, 52, 64].map(function (n) {
      return n + 'em';
    });
    var defaultTheme = {
      space: [0, 4, 8, 16, 32, 64, 128, 256, 512],
      fontSizes: [12, 14, 16, 20, 24, 32, 48, 64, 72]
    };
    var aliases = {
      bg: 'backgroundColor',
      m: 'margin',
      mt: 'marginTop',
      mr: 'marginRight',
      mb: 'marginBottom',
      ml: 'marginLeft',
      mx: 'marginX',
      my: 'marginY',
      p: 'padding',
      pt: 'paddingTop',
      pr: 'paddingRight',
      pb: 'paddingBottom',
      pl: 'paddingLeft',
      px: 'paddingX',
      py: 'paddingY'
    };
    var multiples = {
      marginX: ['marginLeft', 'marginRight'],
      marginY: ['marginTop', 'marginBottom'],
      paddingX: ['paddingLeft', 'paddingRight'],
      paddingY: ['paddingTop', 'paddingBottom'],
      size: ['width', 'height']
    };
    var scales = {
      color: 'colors',
      backgroundColor: 'colors',
      borderColor: 'colors',
      margin: 'space',
      marginTop: 'space',
      marginRight: 'space',
      marginBottom: 'space',
      marginLeft: 'space',
      marginX: 'space',
      marginY: 'space',
      padding: 'space',
      paddingTop: 'space',
      paddingRight: 'space',
      paddingBottom: 'space',
      paddingLeft: 'space',
      paddingX: 'space',
      paddingY: 'space',
      top: 'space',
      right: 'space',
      bottom: 'space',
      left: 'space',
      gridGap: 'space',
      gridColumnGap: 'space',
      gridRowGap: 'space',
      gap: 'space',
      columnGap: 'space',
      rowGap: 'space',
      fontFamily: 'fonts',
      fontSize: 'fontSizes',
      fontWeight: 'fontWeights',
      lineHeight: 'lineHeights',
      letterSpacing: 'letterSpacings',
      border: 'borders',
      borderTop: 'borders',
      borderRight: 'borders',
      borderBottom: 'borders',
      borderLeft: 'borders',
      borderWidth: 'borderWidths',
      borderStyle: 'borderStyles',
      borderRadius: 'radii',
      borderTopRightRadius: 'radii',
      borderTopLeftRadius: 'radii',
      borderBottomRightRadius: 'radii',
      borderBottomLeftRadius: 'radii',
      borderTopWidth: 'borderWidths',
      borderTopColor: 'colors',
      borderTopStyle: 'borderStyles',
      borderBottomWidth: 'borderWidths',
      borderBottomColor: 'colors',
      borderBottomStyle: 'borderStyles',
      borderLeftWidth: 'borderWidths',
      borderLeftColor: 'colors',
      borderLeftStyle: 'borderStyles',
      borderRightWidth: 'borderWidths',
      borderRightColor: 'colors',
      borderRightStyle: 'borderStyles',
      outlineColor: 'colors',
      boxShadow: 'shadows',
      textShadow: 'shadows',
      zIndex: 'zIndices',
      width: 'sizes',
      minWidth: 'sizes',
      maxWidth: 'sizes',
      height: 'sizes',
      minHeight: 'sizes',
      maxHeight: 'sizes',
      flexBasis: 'sizes',
      size: 'sizes',
      // svg
      fill: 'colors',
      stroke: 'colors'
    };

    var positiveOrNegative = function positiveOrNegative(scale, value) {
      if (typeof value !== 'number' || value >= 0) {
        return get$1(scale, value, value);
      }

      var absolute = Math.abs(value);
      var n = get$1(scale, absolute, absolute);
      if (typeof n === 'string') return '-' + n;
      return n * -1;
    };

    var transforms = ['margin', 'marginTop', 'marginRight', 'marginBottom', 'marginLeft', 'marginX', 'marginY', 'top', 'bottom', 'left', 'right'].reduce(function (acc, curr) {
      var _extends2;

      return _extends$1({}, acc, (_extends2 = {}, _extends2[curr] = positiveOrNegative, _extends2));
    }, {});
    var responsive = function responsive(styles) {
      return function (theme) {
        var next = {};
        var breakpoints = get$1(theme, 'breakpoints', defaultBreakpoints);
        var mediaQueries = [null].concat(breakpoints.map(function (n) {
          return "@media screen and (min-width: " + n + ")";
        }));

        for (var key in styles) {
          var value = typeof styles[key] === 'function' ? styles[key](theme) : styles[key];
          if (value == null) continue;

          if (!Array.isArray(value)) {
            next[key] = value;
            continue;
          }

          for (var i = 0; i < value.slice(0, mediaQueries.length).length; i++) {
            var media = mediaQueries[i];

            if (!media) {
              next[key] = value[i];
              continue;
            }

            next[media] = next[media] || {};
            if (value[i] == null) continue;
            next[media][key] = value[i];
          }
        }

        return next;
      };
    };
    var css = function css(args) {
      return function (props) {
        if (props === void 0) {
          props = {};
        }

        var theme = _extends$1({}, defaultTheme, {}, props.theme || props);

        var result = {};
        var obj = typeof args === 'function' ? args(theme) : args;
        var styles = responsive(obj)(theme);

        for (var key in styles) {
          var x = styles[key];
          var val = typeof x === 'function' ? x(theme) : x;

          if (key === 'variant') {
            var variant = css(get$1(theme, val))(theme);
            result = _extends$1({}, result, {}, variant);
            continue;
          }

          if (val && typeof val === 'object') {
            result[key] = css(val)(theme);
            continue;
          }

          var prop = get$1(aliases, key, key);
          var scaleName = get$1(scales, prop);
          var scale = get$1(theme, scaleName, get$1(theme, prop, {}));
          var transform = get$1(transforms, prop, get$1);
          var value = transform(scale, val, val);

          if (multiples[prop]) {
            var dirs = multiples[prop];

            for (var i = 0; i < dirs.length; i++) {
              result[dirs[i]] = value;
            }
          } else {
            result[prop] = value;
          }
        }

        return result;
      };
    };

    // @ts-expect-error ts-migrate(7016) FIXME: Try `npm install @types/styled-system__core` if it... Remove this comment to see the full error message

    var variant = function variant(_a) {
      var _b;

      var scale = _a.scale,
          _c = _a.prop,
          prop = _c === void 0 ? 'variant' : _c,
          // Custom property to force theme lookup instead of having to supply a filler `variants` object
      _d = _a.forceThemeUsage,
          // Custom property to force theme lookup instead of having to supply a filler `variants` object
      forceThemeUsage = _d === void 0 ? true : _d,
          // enables new api
      _e = _a.variants,
          // enables new api
      variants = _e === void 0 ? {} : _e,
          // shim for v4 API
      key = _a.key;
      var sx;

      if (forceThemeUsage || Object.keys(variants).length) {
        sx = function sx(value, scale, props) {
          return css(get(scale, value, null))(props.theme);
        };
      } else {
        sx = function sx(value, scale) {
          return get(scale, value, null);
        };
      } // @ts-expect-error ts-migrate(2339) FIXME: Property 'scale' does not exist on type '(value: a... Remove this comment to see the full error message


      sx.scale = scale || key; // @ts-expect-error ts-migrate(2339) FIXME: Property 'defaults' does not exist on type '(value... Remove this comment to see the full error message

      sx.defaults = variants;
      var config = (_b = {}, _b[prop] = sx, _b);
      var parser = createParser(config);
      return parser;
    };

    var topBottomLeftRight = function topBottomLeftRight(val) {
      return styled.css(templateObject_1$1 || (templateObject_1$1 = __makeTemplateObject(["\n  top: ", ";\n  bottom: ", ";\n  left: ", ";\n  right: ", ";\n"], ["\n  top: ", ";\n  bottom: ", ";\n  left: ", ";\n  right: ", ";\n"])), val, val, val, val);
    };

    var positionAbsoluteCenter = styled.css(templateObject_2$1 || (templateObject_2$1 = __makeTemplateObject(["\n  position: absolute;\n  top: 50%;\n  left: 50%;\n  transform: translate(-50%, -50%);\n"], ["\n  position: absolute;\n  top: 50%;\n  left: 50%;\n  transform: translate(-50%, -50%);\n"])));

    var applyStylesGivenProperty = function applyStylesGivenProperty(property, styles) {
      return function (props) {
        if (props[property] === true) {
          return styles;
        }
      };
    };

    var textVariantFunction = function textVariantFunction(textVariantName) {
      return function (_a) {
        var theme = _a.theme;
        return variant({
          scale: 'textVariants'
        })({
          theme: theme,
          variant: textVariantName
        });
      };
    };
    var templateObject_1$1, templateObject_2$1;

    var isNumber = function isNumber(number) {
      return typeof number === 'number' && !isNaN(number);
    };

    var negate$1 = function negate(value, valueType) {
      return valueType === 'number' ? value * -1 : "-" + value;
    };

    var normalizeValue = function normalizeValue(_a) {
      var value = _a.value,
          isNegative = _a.isNegative,
          valueType = _a.valueType;
      return isNegative ? negate$1(value, valueType) : value;
    };

    // @ts-expect-error ts-migrate(7016) FIXME: Try `npm install @types/styled-system` if it exist... Remove this comment to see the full error message

    var getMarginNumber = function getMarginNumber(number) {
      var isNegative = number < 0;
      var absoluteValue = Math.abs(number);
      return {
        isNegative: isNegative,
        rawToken: absoluteValue
      };
    };

    var getMarginString = function getMarginString(token) {
      var isNegative = token.slice(0, 1) === '-';
      var rawToken = isNegative ? token.slice(1) : token;
      return {
        isNegative: isNegative,
        rawToken: rawToken
      };
    };
    /**
     * Transform for the custom margin implementation.
     * See https://styled-system.com/custom-props/#transform for more context
     */


    var getMargin = function getMargin(token, scale) {
      if (token === undefined || token === null) {
        return token;
      }

      var valueType = isNumber(token) ? 'number' : 'string';

      var _a = valueType === 'number' ? // @ts-expect-error ts-migrate(2554) FIXME: Expected 1 arguments, but got 2.
      getMarginNumber(token) : // @ts-expect-error ts-migrate(2554) FIXME: Expected 1 arguments, but got 2.
      getMarginString(token),
          rawToken = _a.rawToken,
          isNegative = _a.isNegative;

      var value = styledSystem.get(scale, rawToken, rawToken);
      return normalizeValue({
        value: value,
        isNegative: isNegative,
        valueType: valueType
      });
    };

    // @ts-expect-error ts-migrate(7016) FIXME: Try `npm install @types/styled-system` if it exist... Remove this comment to see the full error message
    var config = {
      margin: {
        property: 'margin',
        scale: 'space',
        transform: getMargin
      },
      marginTop: {
        property: 'marginTop',
        scale: 'space',
        transform: getMargin
      },
      marginRight: {
        property: 'marginRight',
        scale: 'space',
        transform: getMargin
      },
      marginBottom: {
        property: 'marginBottom',
        scale: 'space',
        transform: getMargin
      },
      marginLeft: {
        property: 'marginLeft',
        scale: 'space',
        transform: getMargin
      },
      marginX: {
        properties: ['marginLeft', 'marginRight'],
        scale: 'space',
        transform: getMargin
      },
      marginY: {
        properties: ['marginTop', 'marginBottom'],
        scale: 'space',
        transform: getMargin
      }
    }; // @ts-expect-error ts-migrate(2339) FIXME: Property 'm' does not exist on type '{ margin: { p... Remove this comment to see the full error message

    config.m = config.margin; // @ts-expect-error ts-migrate(2339) FIXME: Property 'mt' does not exist on type '{ margin: { ... Remove this comment to see the full error message

    config.mt = config.marginTop; // @ts-expect-error ts-migrate(2339) FIXME: Property 'mr' does not exist on type '{ margin: { ... Remove this comment to see the full error message

    config.mr = config.marginRight; // @ts-expect-error ts-migrate(2339) FIXME: Property 'mb' does not exist on type '{ margin: { ... Remove this comment to see the full error message

    config.mb = config.marginBottom; // @ts-expect-error ts-migrate(2339) FIXME: Property 'ml' does not exist on type '{ margin: { ... Remove this comment to see the full error message

    config.ml = config.marginLeft; // @ts-expect-error ts-migrate(2339) FIXME: Property 'mx' does not exist on type '{ margin: { ... Remove this comment to see the full error message

    config.mx = config.marginX; // @ts-expect-error ts-migrate(2339) FIXME: Property 'my' does not exist on type '{ margin: { ... Remove this comment to see the full error message

    config.my = config.marginY;
    var margin = styledSystem.system(config);

    // @ts-expect-error ts-migrate(7016) FIXME: Try `npm install @types/styled-system` if it exist... Remove this comment to see the full error message
    /**
     * Note: this does not cover all outline properties, as the primary use case here
     * should be to reset `outline`, not apply specific styles
     */

    var outline = styledSystem.system({
      outline: true
    });

    // @ts-expect-error ts-migrate(7016) FIXME: Try `npm install @types/styled-system` if it exist... Remove this comment to see the full error message
    /**
     * Styled System's `shadow` allows for text shadows. 🙅‍ no thx.
     */

    var shadow = styledSystem.system({
      boxShadow: {
        property: 'boxShadow',
        scale: 'shadows'
      }
    });

    // @ts-expect-error ts-migrate(7016) FIXME: Try `npm install @types/styled-system` if it exist... Remove this comment to see the full error message

    var transition = styledSystem.system({
      prop: 'transition',
      transition: {
        property: 'transition',
        scale: 'transitions'
      }
    });
    var transitionProperty = styledSystem.system({
      transitionProperty: true
    });
    var timing = styledSystem.system({
      prop: 'timing',
      timing: {
        property: 'transition-duration',
        scale: 'timings'
      }
    });
    var easing = styledSystem.system({
      prop: 'easing',
      easing: {
        property: 'transition-timing-function',
        scale: 'easings'
      }
    });

    var styledSystemAbilities = styledSystem.compose(styledSystem.background, styledSystem.border, styledSystem.color, styledSystem.flexbox, styledSystem.grid, styledSystem.layout, styledSystem.padding, styledSystem.position, styledSystem.typography);
    var roadmunkDesignSystemStyleAbilities = styledSystem.compose(margin, shadow, easing, outline, timing, transition, transitionProperty);
    var Box = styled__default['default'].div(templateObject_1$2 || (templateObject_1$2 = __makeTemplateObject(["\n  ", ";\n  ", ";\n"], ["\n  ", ";\n  ", ";\n"])), styledSystemAbilities, roadmunkDesignSystemStyleAbilities);
    var templateObject_1$2;

    // @ts-expect-error ts-migrate(7016) FIXME: Try `npm install @types/ramda` if it exists or add... Remove this comment to see the full error message
    var getAsProp = function getAsProp(_a, _b) {
      var variant = _a.variant,
          semanticElement = _a.semanticElement;
      var textVariants = _b.textVariants;
      var textVariantSpec = prop(variant, textVariants);
      return semanticElement || path(['meta', 'defaultSemantic'], textVariantSpec);
    };

    var themeGet = function themeGet(path, fallback) {
      if (fallback === void 0) {
        fallback = null;
      }

      return function (props) {
        return get(props.theme, path, fallback);
      };
    };

    var styleVariantOptions = {
      error: 'colors.rose60',
      success: 'colors.grass60',
      understated: 'colors.black70'
    };
    var textVariantStyles = variant({
      scale: 'textVariants'
    });
    var overridePropStyles = styledSystem.compose(styledSystem.typography, styledSystem.color);
    var emphasisStyles = styled.css(templateObject_1$3 || (templateObject_1$3 = __makeTemplateObject(["\n  strong,\n  b {\n    font-weight: ", ";\n  }\n"], ["\n  strong,\n  b {\n    font-weight: ", ";\n  }\n"])), themeGet('fontWeights.bold'));
    var anchorUnderlineStyles = styled.css(templateObject_2$2 || (templateObject_2$2 = __makeTemplateObject(["\n  text-decoration: none;\n  background-position: 0 100%;\n  background-repeat: no-repeat;\n  background-size: 100% 0;\n  :hover,\n  :focus,\n  :active {\n    background-size: 100% 1px;\n  }\n"], ["\n  text-decoration: none;\n  background-position: 0 100%;\n  background-repeat: no-repeat;\n  background-size: 100% 0;\n  :hover,\n  :focus,\n  :active {\n    background-size: 100% 1px;\n  }\n"])));

    var makeAnchorUnderlineStyle = function makeAnchorUnderlineStyle(color) {
      return styled.css(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  color: ", ";\n  background-image: linear-gradient(", ", ", ");\n"], ["\n  color: ", ";\n  background-image: linear-gradient(", ", ", ");\n"])), color, color, color);
    };

    var anchorStyles = styled.css(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  ", ";\n  transition-property: background-size, color;\n  /* TODO: move these to tokens https://roadmunk.atlassian.net/browse/DS-281 */\n  transition-duration: 200ms;\n  transition-timing-function: ease-in-out;\n  ", ";\n  :hover {\n    ", ";\n  }\n  :active,\n  :focus {\n    ", ";\n  }\n"], ["\n  ", ";\n  transition-property: background-size, color;\n  /* TODO: move these to tokens https://roadmunk.atlassian.net/browse/DS-281 */\n  transition-duration: 200ms;\n  transition-timing-function: ease-in-out;\n  ", ";\n  :hover {\n    ", ";\n  }\n  :active,\n  :focus {\n    ", ";\n  }\n"])), anchorUnderlineStyles, makeAnchorUnderlineStyle(themeGet('colors.blue50')), makeAnchorUnderlineStyle(themeGet('colors.blue40')), makeAnchorUnderlineStyle(themeGet('colors.blue60')));

    var styleVariantStyles = function styleVariantStyles(styleVariant) {
      return styled.css(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  color: ", ";\n"], ["\n  color: ", ";\n"])), themeGet( // @ts-expect-error ts-migrate(7053) FIXME: Element implicitly has an 'any' type because expre... Remove this comment to see the full error message
      styleVariantOptions[styleVariant]));
    };

    var StyledText = styled__default['default'].h1(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n  margin-top: 0;\n  margin-bottom: 0;\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  a {\n    ", ";\n  }\n"], ["\n  margin-top: 0;\n  margin-bottom: 0;\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  a {\n    ", ";\n  }\n"])), textVariantStyles, overridePropStyles, function (_a) {
      var // @ts-expect-error ts-migrate(2339) FIXME: Property 'styleVariant' does not exist on type 'Pi... Remove this comment to see the full error message
      styleVariant = _a.styleVariant;
      return styleVariant && styleVariantStyles(styleVariant);
    }, emphasisStyles, anchorStyles);
    var templateObject_1$3, templateObject_2$2, templateObject_3, templateObject_4, templateObject_5, templateObject_6;

    // this pattern should be removed and usages should directly reference the theme

    var transparentBlueTransforms = {
      idle: curriedTransparentize(1),
      focus: curriedTransparentize(1),
      hover: curriedTransparentize(0.9),
      active: curriedTransparentize(0.8),
      disabled: curriedTransparentize(1)
    };
    var transparentAltTransforms = {
      idle: curriedTransparentize(1),
      focus: curriedTransparentize(1),
      hover: curriedTransparentize(0.95),
      active: curriedTransparentize(0.9),
      disabled: curriedTransparentize(1)
    };
    var transparentInverseTransforms = {
      idle: curriedTransparentize(1),
      focus: curriedTransparentize(1),
      hover: curriedTransparentize(0.9),
      active: curriedTransparentize(0.8),
      disabled: curriedTransparentize(1)
    };

    var transformColorGivenTransforms = function transformColorGivenTransforms(color, transformsDictionary) {
      var transformedTuples = Object.entries(transformsDictionary).map(function (_a) {
        var key = _a[0],
            transform = _a[1];
        return [key, transform(color)];
      });
      return Object.fromEntries(transformedTuples);
    };

    var _a, _b, _c; // @ts-expect-error ts-migrate(7016) FIXME: Try `npm install @types/roadmunk__ds-tokens` if it... Remove this comment to see the full error message
    var solidDisabledStyles = (_a = {
      backgroundColor: 'sand20',
      borderColor: 'sand20'
    }, _a[StyledText] = {
      color: 'sand50'
    }, _a);
    var sharedOutlineDisabledStyles = (_b = {
      borderColor: 'sand40'
    }, _b[StyledText] = {
      color: 'sand50'
    }, _b);
    var sharedGhostDisabledStyles = (_c = {}, _c[StyledText] = {
      color: 'sand50'
    }, _c);
    var transparentBlueColors = transformColorGivenTransforms(dsTokens.colors.blue50, transparentBlueTransforms);
    var transparentAltColors = transformColorGivenTransforms(dsTokens.colors.midnight60, transparentAltTransforms);
    var transparentInverseColors = transformColorGivenTransforms(dsTokens.colors.white, transparentInverseTransforms);

    var _a$1, _b$1, _c$1, _d, _e, _f, _g, _h;
    var buttonVariants = {
      solidBlue: (_a$1 = {
        backgroundColor: 'blue50',
        borderColor: 'blue50'
      }, _a$1[StyledText] = {
        color: 'white'
      }, _a$1['&:focus'] = {
        backgroundColor: 'blue50'
      }, _a$1['&:hover'] = {
        backgroundColor: 'blue40',
        borderColor: 'blue40',
        boxShadow: 'medium'
      }, _a$1['&:active'] = {
        backgroundColor: 'blue60',
        borderColor: 'blue60',
        boxShadow: 'small'
      }, _a$1['&:disabled'] = solidDisabledStyles, _a$1),
      solidAlt: (_b$1 = {
        backgroundColor: 'sand20',
        borderColor: 'sand20'
      }, _b$1[StyledText] = {
        color: 'black90'
      }, _b$1['&:focus'] = {
        backgroundColor: 'sand20'
      }, _b$1['&:hover'] = {
        backgroundColor: 'sand30',
        borderColor: 'sand30',
        boxShadow: 'medium'
      }, _b$1['&:active'] = {
        backgroundColor: 'sand40',
        borderColor: 'sand40',
        boxShadow: 'small'
      }, _b$1['&:disabled'] = solidDisabledStyles, _b$1),
      outlineBlue: (_c$1 = {
        backgroundColor: transparentBlueColors.idle,
        borderColor: 'blue50'
      }, _c$1[StyledText] = {
        color: 'blue50'
      }, _c$1['&:focus'] = {
        backgroundColor: transparentBlueColors.focus
      }, _c$1['&:hover'] = {
        backgroundColor: transparentBlueColors.hover
      }, _c$1['&:active'] = {
        backgroundColor: transparentBlueColors.active
      }, _c$1['&:disabled'] = __assign(__assign({}, sharedOutlineDisabledStyles), {
        backgroundColor: transparentBlueColors.disabled
      }), _c$1),
      outlineAlt: (_d = {
        backgroundColor: transparentAltColors.idle,
        borderColor: 'sand60'
      }, _d[StyledText] = {
        color: 'black90'
      }, _d['&:focus'] = {
        backgroundColor: transparentAltColors.focus
      }, _d['&:hover'] = {
        backgroundColor: transparentAltColors.hover
      }, _d['&:active'] = {
        backgroundColor: transparentAltColors.active
      }, _d['&:disabled'] = __assign(__assign({}, sharedOutlineDisabledStyles), {
        backgroundColor: transparentAltColors.disabled
      }), _d),
      outlineInverse: (_e = {
        backgroundColor: transparentInverseColors.idle,
        borderColor: 'sand10'
      }, _e[StyledText] = {
        color: 'sand20'
      }, _e['&:focus'] = {
        backgroundColor: transparentInverseColors.focus
      }, _e['&:hover'] = {
        backgroundColor: transparentInverseColors.hover
      }, _e['&:active'] = {
        backgroundColor: transparentInverseColors.active
      }, _e['&:disabled'] = __assign(__assign({}, sharedOutlineDisabledStyles), {
        backgroundColor: transparentInverseColors.disabled,
        borderColor: 'sand50'
      }), _e),

      /**
       * NOTE: for ghost buttons, the border has to stay at the idle value, or
       * else the border and the background stack on each other.
       * `focusRing`'s styling does not care about this, as it is fully opaque
       */
      ghostBlue: (_f = {
        backgroundColor: transparentBlueColors.idle,
        borderColor: transparentBlueColors.idle
      }, _f[StyledText] = {
        color: 'blue50'
      }, _f['&:focus'] = {
        backgroundColor: transparentBlueColors.focus,
        borderColor: transparentBlueColors.idle
      }, _f['&:hover'] = {
        backgroundColor: transparentBlueColors.hover,
        borderColor: transparentBlueColors.idle
      }, _f['&:active'] = {
        backgroundColor: transparentBlueColors.active,
        borderColor: transparentBlueColors.idle
      }, _f['&:disabled'] = __assign(__assign({}, sharedGhostDisabledStyles), {
        backgroundColor: transparentBlueColors.disabled,
        borderColor: transparentBlueColors.disabled
      }), _f),
      ghostAlt: (_g = {
        backgroundColor: transparentAltColors.idle,
        borderColor: transparentAltColors.idle
      }, _g[StyledText] = {
        color: 'black90'
      }, _g['&:focus'] = {
        backgroundColor: transparentAltColors.focus,
        borderColor: transparentAltColors.idle
      }, _g['&:hover'] = {
        backgroundColor: transparentAltColors.hover,
        borderColor: transparentAltColors.idle
      }, _g['&:active'] = {
        backgroundColor: transparentAltColors.active,
        borderColor: transparentAltColors.idle
      }, _g['&:disabled'] = __assign(__assign({}, sharedGhostDisabledStyles), {
        backgroundColor: transparentAltColors.disabled,
        borderColor: transparentAltColors.disabled
      }), _g),
      ghostInverse: (_h = {
        backgroundColor: transparentInverseColors.idle,
        borderColor: transparentInverseColors.idle
      }, _h[StyledText] = {
        color: 'sand20'
      }, _h['&:focus'] = {
        backgroundColor: transparentInverseColors.focus,
        borderColor: transparentInverseColors.idle
      }, _h['&:hover'] = {
        backgroundColor: transparentInverseColors.hover,
        borderColor: transparentInverseColors.idle
      }, _h['&:active'] = {
        backgroundColor: transparentInverseColors.active,
        borderColor: transparentInverseColors.idle
      }, _h['&:disabled'] = __assign(__assign({}, sharedGhostDisabledStyles), {
        backgroundColor: transparentInverseColors.disabled,
        borderColor: transparentInverseColors.disabled
      }), _h)
    }; // @ts-expect-error ts-migrate(2339) FIXME: Property 'default' does not exist on type '{ solid... Remove this comment to see the full error message

    buttonVariants.default = buttonVariants.solidBlue;

    var _a$2, _b$2, _c$2;
    var sharedButtonFontStyles = {
      fontWeight: 'semiBold',
      fontFamily: 'workSans'
    };
    var buttonSizes = {
      large: (_a$2 = {
        paddingY: '14px',
        paddingX: '15px',
        minWidth: '100px'
      }, _a$2[StyledText] = __assign({
        fontSize: 'large',
        lineHeight: '14px'
      }, sharedButtonFontStyles), _a$2),
      medium: (_b$2 = {
        paddingY: '10px',
        paddingX: '15px',
        minWidth: '80px'
      }, _b$2[StyledText] = __assign({
        fontSize: 'medium',
        lineHeight: '14px'
      }, sharedButtonFontStyles), _b$2),
      small: (_c$2 = {
        paddingY: '7px',
        paddingX: '11px',
        minWidth: '64px'
      }, _c$2[StyledText] = __assign({
        fontSize: 'small',
        lineHeight: '12px'
      }, sharedButtonFontStyles), _c$2)
    };

    var indexByVal = function indexByVal(finalObj, val) {
      var _a;

      return __assign(__assign({}, finalObj), (_a = {}, _a[val] = val, _a));
    };

    var semanticTextElementsArray = ['h1', 'h2', 'h3', 'h4', 'h5', 'p', 'span', 'label'];
    var semanticTextElements = semanticTextElementsArray.reduce(indexByVal, {});

    var textVariants = {
      headingXL: {
        fontFamily: 'workSans',
        fontSize: '4xLarge',
        lineHeight: 'normal',
        fontWeight: 'bold',
        letterSpacing: 'tight',
        color: 'black90',
        meta: {
          defaultSemantic: semanticTextElements.h1
        }
      },
      headingLarge: {
        fontFamily: 'workSans',
        fontSize: '3xLarge',
        lineHeight: 'normal',
        fontWeight: 'bold',
        letterSpacing: 'tight',
        color: 'black90',
        meta: {
          defaultSemantic: semanticTextElements.h2
        }
      },
      headingMedium: {
        fontFamily: 'workSans',
        fontSize: '2xLarge',
        lineHeight: 'normal',
        fontWeight: 'semiBold',
        letterSpacing: 'tight',
        color: 'black90',
        meta: {
          defaultSemantic: semanticTextElements.h3
        }
      },
      headingSmall: {
        fontFamily: 'workSans',
        fontSize: 'xLarge',
        lineHeight: 'normal',
        fontWeight: 'semiBold',
        letterSpacing: 'tight',
        color: 'black90',
        meta: {
          defaultSemantic: semanticTextElements.h4
        }
      },
      headingXS: {
        fontFamily: 'workSans',
        fontSize: 'large',
        lineHeight: 'normal',
        fontWeight: 'medium',
        letterSpacing: 'tight',
        color: 'black90',
        meta: {
          defaultSemantic: semanticTextElements.h5
        }
      },
      displayLarge: {
        fontFamily: 'workSans',
        fontSize: '5xLarge',
        lineHeight: 'normal',
        fontWeight: 'semiBold',
        letterSpacing: 'tight',
        color: 'black90',
        meta: {
          defaultSemantic: semanticTextElements.span
        }
      },
      displayMedium: {
        fontFamily: 'workSans',
        fontSize: '4xLarge',
        lineHeight: 'normal',
        fontWeight: 'semiBold',
        letterSpacing: 'tight',
        color: 'black90',
        meta: {
          defaultSemantic: semanticTextElements.span
        }
      },
      displaySmall: {
        fontFamily: 'workSans',
        fontSize: '2xLarge',
        lineHeight: 'normal',
        fontWeight: 'semiBold',
        letterSpacing: 'tight',
        color: 'black90',
        meta: {
          defaultSemantic: semanticTextElements.span
        }
      },
      copyMedium: {
        fontFamily: 'sourceSans',
        fontSize: 'medium',
        lineHeight: 'tall',
        fontWeight: 'normal',
        letterSpacing: 'normal',
        color: 'black90',
        meta: {
          defaultSemantic: semanticTextElements.p
        }
      },
      copySmall: {
        fontFamily: 'sourceSans',
        fontSize: 'small',
        lineHeight: 'tall',
        fontWeight: 'normal',
        letterSpacing: 'normal',
        color: 'black90',
        meta: {
          defaultSemantic: semanticTextElements.p
        }
      },
      copyXS: {
        fontFamily: 'sourceSans',
        fontSize: 'xSmall',
        lineHeight: 'tall',
        fontWeight: 'normal',
        letterSpacing: 'normal',
        color: 'black90',
        meta: {
          defaultSemantic: semanticTextElements.p
        }
      }
    };

    var spinnerSizeStyles = variant({
      prop: 'size',
      scale: 'spinnerSizes'
    });

    var innerAnimationStyles = function innerAnimationStyles(getDashValue) {
      return styled.keyframes(templateObject_1$4 || (templateObject_1$4 = __makeTemplateObject(["\n  0%, 25% {\n    stroke-dashoffset : ", ";\n    transform: rotate(0);\n  }\n  50%, 75% {\n    stroke-dashoffset : ", ";\n    transform: rotate(45deg);\n  }\n  100% {\n    stroke-dashoffset : ", ";\n    transform: rotate(360deg);\n  }\n"], ["\n  0%, 25% {\n    stroke-dashoffset : ", ";\n    transform: rotate(0);\n  }\n  50%, 75% {\n    stroke-dashoffset : ", ";\n    transform: rotate(45deg);\n  }\n  100% {\n    stroke-dashoffset : ", ";\n    transform: rotate(360deg);\n  }\n"])), getDashValue(0.95), getDashValue(0.25), getDashValue(0.95));
    };

    var outerAnimationStyles = styled.keyframes(templateObject_2$3 || (templateObject_2$3 = __makeTemplateObject(["\n  0% {\n    transform: rotateZ(0deg);\n  }\n  100% {\n    transform: rotateZ(360deg)\n  }\n"], ["\n  0% {\n    transform: rotateZ(0deg);\n  }\n  100% {\n    transform: rotateZ(360deg)\n  }\n"])));
    var StyledSpinnerCircle = styled__default['default'].circle(templateObject_3$1 || (templateObject_3$1 = __makeTemplateObject(["\n  fill: none;\n  stroke-dasharray: ", ";\n  transform-origin: 50% 50%;\n  stroke: ", ";\n  animation: ", "\n    1.5s infinite;\n  r: ", ";\n"], ["\n  fill: none;\n  stroke-dasharray: ", ";\n  transform-origin: 50% 50%;\n  stroke: ", ";\n  animation: ", "\n    1.5s infinite;\n  r: ", ";\n"])), function (_a) {
      var // @ts-expect-error ts-migrate(2339) FIXME: Property 'getDashValue' does not exist on type 'Pi... Remove this comment to see the full error message
      getDashValue = _a.getDashValue;
      return getDashValue(1);
    }, themeGet('colors.blue50'), function (_a) {
      var // @ts-expect-error ts-migrate(2339) FIXME: Property 'getDashValue' does not exist on type 'Pi... Remove this comment to see the full error message
      getDashValue = _a.getDashValue;
      return innerAnimationStyles(getDashValue);
    }, function (_a) {
      var radius = _a.radius;
      return radius + "px";
    });
    var StyledSpinner = styled__default['default'].svg(templateObject_4$1 || (templateObject_4$1 = __makeTemplateObject(["\n  ", ";\n  animation: ", " 2s linear infinite;\n"], ["\n  ", ";\n  animation: ", " 2s linear infinite;\n"])), spinnerSizeStyles, outerAnimationStyles);
    var templateObject_1$4, templateObject_2$3, templateObject_3$1, templateObject_4$1;

    var _a$3, _b$3, _c$3;
    var spinnerSizes = {
      small: (_a$3 = {
        width: '16px',
        height: '16px'
      }, _a$3[StyledSpinnerCircle] = {
        strokeWidth: '3px'
      }, _a$3),
      medium: (_b$3 = {
        width: '48px',
        height: '48px'
      }, _b$3[StyledSpinnerCircle] = {
        strokeWidth: '5px'
      }, _b$3),
      large: (_c$3 = {
        width: '80px',
        height: '80px'
      }, _c$3[StyledSpinnerCircle] = {
        strokeWidth: '6px'
      }, _c$3)
    };

    // @ts-expect-error ts-migrate(7016) FIXME: Try `npm install @types/roadmunk__ds-tokens` if it... Remove this comment to see the full error message
    var layout = dsTokens.space.layout;
    var breakpointsWithMeta = {
      zero: {
        width: dsTokens.breakpoints.zero,
        meta: {
          columns: 4,
          outerPadding: layout.zero
        }
      },
      small: {
        width: dsTokens.breakpoints.small,
        meta: {
          columns: 4,
          outerPadding: layout.zero
        }
      },
      medium: {
        width: dsTokens.breakpoints.medium,
        meta: {
          columns: 8,
          outerPadding: layout.xSmall
        }
      },
      large: {
        width: dsTokens.breakpoints.large,
        meta: {
          columns: 16,
          outerPadding: layout.xSmall
        }
      },
      xLarge: {
        width: dsTokens.breakpoints.xLarge,
        meta: {
          columns: 16,
          outerPadding: layout.xSmall
        }
      },
      max: {
        width: dsTokens.breakpoints.max,
        meta: {
          columns: 16,
          outerPadding: layout.small
        }
      }
    };

    var gutterSize = dsTokens.space.layout.medium;

    var _a$4 = getValueAndUnit(gutterSize),
        gutterVal = _a$4[0],
        gutterUnit = _a$4[1];

    var appendGutterUnitToCollection = appendUnitToCollection(gutterUnit);
    var gutter = gutterVal;
    var gutterHalf = gutterVal / 2;
    var baseSpaceExtensions = {
      gutter: gutter,
      gutterHalf: gutterHalf,
      gutterNegative: negate(gutter),
      gutterHalfNegative: negate(gutterHalf)
    };
    var spaceExtensions = appendGutterUnitToCollection(baseSpaceExtensions);

    var space = __assign(__assign({}, dsTokens.space), spaceExtensions);

    var theme = {
      borders: dsTokens.borders,
      borderStyles: dsTokens.borderStyles,
      borderWidths: dsTokens.borderWidths,
      breakpoints: dsTokens.breakpoints,
      breakpointsWithMeta: breakpointsWithMeta,
      buttonSizes: buttonSizes,
      buttonVariants: buttonVariants,
      colors: dsTokens.colors,
      easings: dsTokens.easings,
      fonts: dsTokens.fonts,
      fontSizes: dsTokens.fontSizes,
      fontWeights: dsTokens.fontWeights,
      letterSpacings: dsTokens.letterSpacings,
      lineHeights: dsTokens.lineHeights,
      radii: dsTokens.radii,
      semanticTextElements: semanticTextElements,
      shadows: dsTokens.shadows,
      space: space,
      spinnerSizes: spinnerSizes,
      textVariants: textVariants,
      timings: dsTokens.timings,
      transitions: dsTokens.transitions
    };

    // @ts-expect-error ts-migrate(7016) FIXME: Try `npm install @types/ramda` if it exists or add... Remove this comment to see the full error message
    var textVariants$1 = theme.textVariants,
        semanticTextElements$1 = theme.semanticTextElements;
    var textVariantsEnum = keys(textVariants$1);
    var semanticTextElementsEnum = keys(semanticTextElements$1);

    var useTextProps = function useTextProps(_a) {
      var variant = _a.variant,
          semanticElement = _a.semanticElement,
          props = _a.props,
          blacklistedTextProps = _a.blacklistedTextProps; // @ts-expect-error ts-migrate(2339) FIXME: Property 'textVariants' does not exist on type 'De... Remove this comment to see the full error message

      var textVariants = styled.useTheme().textVariants;
      var as = getAsProp({
        variant: variant,
        semanticElement: semanticElement
      }, {
        textVariants: textVariants
      });
      var propsToPass = omit(blacklistedTextProps, props);
      return __assign({
        variant: variant,
        as: as
      }, propsToPass);
    };

    var blacklistedTextProps = ['bg', 'backgroundColor', 'opacity'];

    var Text = function Text(_a) {
      var _b = _a.variant,
          variant = _b === void 0 ? 'copyMedium' : _b,
          semanticElement = _a.semanticElement,
          styleVariant = _a.styleVariant,
          children = _a.children,
          props = __rest(_a, ["variant", "semanticElement", "styleVariant", "children"]);

      var transformedTextProps = useTextProps({
        variant: variant,
        semanticElement: semanticElement,
        props: props,
        blacklistedTextProps: blacklistedTextProps
      });
      return /*#__PURE__*/React__default['default'].createElement(StyledText, __assign({}, transformedTextProps, {
        styleVariant: styleVariant
      }), children);
    };

    var sortArrayByOrderedArray = function sortArrayByOrderedArray(array, order, key) {
      array.sort(function (a, b) {
        var A = a[key];
        var B = b[key];
        return order.indexOf(A) > order.indexOf(B) ? 1 : -1;
      });
      return array;
    };

    var sortValuesByOrderedBreakpoints = function sortValuesByOrderedBreakpoints(breakpointsInOrder) {
      return function (pairsFromResponsiveObj) {
        return sortArrayByOrderedArray(pairsFromResponsiveObj, breakpointsInOrder, // We're assuming [key, value] pairs, so "0" is the breakpoint name
        '0');
      };
    };

    var removeDuplicateConsecutiveValues = function removeDuplicateConsecutiveValues(pairsWithoutDuplicates, currentPair) {
      var currVal = currentPair[1];
      var previousPair = last(pairsWithoutDuplicates);

      var _a = defaultTo([null, null], previousPair),
          prevVal = _a[1];

      return prevVal !== currVal ? __spreadArrays(pairsWithoutDuplicates, [currentPair]) : pairsWithoutDuplicates;
    };

    var removeDuplicateConsecutiveValuesPerBreakpoint = reduce(removeDuplicateConsecutiveValues, []);
    var breakpointsInOrder = ['zero', 'small', 'medium', 'large', 'xLarge', 'max'];
    var normalizeResponsivePropValues = pipe(toPairs, sortValuesByOrderedBreakpoints(breakpointsInOrder), removeDuplicateConsecutiveValuesPerBreakpoint, fromPairs);

    var invertStylePropertyAndBreakpointKey = function invertStylePropertyAndBreakpointKey(breakpointKey) {
      return function (acc, // @ts-expect-error ts-migrate(7031) FIXME: Binding element 'propertyKey' implicitly has an 'a... Remove this comment to see the full error message
      _a) {
        var _b;

        var propertyKey = _a[0],
            propertyValue = _a[1];
        return assoc(propertyKey, (_b = {}, _b[breakpointKey] = propertyValue, _b), acc);
      };
    };

    var invertStylesAndBreakpointKeys = function invertStylesAndBreakpointKeys(breakpointKey) {
      return pipe(toPairs, reduce(invertStylePropertyAndBreakpointKey(breakpointKey), {}));
    };

    var createPairOfObjects = function createPairOfObjects(finalObj) {
      return function (value, key) {
        return [finalObj[key], value];
      };
    }; // @ts-expect-error ts-migrate(7031) FIXME: Binding element 'one' implicitly has an 'any' type... Remove this comment to see the full error message


    var mergePairOfObjects = function mergePairOfObjects(_a) {
      var one = _a[0],
          two = _a[1];
      return mergeLeft(one, two);
    };

    var mergePairsOfObjects = map(mergePairOfObjects);
    /**
     * We start with { small: { display: 'block', flexBasis: '100%' } }
     * The end of the pipeline needs to have something like
     * { display: { small: 'block }, flexBasis: { small: '100%' } }
     */

    var prepareStylesForProps = function prepareStylesForProps(finalObj, // @ts-expect-error ts-migrate(7031) FIXME: Binding element 'breakpointKey' implicitly has an ... Remove this comment to see the full error message
    _a) {
      var breakpointKey = _a[0],
          styles = _a[1];
      var invertedObjectOfStylesAndBreakpointKeys = invertStylesAndBreakpointKeys(breakpointKey)(styles);
      var pairsToMerge = mapObjIndexed(createPairOfObjects(finalObj), invertedObjectOfStylesAndBreakpointKeys);
      return mergePairsOfObjects(pairsToMerge);
    };

    // @ts-expect-error ts-migrate(7016) FIXME: Try `npm install @types/ramda` if it exists or add... Remove this comment to see the full error message

    var ceilingPercentageTo100 = function ceilingPercentageTo100(rawPercentage) {
      return rawPercentage > 100 ? 100 : rawPercentage;
    };

    var safeCalcPercentage = function safeCalcPercentage(divisor) {
      return pipe(calcPercentage(divisor), stripUnit, ceilingPercentageTo100, appendUnit('%'));
    };

    function _typeof(obj) {
      "@babel/helpers - typeof";

      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function (obj) {
          return typeof obj;
        };
      } else {
        _typeof = function (obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }

      return _typeof(obj);
    }

    // @ts-expect-error ts-migrate(7016) FIXME: Try `npm install @types/ramda` if it exists or add... Remove this comment to see the full error message
    var getMetaColumns = path(['meta', 'columns']);

    var singleColumnInputToResponsiveTransform = function singleColumnInputToResponsiveTransform(breakpointsWithMeta) {
      return function (inputValue) {
        var sanitizedInput = parseInt(inputValue, 10); // get the percentage on large

        var numLargeColumns = path(['large', 'meta', 'columns'])(breakpointsWithMeta);
        var largePercentage = pipe(safeCalcPercentage(numLargeColumns), stripUnit)(sanitizedInput); // apply the percentage to every other bp

        var getColumnsPerBreakpoint = function getColumnsPerBreakpoint(breakpointWithMeta) {
          var columnsInBp = getMetaColumns(breakpointWithMeta);
          var roundedDownNumColumns = Math.floor(columnsInBp * largePercentage / 100); // Unless we're specifically choosing a '0' value, we should default to '1'

          if (sanitizedInput !== 0 && roundedDownNumColumns === 0) {
            return 1;
          }

          return roundedDownNumColumns;
        };

        return map(getColumnsPerBreakpoint)(breakpointsWithMeta);
      };
    };

    var sanitizeColumnPropsInput = function sanitizeColumnPropsInput(breakpointsWithMeta) {
      return function (propsInput) {
        var typeOfInput = _typeof(propsInput);

        if (Array.isArray(propsInput) || typeOfInput === 'object') {
          return propsInput;
        }

        if (typeOfInput === 'string' || typeOfInput === 'number') {
          return singleColumnInputToResponsiveTransform(breakpointsWithMeta)(propsInput);
        }
      };
    };

    var defaultColumnStyle = {
      display: 'block',
      flexGrow: 1,
      flexShrink: 0,
      flexBasis: 0,
      width: 'auto',
      maxWidth: '100%'
    };

    // @ts-expect-error ts-migrate(7016) FIXME: Try `npm install @types/ramda` if it exists or add... Remove this comment to see the full error message

    var buildStylesWithContext = function buildStylesWithContext(_a) {
      var breakpointsWithMeta = _a.breakpointsWithMeta,
          propsBuilder = _a.propsBuilder;
      return function (_a) {
        var breakpointKey = _a[0],
            breakpointValue = _a[1];
        var numColumns = path([breakpointKey, 'meta', 'columns'])(breakpointsWithMeta);
        var breakpointStyles = propsBuilder(numColumns)(breakpointValue);
        return [breakpointKey, breakpointStyles];
      };
    };

    var buildColumnPropsEpic = function buildColumnPropsEpic(_a) {
      var propsBuilder = _a.propsBuilder,
          breakpointsWithMeta = _a.breakpointsWithMeta;
      return pipe(sanitizeColumnPropsInput(breakpointsWithMeta), toPairs, map(buildStylesWithContext({
        breakpointsWithMeta: breakpointsWithMeta,
        propsBuilder: propsBuilder
      })), reduce(prepareStylesForProps, {}), map(normalizeResponsivePropValues));
    };

    var buildColumnProps = function buildColumnProps(propsBuilder) {
      return function (breakpointsWithMeta) {
        return function (propsInput) {
          if (hasValue(propsInput)) {
            return buildColumnPropsEpic({
              propsBuilder: propsBuilder,
              breakpointsWithMeta: breakpointsWithMeta
            })(propsInput);
          }
        };
      };
    };

    // @ts-expect-error ts-migrate(7016) FIXME: Try `npm install @types/ramda` if it exists or add... Remove this comment to see the full error message
    var autoSpanCondition = [equals('auto'), function () {
      return defaultColumnStyle;
    }];
    var hideColumnCondition = [anyPass([equals(0), equals('none')]), function () {
      return {
        display: 'none',
        flexGrow: 0,
        flexShrink: 0,
        flexBasis: 0,
        width: 0,
        maxWidth: 0
      };
    }];

    var specifiedSpanCondition = function specifiedSpanCondition(numColumns) {
      return [hasValue, function (span) {
        return {
          display: 'block',
          flexGrow: 0,
          flexShrink: 0,
          flexBasis: safeCalcPercentage(numColumns)(span),
          width: '100%',
          maxWidth: safeCalcPercentage(numColumns)(span)
        };
      }];
    };

    var defaultSpanCondition = [T, function () {
      return defaultColumnStyle;
    }];

    var buildSpanSpec = function buildSpanSpec(numColumns) {
      return cond([hideColumnCondition, autoSpanCondition, specifiedSpanCondition(numColumns), defaultSpanCondition]);
    };

    var buildSpansProps = buildColumnProps(buildSpanSpec);

    // @ts-expect-error ts-migrate(7016) FIXME: Try `npm install @types/ramda` if it exists or add... Remove this comment to see the full error message

    var specifiedOffsetCondition = function specifiedOffsetCondition(numColumns) {
      return [hasValue, function (offsetValue) {
        return {
          marginLeft: calcPercentage(numColumns)(offsetValue)
        };
      }];
    };

    var defaultOffsetCondition = [T, function () {
      return {
        marginLeft: 0
      };
    }];

    var buildOffsetSpec = function buildOffsetSpec(numColumns) {
      return cond([specifiedOffsetCondition(numColumns), defaultOffsetCondition]);
    };

    var buildOffsetsProps = buildColumnProps(buildOffsetSpec);

    // @ts-expect-error ts-migrate(7016) FIXME: Try `npm install @types/styled-system__theme-get` ... Remove this comment to see the full error message
    var defaultGutter = 32;
    var themeGetGutterHalf = themeGet('space.gutterHalf', defaultGutter / 2);

    // @ts-expect-error ts-migrate(7016) FIXME: Try `npm install @types/ramda` if it exists or add... Remove this comment to see the full error message
    var gridModes = {
      wide: 'wide',
      condensed: 'condensed'
    };
    var gridModesEnum = keys(gridModes);

    var GridContext = /*#__PURE__*/React__default['default'].createContext({
      debug: false,
      gridMode: gridModes.wide
    });

    var GridProvider = function GridProvider(_a) {
      var debug = _a.debug,
          _b = _a.gridMode,
          gridMode = _b === void 0 ? gridModes.wide : _b,
          children = _a.children;
      return /*#__PURE__*/React__default['default'].createElement(GridContext.Provider, {
        value: {
          debug: debug,
          gridMode: gridMode
        }
      }, children);
    };

    var useGridContext = function useGridContext() {
      return React.useContext(GridContext);
    };

    // @ts-expect-error ts-migrate(7016) FIXME: Try `npm install @types/ramda` if it exists or add... Remove this comment to see the full error message

    var responsiveOuterPadding = function responsiveOuterPadding(propsWithTheme) {
      var breakpointSpecs = themeGet('breakpointsWithMeta')(propsWithTheme);
      var themeGutter = themeGetGutterHalf(propsWithTheme);
      return pipe(pluck('meta'), pluck('outerPadding'), map(addTwoUnitValues(themeGutter)))(breakpointSpecs);
    };

    var defaultCondition = [T, responsiveOuterPadding];
    var getOuterGutterWidth = cond([[propEq('noOuterGutter', true), function () {
      return 0;
    }], defaultCondition]);

    var debugStyles = function debugStyles(props) {
      var debugColor = themeGet('colors.coral50')(props);
      return styled.css(templateObject_1$5 || (templateObject_1$5 = __makeTemplateObject(["\n    box-shadow: ", " 0 0 0 1px;\n  "], ["\n    box-shadow: ", " 0 0 0 1px;\n  "])), debugColor);
    };

    var StyledGrid = styled__default['default'](Box)(templateObject_2$4 || (templateObject_2$4 = __makeTemplateObject(["\n  ", ";\n"], ["\n  ", ";\n"])), function (_a) {
      var debug = _a.debug,
          props = __rest(_a, ["debug"]);

      return debug ? debugStyles(props) : '';
    });
    var templateObject_1$5, templateObject_2$4;

    var BaseGrid = function BaseGrid(_a) {
      var children = _a.children,
          props = __rest(_a, ["children"]);

      var gridContextValue = useGridContext();
      var debug = gridContextValue.debug,
          gridMode = gridContextValue.gridMode;
      var theme = styled.useTheme();
      var paddingX = getOuterGutterWidth(__assign(__assign({}, props), {
        theme: theme
      }));
      return /*#__PURE__*/React__default['default'].createElement(StyledGrid, __assign({
        marginX: "auto",
        paddingX: paddingX,
        debug: debug,
        gridMode: gridMode
      }, props), children);
    };

    var Grid = function Grid(_a) {
      var _b = _a.debug,
          debug = _b === void 0 ? false : _b,
          _c = _a.gridMode,
          gridMode = _c === void 0 ? 'wide' : _c,
          props = __rest(_a, ["debug", "gridMode"]);

      return /*#__PURE__*/React__default['default'].createElement(GridProvider, {
        debug: debug,
        gridMode: gridMode
      }, /*#__PURE__*/React__default['default'].createElement(BaseGrid, __assign({}, props)));
    };

    var StyledRow = styled__default['default'](Box)(templateObject_1$6 || (templateObject_1$6 = __makeTemplateObject([""], [""])));
    var templateObject_1$6;

    var _a$5;
    var marginByModesDictionary = (_a$5 = {}, _a$5[gridModes.wide] = '-gutterHalf', // TODO: https://roadmunk.atlassian.net/browse/DS-50 move value to theme
    _a$5[gridModes.condensed] = -2, _a$5);
    var Row = function Row(_a) {
      var children = _a.children,
          props = __rest(_a, ["children"]);

      var gridContextValue = useGridContext();
      var gridMode = gridContextValue.gridMode;
      var rowMargin = marginByModesDictionary[gridMode] || '-gutterHalf';
      return /*#__PURE__*/React__default['default'].createElement(StyledRow, __assign({
        gridMode: gridMode,
        display: "flex",
        flexWrap: "wrap",
        marginX: rowMargin
      }, props), children);
    };

    var debugStyles$1 = function debugStyles(props) {
      return styled.css(templateObject_1$7 || (templateObject_1$7 = __makeTemplateObject(["\n  background-color: ", ";\n  outline: 1px solid ", ";\n"], ["\n  background-color: ", ";\n  outline: 1px solid ", ";\n"])), themeGet('colors.blue20')(props), themeGet('colors.blue30')(props));
    };

    var StyledColumn = styled__default['default'](Box)(templateObject_2$5 || (templateObject_2$5 = __makeTemplateObject(["\n  ", ";\n  ", ";\n"], ["\n  ", ";\n  ", ";\n"])), applyStylesGivenProperty('applyDefaultStyle', defaultColumnStyle), function (_a) {
      var debug = _a.debug,
          props = __rest(_a, ["debug"]);

      return debug ? debugStyles$1(props) : '';
    });
    var templateObject_1$7, templateObject_2$5;

    var _a$6;
    var paddingByModesDictionary = (_a$6 = {}, _a$6[gridModes.wide] = 'gutterHalf', // TODO: https://roadmunk.atlassian.net/browse/DS-50 move value to theme
    _a$6[gridModes.condensed] = 1, _a$6);
    var Column = function Column(_a) {
      var children = _a.children,
          spans = _a.spans,
          offsets = _a.offsets,
          props = __rest(_a, ["children", "spans", "offsets"]);

      var gridContextValue = useGridContext();
      var debug = gridContextValue.debug,
          gridMode = gridContextValue.gridMode; // @ts-expect-error ts-migrate(2339) FIXME: Property 'breakpointsWithMeta' does not exist on t... Remove this comment to see the full error message

      var breakpointsWithMeta = styled.useTheme().breakpointsWithMeta;
      var columnPadding = paddingByModesDictionary[gridMode] || 'gutterHalf';
      var propsBuiltFromSpans = buildSpansProps(breakpointsWithMeta)(spans);
      var propsBuiltFromOffsets = buildOffsetsProps(breakpointsWithMeta)(offsets);
      return /*#__PURE__*/React__default['default'].createElement(StyledColumn, __assign({
        debug: debug,
        gridMode: gridMode,
        display: "block",
        applyDefaultStyle: propsBuiltFromSpans === undefined,
        paddingX: columnPadding
      }, propsBuiltFromSpans, propsBuiltFromOffsets, props), children);
    };

    var variantStylesDictionary = {
      light: {
        borderColor: 'blue50',
        boxShadowColor: 'blue10'
      },
      blue: {
        borderColor: 'blue70',
        boxShadowColor: 'blue10'
      },
      dark: {
        borderColor: 'sand10',
        boxShadowColor: 'midnight30'
      }
    };
    var crossBrowserFocusRingReset = styled.css(templateObject_1$8 || (templateObject_1$8 = __makeTemplateObject(["\n  outline: none;\n"], ["\n  outline: none;\n"])));
    /**
     * Applies focus styling to a styled component given some props. The component
     * which will receive the focus needs to have a border, even if the border is
     * the same as the background, or its color is transparent, it still needs to
     * exist.
     * @param props {Object}: should include `focusRingVariant` which is one of:
     * ['light', 'blue', 'dark']
     * @example
     * // in the Styled Component usage:
     * <StyledFoo
     *   border="1px solid black"
     *   focusRingVariant="light"
     *   transition="normal"
     *   transitionProperty="border-color, box-shadow"
     * />
     *
     * // in the definition:
     * const StyledFoo = styled.div`
     *   ${border};
     *   ${transition};
     *   ${transitionProperty};
     *   ${focusRing};
     * `
     */

    var focusRing = function focusRing(_a) {
      var _b = _a.focusRingVariant,
          variant = _b === void 0 ? 'light' : _b;
      var _c = variantStylesDictionary[variant],
          borderColor = _c.borderColor,
          boxShadowColor = _c.boxShadowColor;
      return styled.css(templateObject_2$6 || (templateObject_2$6 = __makeTemplateObject(["\n    ", ";\n\n    &:not(:active):focus {\n      border-color: ", ";\n      box-shadow: 0 0 0 4px ", ";\n    }\n  "], ["\n    ", ";\n\n    &:not(:active):focus {\n      border-color: ", ";\n      box-shadow: 0 0 0 4px ", ";\n    }\n  "])), crossBrowserFocusRingReset, themeGet("colors." + borderColor), themeGet("colors." + boxShadowColor));
    };
    var templateObject_1$8, templateObject_2$6;

    var buttonVariantStyles = variant({
      prop: 'variant',
      scale: 'buttonVariants'
    });
    var buttonSizeStyles = variant({
      prop: 'size',
      scale: 'buttonSizes'
    });
    var StyledButton = styled__default['default'].button(templateObject_1$9 || (templateObject_1$9 = __makeTemplateObject(["\n  position: relative;\n  cursor: pointer;\n  ", " {\n    display: block;\n  }\n  ", ";\n  ", ";\n  ", ";\n\n  ", ";\n  ", ";\n  ", ";\n  &:disabled {\n    cursor: not-allowed;\n    box-shadow: none;\n  }\n"], ["\n  position: relative;\n  cursor: pointer;\n  ", " {\n    display: block;\n  }\n  ", ";\n  ", ";\n  ", ";\n\n  ", ";\n  ", ";\n  ", ";\n  &:disabled {\n    cursor: not-allowed;\n    box-shadow: none;\n  }\n"])), StyledText, styledSystem.border, transition, transitionProperty, buttonVariantStyles, buttonSizeStyles, function (props) {
      return focusRing({
        focusRingVariant: props.focusRingVariant
      });
    });
    var templateObject_1$9;

    var buttonVariantToFocusVariantDictionary = {
      solidBlue: 'blue',
      solidAlt: 'light',
      outlineBlue: 'light',
      outlineAlt: 'light',
      outlineInverse: 'dark',
      ghostBlue: 'light',
      ghostAlt: 'light',
      ghostInverse: 'dark'
    };

    var getFocusRingVariant = function getFocusRingVariant(variant) {
      // @ts-expect-error ts-migrate(7053) FIXME: Element implicitly has an 'any' type because expre... Remove this comment to see the full error message
      return buttonVariantToFocusVariantDictionary[variant] || 'light';
    };

    var Button = function Button(_a) {
      var children = _a.children,
          onClick = _a.onClick,
          _b = _a.variant,
          variant = _b === void 0 ? 'solidBlue' : _b,
          _c = _a.size,
          size = _c === void 0 ? 'medium' : _c,
          _d = _a.disabled,
          disabled = _d === void 0 ? false : _d,
          props = __rest(_a, ["children", "onClick", "variant", "size", "disabled"]);

      var focusRingVariant = getFocusRingVariant(variant);
      return /*#__PURE__*/React__default['default'].createElement(StyledButton, __assign({
        onClick: onClick,
        variant: variant,
        size: size,
        border: "normal",
        borderRadius: "small",
        transitionProperty: "background-color, border-color, box-shadow, color",
        transition: "normal",
        focusRingVariant: focusRingVariant,
        disabled: disabled
      }, props), /*#__PURE__*/React__default['default'].createElement(Text, null, children));
    };

    var shouldGroupRight = function shouldGroupRight(_a) {
      var childIndex = _a.childIndex,
          groupRightAt = _a.groupRightAt;

      if (groupRightAt === null) {
        return false;
      }

      var sanitizedGroupRightAt = parseInt(groupRightAt, 10);
      return childIndex === sanitizedGroupRightAt;
    };

    var buttonWrapperPaddingUnit = 'spacing.2xSmall';

    var ButtonWrapper = function ButtonWrapper(props) {
      return /*#__PURE__*/React__default['default'].createElement(Box, __assign({
        paddingX: buttonWrapperPaddingUnit
      }, props));
    };

    var ButtonGroup = function ButtonGroup(_a) {
      var children = _a.children,
          groupRightAt = _a.groupRightAt,
          props = __rest(_a, ["children", "groupRightAt"]);

      return /*#__PURE__*/React__default['default'].createElement(Box, __assign({
        marginX: "-" + buttonWrapperPaddingUnit,
        display: "flex"
      }, props), React__default['default'].Children.toArray(children).map(function (child, childIndex) {
        var buttonWrapperMarginLeft = shouldGroupRight({
          groupRightAt: groupRightAt,
          childIndex: childIndex
        }) ? 'auto' : null;
        return /*#__PURE__*/React__default['default'].createElement(ButtonWrapper // @ts-expect-error ts-migrate(2339) FIXME: Property 'key' does not exist on type 'string'.
        , {
          // @ts-expect-error ts-migrate(2339) FIXME: Property 'key' does not exist on type 'string'.
          key: "ButtonWrapper" + child.key,
          marginLeft: buttonWrapperMarginLeft
        }, child);
      }));
    };

    var hiddenStyles = styled.css(templateObject_1$a || (templateObject_1$a = __makeTemplateObject(["\n  border: 0;\n  clip: rect(0 0 0 0);\n  height: 1px;\n  margin: -1px;\n  overflow: hidden;\n  padding: 0;\n  position: absolute;\n  width: 1px;\n"], ["\n  border: 0;\n  clip: rect(0 0 0 0);\n  height: 1px;\n  margin: -1px;\n  overflow: hidden;\n  padding: 0;\n  position: absolute;\n  width: 1px;\n"])));
    var templateObject_1$a;

    var HiddenInput = styled__default['default'].input(templateObject_1$b || (templateObject_1$b = __makeTemplateObject(["\n  ", "\n"], ["\n  ", "\n"])), hiddenStyles);

    var LabelText = function LabelText(props) {
      return /*#__PURE__*/React__default['default'].createElement(Text, __assign({
        variant: "copyMedium",
        semanticElement: "span"
      }, props));
    };
    var templateObject_1$b;

    var borderColors = {
      idle: 'sand60',
      hover: 'sand70',
      error: 'rose50',
      focus: 'blue50',
      selected: 'blue50'
    };

    var getBorderColor = function getBorderColor(inputState) {
      // @ts-expect-error ts-migrate(7053) FIXME: Element implicitly has an 'any' type because expre... Remove this comment to see the full error message
      return borderColors[inputState] || borderColors.idle;
    };

    var inputBorderColor = function inputBorderColor(inputState) {
      return styled.css(templateObject_1$c || (templateObject_1$c = __makeTemplateObject(["\n  border-color: ", ";\n"], ["\n  border-color: ", ";\n"])), themeGet("colors." + getBorderColor(inputState)));
    }; // These Styles are being copied rather than imported from focusRing due to a current limitation
    // This will need to be updated once the focusRing has been modified: https://roadmunk.atlassian.net/browse/DS-394


    var focusStyles = styled.css(templateObject_2$7 || (templateObject_2$7 = __makeTemplateObject(["\n  outline: none;\n  ", ";\n  box-shadow: 0 0 0 4px ", ";\n"], ["\n  outline: none;\n  ", ";\n  box-shadow: 0 0 0 4px ", ";\n"])), inputBorderColor('focus'), themeGet('colors.blue10'));
    var templateObject_1$c, templateObject_2$7;

    var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

    /** Detect free variable `global` from Node.js. */
    var freeGlobal = typeof commonjsGlobal == 'object' && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;

    var _freeGlobal = freeGlobal;

    /** Detect free variable `self`. */
    var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

    /** Used as a reference to the global object. */
    var root = _freeGlobal || freeSelf || Function('return this')();

    var _root = root;

    /** Built-in value references. */
    var Symbol$1 = _root.Symbol;

    var _Symbol = Symbol$1;

    /**
     * A specialized version of `_.map` for arrays without support for iteratee
     * shorthands.
     *
     * @private
     * @param {Array} [array] The array to iterate over.
     * @param {Function} iteratee The function invoked per iteration.
     * @returns {Array} Returns the new mapped array.
     */
    function arrayMap(array, iteratee) {
      var index = -1,
          length = array == null ? 0 : array.length,
          result = Array(length);

      while (++index < length) {
        result[index] = iteratee(array[index], index, array);
      }
      return result;
    }

    var _arrayMap = arrayMap;

    /**
     * Checks if `value` is classified as an `Array` object.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is an array, else `false`.
     * @example
     *
     * _.isArray([1, 2, 3]);
     * // => true
     *
     * _.isArray(document.body.children);
     * // => false
     *
     * _.isArray('abc');
     * // => false
     *
     * _.isArray(_.noop);
     * // => false
     */
    var isArray = Array.isArray;

    var isArray_1 = isArray;

    /** Used for built-in method references. */
    var objectProto = Object.prototype;

    /** Used to check objects for own properties. */
    var hasOwnProperty$1 = objectProto.hasOwnProperty;

    /**
     * Used to resolve the
     * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
     * of values.
     */
    var nativeObjectToString = objectProto.toString;

    /** Built-in value references. */
    var symToStringTag = _Symbol ? _Symbol.toStringTag : undefined;

    /**
     * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
     *
     * @private
     * @param {*} value The value to query.
     * @returns {string} Returns the raw `toStringTag`.
     */
    function getRawTag(value) {
      var isOwn = hasOwnProperty$1.call(value, symToStringTag),
          tag = value[symToStringTag];

      try {
        value[symToStringTag] = undefined;
        var unmasked = true;
      } catch (e) {}

      var result = nativeObjectToString.call(value);
      if (unmasked) {
        if (isOwn) {
          value[symToStringTag] = tag;
        } else {
          delete value[symToStringTag];
        }
      }
      return result;
    }

    var _getRawTag = getRawTag;

    /** Used for built-in method references. */
    var objectProto$1 = Object.prototype;

    /**
     * Used to resolve the
     * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
     * of values.
     */
    var nativeObjectToString$1 = objectProto$1.toString;

    /**
     * Converts `value` to a string using `Object.prototype.toString`.
     *
     * @private
     * @param {*} value The value to convert.
     * @returns {string} Returns the converted string.
     */
    function objectToString(value) {
      return nativeObjectToString$1.call(value);
    }

    var _objectToString = objectToString;

    /** `Object#toString` result references. */
    var nullTag = '[object Null]',
        undefinedTag = '[object Undefined]';

    /** Built-in value references. */
    var symToStringTag$1 = _Symbol ? _Symbol.toStringTag : undefined;

    /**
     * The base implementation of `getTag` without fallbacks for buggy environments.
     *
     * @private
     * @param {*} value The value to query.
     * @returns {string} Returns the `toStringTag`.
     */
    function baseGetTag(value) {
      if (value == null) {
        return value === undefined ? undefinedTag : nullTag;
      }
      return (symToStringTag$1 && symToStringTag$1 in Object(value))
        ? _getRawTag(value)
        : _objectToString(value);
    }

    var _baseGetTag = baseGetTag;

    /**
     * Checks if `value` is object-like. A value is object-like if it's not `null`
     * and has a `typeof` result of "object".
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
     * @example
     *
     * _.isObjectLike({});
     * // => true
     *
     * _.isObjectLike([1, 2, 3]);
     * // => true
     *
     * _.isObjectLike(_.noop);
     * // => false
     *
     * _.isObjectLike(null);
     * // => false
     */
    function isObjectLike(value) {
      return value != null && typeof value == 'object';
    }

    var isObjectLike_1 = isObjectLike;

    /** `Object#toString` result references. */
    var symbolTag = '[object Symbol]';

    /**
     * Checks if `value` is classified as a `Symbol` primitive or object.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
     * @example
     *
     * _.isSymbol(Symbol.iterator);
     * // => true
     *
     * _.isSymbol('abc');
     * // => false
     */
    function isSymbol(value) {
      return typeof value == 'symbol' ||
        (isObjectLike_1(value) && _baseGetTag(value) == symbolTag);
    }

    var isSymbol_1 = isSymbol;

    /** Used as references for various `Number` constants. */
    var INFINITY = 1 / 0;

    /** Used to convert symbols to primitives and strings. */
    var symbolProto = _Symbol ? _Symbol.prototype : undefined,
        symbolToString = symbolProto ? symbolProto.toString : undefined;

    /**
     * The base implementation of `_.toString` which doesn't convert nullish
     * values to empty strings.
     *
     * @private
     * @param {*} value The value to process.
     * @returns {string} Returns the string.
     */
    function baseToString(value) {
      // Exit early for strings to avoid a performance hit in some environments.
      if (typeof value == 'string') {
        return value;
      }
      if (isArray_1(value)) {
        // Recursively convert values (susceptible to call stack limits).
        return _arrayMap(value, baseToString) + '';
      }
      if (isSymbol_1(value)) {
        return symbolToString ? symbolToString.call(value) : '';
      }
      var result = (value + '');
      return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
    }

    var _baseToString = baseToString;

    /**
     * Converts `value` to a string. An empty string is returned for `null`
     * and `undefined` values. The sign of `-0` is preserved.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to convert.
     * @returns {string} Returns the converted string.
     * @example
     *
     * _.toString(null);
     * // => ''
     *
     * _.toString(-0);
     * // => '-0'
     *
     * _.toString([1, 2, 3]);
     * // => '1,2,3'
     */
    function toString$2(value) {
      return value == null ? '' : _baseToString(value);
    }

    var toString_1 = toString$2;

    /** Used to generate unique IDs. */
    var idCounter = 0;

    /**
     * Generates a unique ID. If `prefix` is given, the ID is appended to it.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Util
     * @param {string} [prefix=''] The value to prefix the ID with.
     * @returns {string} Returns the unique ID.
     * @example
     *
     * _.uniqueId('contact_');
     * // => 'contact_104'
     *
     * _.uniqueId();
     * // => '105'
     */
    function uniqueId(prefix) {
      var id = ++idCounter;
      return toString_1(prefix) + id;
    }

    var uniqueId_1 = uniqueId;

    var useCheckboxInputProps = function useCheckboxInputProps(_a) {
      var explicitDescribedBy = _a.explicitDescribedBy,
          explicitLabelledBy = _a.explicitLabelledBy,
          explicitId = _a.explicitId,
          isFocused = _a.isFocused;
      var id = React.useRef(explicitId || uniqueId_1('CheckboxInput')).current;
      var inputRef = React.useRef(null);
      React.useEffect(function () {
        cond([[either(propIsNil('isFocused'), propIsNil('input')), noop], [propEq('isFocused', true), function (_a) {
          var input = _a.input;
          return input.focus();
        }], [propEq('isFocused', false), function (_a) {
          var input = _a.input;
          return input.blur();
        }]])({
          isFocused: isFocused,
          input: inputRef.current
        });
      }, [isFocused, inputRef]);
      var labelId = id + "Label";

      var allLabelledByLabelIds = __spreadArrays(explicitLabelledBy, [labelId]);

      var describedBy = toStringWithSpaces(explicitDescribedBy);
      var labelledBy = toStringWithSpaces(allLabelledByLabelIds);
      return {
        describedBy: describedBy,
        id: id,
        inputRef: inputRef,
        labelId: labelId,
        labelledBy: labelledBy
      };
    };

    var StyledCheckboxInnerCheckWrapper = styled__default['default'](Box)(templateObject_1$d || (templateObject_1$d = __makeTemplateObject(["\n  ", ";\n  path {\n    transition: ", ";\n    transition-property: fill;\n\n    fill: ", ";\n  }\n"], ["\n  ", ";\n  path {\n    transition: ", ";\n    transition-property: fill;\n\n    fill: ", ";\n  }\n"])), positionAbsoluteCenter, themeGet('transitions.normal'), themeGet('colors.white'));

    var CheckboxIcon = function CheckboxIcon(_a) {
      var props = __rest(_a, []);

      return /*#__PURE__*/React__default['default'].createElement("svg", {
        width: "10",
        height: "8",
        viewBox: "0 0 10 8",
        fill: "none",
        xmlns: "http://www.w3.org/2000/svg"
      }, /*#__PURE__*/React__default['default'].createElement(Box, {
        as: "path",
        d: "M9.64425 1.24985L8.48092 0.0831784C8.46157 0.063777 8.43858 0.0483842 8.41327 0.0378815C8.38796 0.0273788 8.36082 0.0219727 8.33342 0.0219727C8.30602 0.0219727 8.27888 0.0273788 8.25357 0.0378815C8.22826 0.0483842 8.20527 0.063777 8.18592 0.0831784L3.27259 4.99985C3.25323 5.01925 3.23024 5.03464 3.20493 5.04514C3.17962 5.05564 3.15249 5.06105 3.12509 5.06105C3.09768 5.06105 3.07055 5.05564 3.04524 5.04514C3.01993 5.03464 2.99694 5.01925 2.97759 4.99985L1.81425 3.83318C1.7949 3.81378 1.77191 3.79838 1.7466 3.78788C1.72129 3.77738 1.69416 3.77197 1.66675 3.77197C1.63935 3.77197 1.61222 3.77738 1.58691 3.78788C1.56159 3.79838 1.5386 3.81378 1.51925 3.83318L0.355919 4.99985C0.316863 5.03891 0.294922 5.09189 0.294922 5.14714C0.294922 5.20238 0.316863 5.25536 0.355919 5.29443L2.97759 7.91651C2.99694 7.93591 3.01993 7.95131 3.04524 7.96181C3.07055 7.97231 3.09768 7.97772 3.12509 7.97772C3.15249 7.97772 3.17962 7.97231 3.20493 7.96181C3.23024 7.95131 3.25323 7.93591 3.27259 7.91651L9.64425 1.54151C9.68242 1.50257 9.70381 1.45021 9.70381 1.39568C9.70381 1.34115 9.68242 1.28879 9.64425 1.24985Z"
      }));
    };

    var StyledCheckboxCheck = styled__default['default'](Box)(templateObject_2$8 || (templateObject_2$8 = __makeTemplateObject([""], [""])));

    var CheckboxCheck = function CheckboxCheck(props) {
      return /*#__PURE__*/React__default['default'].createElement(StyledCheckboxCheck, __assign({
        flexShrink: "0",
        border: "normal",
        position: "relative",
        size: "18px",
        borderRadius: "small",
        transition: "normal",
        transitionProperty: "border-color box-shadow",
        backgroundColor: "white",
        marginRight: "spacing.small"
      }, props), /*#__PURE__*/React__default['default'].createElement(StyledCheckboxInnerCheckWrapper, {
        position: "absolute",
        transition: "normal",
        transitionProperty: "background-color",
        display: "flex",
        checked: props.checked
      }, /*#__PURE__*/React__default['default'].createElement(CheckboxIcon, null)));
    };

    var CheckboxLabel = styled__default['default'](Box)(templateObject_3$2 || (templateObject_3$2 = __makeTemplateObject(["\n  display: inline-flex;\n  cursor: pointer;\n\n  ", " {\n    ", ";\n  }\n  &:hover {\n    ", " {\n      ", ";\n    }\n  }\n  ", ":focus + ", ",\n  ", ":active + ", " {\n    ", ";\n  }\n  ", ":checked + ", " {\n    ", ";\n\n    ", " path {\n      fill: ", ";\n    }\n  }\n"], ["\n  display: inline-flex;\n  cursor: pointer;\n\n  ", " {\n    ", ";\n  }\n  &:hover {\n    ", " {\n      ", ";\n    }\n  }\n  ", ":focus + ", ",\n  ", ":active + ", " {\n    ", ";\n  }\n  ", ":checked + ", " {\n    ", ";\n\n    ", " path {\n      fill: ", ";\n    }\n  }\n"])), StyledCheckboxCheck, inputBorderColor('idle'), StyledCheckboxCheck, inputBorderColor('hover'), HiddenInput, StyledCheckboxCheck, HiddenInput, StyledCheckboxCheck, focusStyles, HiddenInput, StyledCheckboxCheck, inputBorderColor('selected'), StyledCheckboxInnerCheckWrapper, themeGet('colors.blue50'));
    var templateObject_1$d, templateObject_2$8, templateObject_3$2;

    var CheckboxInput = function CheckboxInput(_a) {
      var checked = _a.checked,
          _b = _a.describedBy,
          explicitDescribedBy = _b === void 0 ? [] : _b,
          explicitId = _a.id,
          isFocused = _a.isFocused,
          label = _a.label,
          _c = _a.labelledBy,
          explicitLabelledBy = _c === void 0 ? [] : _c,
          onBlur = _a.onBlur,
          onChange = _a.onChange,
          onFocus = _a.onFocus,
          props = __rest(_a, ["checked", "describedBy", "id", "isFocused", "label", "labelledBy", "onBlur", "onChange", "onFocus"]);

      var _d = useCheckboxInputProps({
        explicitDescribedBy: explicitDescribedBy,
        explicitLabelledBy: explicitLabelledBy,
        explicitId: explicitId,
        isFocused: isFocused
      }),
          describedBy = _d.describedBy,
          id = _d.id,
          inputRef = _d.inputRef,
          labelId = _d.labelId,
          labelledBy = _d.labelledBy;

      return /*#__PURE__*/React__default['default'].createElement(CheckboxLabel, {
        as: "label"
      }, /*#__PURE__*/React__default['default'].createElement(HiddenInput, __assign({
        "aria-describedby": describedBy,
        "aria-labelledby": labelledBy,
        as: "input",
        checked: checked,
        id: id,
        onBlur: onBlur,
        onChange: onChange,
        onFocus: onFocus,
        ref: inputRef,
        type: "checkbox"
      }, props)), /*#__PURE__*/React__default['default'].createElement(CheckboxCheck, {
        checked: checked
      }), /*#__PURE__*/React__default['default'].createElement(LabelText, {
        id: labelId
      }, label));
    };

    var useRadioInputProps = function useRadioInputProps(_a) {
      var explicitDescribedBy = _a.explicitDescribedBy,
          explicitLabelledBy = _a.explicitLabelledBy,
          explicitId = _a.explicitId,
          isFocused = _a.isFocused;
      var id = React.useRef(explicitId || uniqueId_1('RadioInput')).current;
      var inputRef = React.useRef(null);
      React.useEffect(function () {
        cond([[either(propIsNil('isFocused'), propIsNil('input')), noop], [propEq('isFocused', true), function (_a) {
          var input = _a.input;
          return input.focus();
        }], [propEq('isFocused', false), function (_a) {
          var input = _a.input;
          return input.blur();
        }]])({
          isFocused: isFocused,
          input: inputRef.current
        });
      }, [isFocused, inputRef]);
      var labelId = id + "Label";

      var allLabelledByLabelIds = __spreadArrays(explicitLabelledBy, [labelId]);

      var describedBy = toStringWithSpaces(explicitDescribedBy);
      var labelledBy = toStringWithSpaces(allLabelledByLabelIds);
      return {
        describedBy: describedBy,
        id: id,
        inputRef: inputRef,
        labelId: labelId,
        labelledBy: labelledBy
      };
    };

    /* 4px including 1 pixel for the border */

    var StyledRadioInnerCircle = styled__default['default'](Box)(templateObject_1$e || (templateObject_1$e = __makeTemplateObject(["\n  ", ";\n"], ["\n  ", ";\n"])), topBottomLeftRight('3px'));
    var StyledRadioCircle = styled__default['default'](Box)(templateObject_2$9 || (templateObject_2$9 = __makeTemplateObject([""], [""])));

    var RadioCircle = function RadioCircle(props) {
      return /*#__PURE__*/React__default['default'].createElement(StyledRadioCircle, __assign({
        border: "normal",
        position: "relative",
        size: "18px",
        borderRadius: "50%",
        transition: "normal",
        transitionProperty: "border-color box-shadow",
        backgroundColor: "white",
        marginRight: "spacing.small"
      }, props), /*#__PURE__*/React__default['default'].createElement(StyledRadioInnerCircle, {
        position: "absolute",
        borderRadius: "50%",
        transition: "normal",
        transitionProperty: "background-color"
      }));
    };

    var RadioLabel = styled__default['default'](Box)(templateObject_3$3 || (templateObject_3$3 = __makeTemplateObject(["\n  display: inline-flex;\n  cursor: pointer;\n\n  ", " {\n    ", ";\n  }\n  &:hover {\n    ", " {\n      ", ";\n    }\n  }\n  ", ":focus + ", ",\n  ", ":active + ", " {\n    ", ";\n  }\n  ", ":checked + ", " {\n    ", ";\n\n    ", " {\n      background-color: ", ";\n    }\n  }\n"], ["\n  display: inline-flex;\n  cursor: pointer;\n\n  ", " {\n    ", ";\n  }\n  &:hover {\n    ", " {\n      ", ";\n    }\n  }\n  ", ":focus + ", ",\n  ", ":active + ", " {\n    ", ";\n  }\n  ", ":checked + ", " {\n    ", ";\n\n    ", " {\n      background-color: ", ";\n    }\n  }\n"])), StyledRadioCircle, inputBorderColor('idle'), StyledRadioCircle, inputBorderColor('hover'), HiddenInput, StyledRadioCircle, HiddenInput, StyledRadioCircle, focusStyles, HiddenInput, StyledRadioCircle, inputBorderColor('selected'), StyledRadioInnerCircle, themeGet('colors.blue50'));
    var templateObject_1$e, templateObject_2$9, templateObject_3$3;

    var RadioInput = function RadioInput(_a) {
      var checked = _a.checked,
          _b = _a.describedBy,
          explicitDescribedBy = _b === void 0 ? [] : _b,
          explicitId = _a.id,
          isFocused = _a.isFocused,
          label = _a.label,
          _c = _a.labelledBy,
          explicitLabelledBy = _c === void 0 ? [] : _c,
          onBlur = _a.onBlur,
          onChange = _a.onChange,
          onFocus = _a.onFocus,
          props = __rest(_a, ["checked", "describedBy", "id", "isFocused", "label", "labelledBy", "onBlur", "onChange", "onFocus"]);

      var _d = useRadioInputProps({
        explicitDescribedBy: explicitDescribedBy,
        explicitLabelledBy: explicitLabelledBy,
        explicitId: explicitId,
        isFocused: isFocused
      }),
          describedBy = _d.describedBy,
          id = _d.id,
          inputRef = _d.inputRef,
          labelId = _d.labelId,
          labelledBy = _d.labelledBy;

      return /*#__PURE__*/React__default['default'].createElement(RadioLabel, {
        as: "label"
      }, /*#__PURE__*/React__default['default'].createElement(HiddenInput, __assign({
        "aria-describedby": describedBy,
        "aria-labelledby": labelledBy,
        as: "input",
        checked: checked,
        id: id,
        onBlur: onBlur,
        onChange: onChange,
        onFocus: onFocus,
        ref: inputRef,
        type: "radio"
      }, props)), /*#__PURE__*/React__default['default'].createElement(RadioCircle, {
        checked: checked
      }), /*#__PURE__*/React__default['default'].createElement(LabelText, {
        id: labelId
      }, label));
    };

    var ErrorText = function ErrorText(_a) {
      var id = _a.id,
          error = _a.error;
      return /*#__PURE__*/React__default['default'].createElement(Box, {
        id: id,
        marginTop: "6px"
      }, /*#__PURE__*/React__default['default'].createElement(Text, {
        styleVariant: "error",
        variant: "copyXS",
        lineHeight: "normal"
      }, error));
    };

    var getDescribedBy = function getDescribedBy(_a) {
      var explicitDescribedBy = _a.explicitDescribedBy,
          hasError = _a.hasError,
          id = _a.id; // TO DO: https://roadmunk.atlassian.net/browse/DS-358 add helper text to the describedby array

      var describedBy = __spreadArrays(explicitDescribedBy);

      if (hasError) {
        describedBy.unshift(id + "Error");
      }

      return describedBy.join(' ');
    };

    var useTextInputProps = function useTextInputProps(_a) {
      var error = _a.error,
          explicitDescribedBy = _a.explicitDescribedBy,
          explicitId = _a.explicitId,
          isFocused = _a.isFocused,
          onChange = _a.onChange;
      var id = React.useState(explicitId || uniqueId_1('TextInput'))[0];

      var _b = React.useState(Boolean(isFocused)),
          inputFocus = _b[0],
          setInputFocus = _b[1];

      var inputRef = React.useRef(null);
      var hasError = Boolean(error);
      var labelId = id + "Label";
      React.useEffect(function () {
        cond([[either(propIsNil('isFocused'), propIsNil('input')), noop], [propEq('isFocused', true), function (_a) {
          var input = _a.input;
          return input.focus();
        }], [propEq('isFocused', false), function (_a) {
          var input = _a.input;
          return input.blur();
        }]])({
          isFocused: isFocused,
          input: inputRef.current
        });
      }, [isFocused, inputRef]);

      var handleInputFocus = function handleInputFocus() {
        return setInputFocus(true);
      };

      var handleClick = function handleClick() {
        if (inputRef && inputRef.current) {
          // @ts-expect-error ts-migrate(2531) FIXME: Object is possibly 'null'.
          inputRef.current.focus();
        }
      };

      var handleInputBlur = function handleInputBlur() {
        return setInputFocus(false);
      };

      var handleChange = function handleChange(event) {
        return onChange && onChange(event.currentTarget.value);
      };

      var describedBy = getDescribedBy({
        explicitDescribedBy: explicitDescribedBy,
        hasError: hasError,
        id: id
      });
      var labelledBy = labelId;
      return {
        describedBy: describedBy,
        handleChange: handleChange,
        handleClick: handleClick,
        handleInputBlur: handleInputBlur,
        handleInputFocus: handleInputFocus,
        hasError: hasError,
        inputFocus: inputFocus,
        inputRef: inputRef,
        id: id,
        labelId: labelId,
        labelledBy: labelledBy
      };
    };

    var StyledLabel = styled__default['default'](Box)(templateObject_1$f || (templateObject_1$f = __makeTemplateObject(["\n  /* The input should get click events, even though we're super-imposing the\n  label over it */\n  pointer-events: none;\n  display: block;\n  ", ";\n  color: ", ";\n  line-height: 100%;\n  ", ";\n"], ["\n  /* The input should get click events, even though we're super-imposing the\n  label over it */\n  pointer-events: none;\n  display: block;\n  ", ";\n  color: ", ";\n  line-height: 100%;\n  ", ";\n"])), textVariantFunction('copySmall'), themeGet('colors.black80'), applyStylesGivenProperty('hideLabel', hiddenStyles));
    var sharedInputTextStyles = styled.css(templateObject_2$a || (templateObject_2$a = __makeTemplateObject(["\n  ", ";\n  line-height: 22px;\n"], ["\n  ", ";\n  line-height: 22px;\n"])), textVariantFunction('copyMedium'));
    var placeholderStyles = styled.css(templateObject_3$4 || (templateObject_3$4 = __makeTemplateObject(["\n  &::placeholder {\n    ", ";\n    color: ", ";\n  }\n"], ["\n  &::placeholder {\n    ", ";\n    color: ", ";\n  }\n"])), sharedInputTextStyles, themeGet('colors.black70'));
    var StyledTextInput = styled__default['default'].input(templateObject_4$2 || (templateObject_4$2 = __makeTemplateObject(["\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n\n  ", ";\n  ", ";\n  padding: 6px 11px;\n  ", ";\n"], ["\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n\n  ", ";\n  ", ";\n  padding: 6px 11px;\n  ", ";\n"])), styledSystem.color, styledSystem.border, transition, transitionProperty, placeholderStyles, sharedInputTextStyles, focusRing);
    var StyledWrapper = styled__default['default'](Box)(templateObject_5$1 || (templateObject_5$1 = __makeTemplateObject(["\n  ", ":not(:focus) {\n    ", ";\n    ", ";\n  }\n  &:hover:not(:focus) {\n    ", ":not(:focus) {\n      ", ";\n    }\n  }\n"], ["\n  ", ":not(:focus) {\n    ", ";\n    ", ";\n  }\n  &:hover:not(:focus) {\n    ", ":not(:focus) {\n      ", ";\n    }\n  }\n"])), StyledTextInput, inputBorderColor('idle'), applyStylesGivenProperty('hasError', inputBorderColor('error')), StyledTextInput, inputBorderColor('hover'));
    var templateObject_1$f, templateObject_2$a, templateObject_3$4, templateObject_4$2, templateObject_5$1;

    var TextInput = function TextInput(_a) {
      var _b = _a.describedBy,
          explicitDescribedBy = _b === void 0 ? [] : _b,
          _c = _a.error,
          error = _c === void 0 ? null : _c,
          _d = _a.hideLabel,
          hideLabel = _d === void 0 ? false : _d,
          explicitId = _a.id,
          isFocused = _a.isFocused,
          _e = _a.label,
          label = _e === void 0 ? 'Input Label' : _e,
          onBlur = _a.onBlur,
          _f = _a.onChange,
          onChange = _f === void 0 ? function (inputValue) {} : _f,
          onFocus = _a.onFocus,
          placeholder = _a.placeholder,
          inputValue = _a.value,
          props = __rest(_a, ["describedBy", "error", "hideLabel", "id", "isFocused", "label", "onBlur", "onChange", "onFocus", "placeholder", "value"]);

      var _g = useTextInputProps({
        error: error,
        explicitDescribedBy: explicitDescribedBy,
        explicitId: explicitId,
        isFocused: isFocused,
        onChange: onChange
      }),
          describedBy = _g.describedBy,
          handleChange = _g.handleChange,
          handleClick = _g.handleClick,
          handleInputBlur = _g.handleInputBlur,
          handleInputFocus = _g.handleInputFocus,
          hasError = _g.hasError,
          id = _g.id,
          inputFocus = _g.inputFocus,
          inputRef = _g.inputRef,
          labelId = _g.labelId,
          labelledBy = _g.labelledBy;

      return /*#__PURE__*/React__default['default'].createElement(StyledWrapper, {
        display: "flex",
        flexDirection: "column",
        hasError: hasError,
        onBlur: handleInputBlur,
        onClick: handleClick,
        onFocus: handleInputFocus
      }, /*#__PURE__*/React__default['default'].createElement(StyledLabel, {
        as: "label",
        hideLabel: hideLabel,
        htmlFor: id,
        id: labelId,
        marginBottom: "spacing.xSmall"
      }, label), /*#__PURE__*/React__default['default'].createElement(StyledTextInput, __assign({
        "aria-describedby": describedBy,
        "aria-invalid": hasError,
        "aria-labelledby": labelledBy,
        // @ts-expect-error ts-migrate(2769) FIXME: Property 'backgroundColor' does not exist on type ... Remove this comment to see the full error message
        backgroundColor: "white",
        border: "normal",
        borderRadius: "small",
        focus: inputFocus,
        focusRingVariant: "light",
        id: id,
        onBlur: onBlur,
        onChange: handleChange,
        onFocus: onFocus,
        placeholder: placeholder,
        ref: inputRef,
        transition: "normal",
        transitionProperty: "border-color, box-shadow",
        type: "text",
        value: inputValue
      }, props)), hasError && /*#__PURE__*/React__default['default'].createElement(ErrorText, {
        id: id + "Error",
        error: error
      }));
    };

    var StyledCard = styled__default['default'](Box)(templateObject_1$g || (templateObject_1$g = __makeTemplateObject([""], [""])));
    var templateObject_1$g;

    var Card = function Card(_a) {
      var children = _a.children,
          props = __rest(_a, ["children"]);

      return /*#__PURE__*/React__default['default'].createElement(StyledCard, __assign({
        background: "white",
        paddingY: "spacing.medium",
        paddingX: "spacing.large",
        borderRadius: "large",
        boxShadow: "small"
      }, props), children);
    };

    var getDashValueWithRadius = function getDashValueWithRadius(radius) {
      return function (length) {
        if (length === void 0) {
          length = 1;
        }

        var circumference = 2 * Math.PI * radius;
        return circumference * length;
      };
    };

    var getRadius = function getRadius(_a) {
      var diameter = _a.diameter,
          strokeWidth = _a.strokeWidth;
      return (diameter - strokeWidth) * 0.5;
    };

    var useSpinnerProps = function useSpinnerProps(_a) {
      var size = _a.size,
          delay = _a.delay;

      var _b = React.useState(false),
          showSpinner = _b[0],
          setShowSpinner = _b[1];

      React.useEffect(function () {
        setShowSpinner(false); // used to hide the spinner if the delay changes

        var timeout = setTimeout(function () {
          return setShowSpinner(true);
        }, delay);
        return function () {
          return clearTimeout(timeout);
        };
      }, [delay]); // @ts-expect-error ts-migrate(2339) FIXME: Property 'spinnerSizes' does not exist on type 'De... Remove this comment to see the full error message

      var spinnerSizes = styled.useTheme().spinnerSizes;
      var _c = spinnerSizes[size],
          width = _c.width,
          height = _c.height,
          _d = StyledSpinnerCircle,
          strokeWidth = _c[_d].strokeWidth;
      var rawWidth = stripUnit(width);
      var rawHeight = stripUnit(height);
      var rawStrokeWidth = stripUnit(strokeWidth);
      var rawRadius = getRadius({
        diameter: rawWidth,
        strokeWidth: rawStrokeWidth
      });
      return {
        width: rawWidth,
        height: rawHeight,
        radius: rawRadius,
        showSpinner: showSpinner
      };
    };

    var Spinner = function Spinner(_a) {
      var _b = _a.delay,
          delay = _b === void 0 ? 1000 : _b,
          _c = _a.size,
          size = _c === void 0 ? 'medium' : _c,
          props = __rest(_a, ["delay", "size"]);

      var _d = useSpinnerProps({
        size: size,
        delay: delay
      }),
          width = _d.width,
          height = _d.height,
          radius = _d.radius,
          showSpinner = _d.showSpinner;

      return showSpinner ?
      /*#__PURE__*/
      // @ts-expect-error ts-migrate(17004) FIXME: Cannot use JSX unless the '--jsx' flag is provided... Remove this comment to see the full error message
      React__default['default'].createElement(StyledSpinner, __assign({
        viewBox: "0 0 " + width + " " + height,
        size: size
      }, props), /*#__PURE__*/React__default['default'].createElement(StyledSpinnerCircle, {
        cx: "50%",
        cy: "50%",
        radius: radius,
        // @ts-expect-error ts-migrate(2769) FIXME: Property 'getDashValue' does not exist on type 'In... Remove this comment to see the full error message
        getDashValue: getDashValueWithRadius(radius)
      })) : null;
    };

    var InputGroupLabel = function InputGroupLabel(_a) {
      var children = _a.children,
          props = __rest(_a, ["children"]);

      return /*#__PURE__*/React__default['default'].createElement(Box, __assign({
        as: "legend"
      }, props), /*#__PURE__*/React__default['default'].createElement(Text, null, children));
    };

    var fieldsetReset = styled.css(templateObject_1$h || (templateObject_1$h = __makeTemplateObject(["\n  padding: 0;\n  border: none;\n"], ["\n  padding: 0;\n  border: none;\n"])));
    var StyledInputGroupWrapper = styled__default['default'](Box)(templateObject_2$b || (templateObject_2$b = __makeTemplateObject(["\n  ", ";\n"], ["\n  ", ";\n"])), fieldsetReset);
    var InputGroupWrapper = function InputGroupWrapper(props) {
      return /*#__PURE__*/React__default['default'].createElement(StyledInputGroupWrapper, __assign({
        as: "fieldset"
      }, props));
    };
    var templateObject_1$h, templateObject_2$b;

    var InputGroupLayout = function InputGroupLayout(_a) {
      var label = _a.label,
          children = _a.children,
          childrenWrapperProps = _a.childrenWrapperProps,
          props = __rest(_a, ["label", "children", "childrenWrapperProps"]);

      return /*#__PURE__*/React__default['default'].createElement(InputGroupWrapper, __assign({}, props), Boolean(label) && /*#__PURE__*/React__default['default'].createElement(InputGroupLabel, {
        marginBottom: "spacing.medium"
      }, label), /*#__PURE__*/React__default['default'].createElement(Box, __assign({
        display: "flex",
        marginX: "-spacing.medium"
      }, childrenWrapperProps), React__default['default'].Children.toArray(children).map(function (child) {
        return /*#__PURE__*/React__default['default'].createElement(Box //@ts-expect-error FIXME: Property 'key' does not exist on type
        , {
          //@ts-expect-error FIXME: Property 'key' does not exist on type
          key: "InputGroupChildWrapper" + child.key,
          paddingX: "spacing.medium"
        }, child);
      })));
    };

    var InputGroup = function InputGroup(_a) {
      var children = _a.children,
          label = _a.label,
          childrenWrapperProps = _a.childrenWrapperProps,
          props = __rest(_a, ["children", "label", "childrenWrapperProps"]);

      return /*#__PURE__*/React__default['default'].createElement(InputGroupLayout, __assign({
        label: label,
        children: children,
        childrenWrapperProps: childrenWrapperProps
      }, props));
    };

    exports.AppProvider = AppProvider;
    exports.Box = Box;
    exports.Button = Button;
    exports.ButtonGroup = ButtonGroup;
    exports.Card = Card;
    exports.CheckboxInput = CheckboxInput;
    exports.Column = Column;
    exports.Grid = Grid;
    exports.InputGroup = InputGroup;
    exports.RadioInput = RadioInput;
    exports.Row = Row;
    exports.Spinner = Spinner;
    exports.Text = Text;
    exports.TextInput = TextInput;
    exports.theme = theme;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
